!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

subroutine es_diffuse (ng)

use hyp_coms
use mem_met
use mem_grid
use mem_euler
use mem_scratch

implicit none

integer :: ng


integer :: ibcon,ia,iz,ja,jz,i0,j0,mxp,myp,mzp,iz1,jz1,ia_1,ja_1,n

ibcon=15
i0=0
j0=0
ia=2
iz=nnxh(ng)-1
ja=2
jz=nnyh(ng)-1
mxp=nnxh(ng)
myp=nnyh(ng)
mzp=nnzh(ng)

iz1=iz+1
jz1=jz+1
ia_1=ia-1
ja_1=ja-1

do n=1,nspecies
   call azero(mxp*myp,scr%scr11)
   
   call diffsclr (mzp,mxp,myp,mzp,mxp,myp,ia,iz,ja,jz,i0,j0  &
                 ,mxp*myp,ia_1,ja_1,eul(n,ng)%spec,scr%scr1  &
                 ,scr%scr2,scr%scr3,scr%scr4,scr%scr5  &
                 ,scr%scr6,scr%scr7,scr%scr8,scr%scr9  &
                 ,scr%scr10,grid(ng)%rtgt,scr%scr11  &
                 ,metc(ng)%khv,metc(ng)%khh,ng  &
                 ,nnsttop(ng),nnstbot(ng),n)

enddo

return
end

!***************************************************************************

subroutine diffsclr (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0,nh  &
                    ,ia_1,ja_1,scp,vt3da,vt3db,vt3df,vt3dg  &
                    ,vt3ej,vt3ek,vt3ept,vt3ec,vt3ef,vt3eg  &
                    ,rtgt,sfcflx,vkkh,hkkh,ng,itop,ibot,nspec)

use hyp_coms
use mem_grid

implicit none

integer :: n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0,nh,ia_1,ja_1  &
          ,ng,itop,ibot,nspec

real :: scp(m1,m2,m3),vt3da(m1,m2,m3),vt3db(m1,m2,m3)  &
    ,vt3df(m1,m2,m3),vt3dg(m1,m2,m3),vt3ej(nh,m1),vt3ek(nh,m1)  &
    ,vt3ec(nh,m1),vt3ef(nh,m1),vt3eg(nh,m1),vt3ept(nh,m1)  &
    ,vkkh(m1,m2,m3),hkkh(m1,m2,m3),sfcflx(m2,m3),rtgt(n2,n3)
real, save, dimension(maxk) :: vctr1

integer :: indh,i,j,k
real :: c1

call azero(maxk,vctr1)

! Compute vertical diffusion matrix coefficients for scalars

if(nspec.eq.1) then
   indh=0
   do j=ja,jz
      do i=ia,iz
         indh=indh+1
         do k=1,m1-1
            vctr1(k)=dzmh(k,ng)*(vkkh(k,i,j)+vkkh(k+1,i,j))
         enddo
         c1=0.5*dtpart/(rtgt(i+i0,j+j0)*rtgt(i+i0,j+j0))
         do k=2,m1-1
            vt3ej(indh,k)=-c1*dzth(k,ng)*vctr1(k-1)
            vt3ek(indh,k)=-c1*dzth(k,ng)*vctr1(k)
            vt3ept(indh,k)=1.0-vt3ej(indh,k)-vt3ek(indh,k)
         enddo
         vt3ej(indh,2)=0.
         if(ibot.eq.1)vt3ept(indh,2)=1.0-vt3ek(indh,2)
         vt3ek(indh,m1-1)=0.
         if(itop.eq.1)vt3ept(indh,m1-1)=1.0-vt3ej(indh,m1-1)
      enddo
   enddo
endif

! compute 2 horizontal scalar gradients needed for dscp/dt

call grad (n1,n2,n3,m1,m2,m3,ia_1,iz,ja,jz,i0,j0  &
          ,scp,vt3df,'xdir','tpnt',ng,'gradnt')

call grad (n1,n2,n3,m1,m2,m3,ia,iz,ja_1,jz,i0,j0  &
          ,scp,vt3dg,'ydir','tpnt',ng,'gradnt')

do j=ja_1,jz
   do i=ia_1,iz
      do k=1,m1-1
         vt3df(k,i,j)=-vt3df(k,i,j)*.5*(hkkh(k,i,j)+hkkh(k,i+1,j))
         vt3dg(k,i,j)=-vt3dg(k,i,j)*.5*(hkkh(k,i,j)+hkkh(k,i,j+1))
      enddo
   enddo
enddo

! horizontal flux divergence for scalars

call grad (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
          ,vt3df,vt3da,'xdir','upnt',ng,'divcrt')

call grad (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
          ,vt3dg,vt3db,'ydir','vpnt',ng,'divcrt')
          
! finish matrix coefficients

indh=0
do j=ja,jz
   do i=ia,iz
      indh=indh+1
      do k=2,m1-1
         vt3ec(indh,k)=scp(k,i,j)
      enddo
   enddo
enddo

if(ibot.eq.1) then
   indh=0
   do j=ja,jz
      do i=ia,iz
         indh=indh+1
         vt3ec(indh,2)=scp(2,i,j)+sfcflx(i,j)  &
              *dtpart*dzth(2,ng)/rtgt(i,j)
      enddo
   enddo
else
   indh=0
   do j=ja,jz
      do i=ia,iz
         indh=indh+1
         vt3ec(indh,2)=scp(2,i,j)  &
              +.5*dtpart*(vkkh(1,i,j)+vkkh(2,i,j))  &
              *scp(1,i,j)*dzmh(2,ng)*dzth(2,ng)/rtgt(i,j)**2
      enddo
   enddo
endif

if(itop.eq.0) then
   indh=0
   do j=ja,jz
      do i=ia,iz
         indh=indh+1
         vt3ec(indh,m1-1)=scp(m1-1,i,j)  &
              -.5*dtpart*(vkkh(m1-1,i,j)+vkkh(m1,i,j))  &
              *scp(m1,i,j)*dzmh(m1-1,ng)*dzth(m1,ng)/rtgt(i,j)**2
      enddo
   enddo
endif


call tridiff(nh,m1-1,indh,vt3ej,vt3ept,vt3ek,vt3ec,vt3ef,vt3eg)

indh=0
do j=ja,jz
   do i=ia,iz
      indh=indh+1
      do k=2,m1-1
         scp(k,i,j)=vt3ef(indh,k)-(vt3da(k,i,j)+vt3db(k,i,j))*dtpart
      enddo
   enddo
enddo

return
end

!***************************************************************************

subroutine tridiff (nh,n1,nhdo,cim1,ci,cip1,rhs,cj,cjp1)

real cim1(nh,*),ci(nh,*),cip1(nh,*),rhs(nh,*),cj(nh,*),cjp1(nh,*)

do ih=1,nhdo
   cjp1(ih,2)=cip1(ih,2)/ci(ih,2)
   rhs(ih,2)=rhs(ih,2)/ci(ih,2)
enddo
do k=3,n1
   do ih=1,nhdo
      cj(ih,k)=ci(ih,k)-cim1(ih,k)*cjp1(ih,k-1)
      cjp1(ih,k)=cip1(ih,k)/cj(ih,k)
      rhs(ih,k)=(rhs(ih,k)-cim1(ih,k)*rhs(ih,k-1))/cj(ih,k)
   enddo
enddo

do ih=1,nhdo
   cj(ih,n1)=rhs(ih,n1)
enddo
do k=n1-1,2,-1
   do ih=1,nhdo
      cj(ih,k)=rhs(ih,k)-cjp1(ih,k)*cj(ih,k+1)
   enddo
enddo

return
end

!***************************************************************************

subroutine grad (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                ,vc3da,vc3db,dir,gpnt,ng,optyp)
                
use hyp_coms
use mem_grid

implicit none

integer :: n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0,ng
real :: vc3da(m1,m2,m3),vc3db(m1,m2,m3)
character(len=*) :: dir,gpnt,optyp
real, dimension(maxk) :: vctr1,vctr2

call azero(maxk,vctr1)
call azero(maxk,vctr2)

if(dir.eq.'xdir') then
   if(gpnt.eq.'upnt') then

      call gradxu (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vctr1,grid(ng)%rtgu  &
                  ,grid(ng)%rtgt,grid(ng)%dxt,dzth(1,ng)  &
                  ,grid(ng)%fmapui,grid(ng)%fmapt,grid(ng)%f13t  &
                  ,hwh(1,ng),vctr2,'t',1)
   elseif(gpnt.eq.'tpnt') then

      call gradxt (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vctr1,grid(ng)%rtgt  &
                  ,grid(ng)%rtgu,grid(ng)%dxu,dzth(1,ng)  &
                  ,grid(ng)%fmapti,grid(ng)%fmapu,grid(ng)%f13u  &
                  ,hwh(1,ng),vctr2,'t',1)
   endif
elseif(dir.eq.'ydir') then

   if(gpnt.eq.'vpnt') then

      call gradyv (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vctr1,grid(ng)%rtgv  &
                  ,grid(ng)%rtgt,grid(ng)%dyt,dzth(1,ng)  &
                  ,grid(ng)%fmapvi,grid(ng)%fmapt,grid(ng)%f23t  &
                  ,hwh(1,ng),vctr2,'t',1)
           
   elseif(gpnt.eq.'tpnt') then

      call gradyt (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vctr1,grid(ng)%rtgt  &
                  ,grid(ng)%rtgv,grid(ng)%dyv,dzth(1,ng)  &
                  ,grid(ng)%fmapti,grid(ng)%fmapv,grid(ng)%f23v  &
                  ,hwh(1,ng),vctr2,'t',1)
   endif
endif

return
end

!***************************************************************************

! These are a general subroutine which computes any component of the
! gradient or divergence of VC3DA and stores it in VC3DB.

subroutine gradxu (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vc1da,rtge,rtgc  &
                  ,dx,dz,fmapi,fmap,fq,hq,hq4,lev,jd)

real vc3da(m1,m2,m3),vc3db(m1,m2,m3),vc1da(*)  &
    ,rtge(n2,n3),rtgc(n2,n3),dx(n2,n3),dy(n2,n3)  &
    ,fmap(n2,n3),fmapi(n2,n3),dz(*),fq(n2,n3),hq(*),hq4(*)
character*(*) optyp,lev

if(optyp.eq.'gradnt') then
   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i,j)*rtge(i+i0,j+j0)  &
                         -vc3da(k,i-1,j)*rtge(i-1+i0,j+j0))  &
                         *dx(i+i0,j+j0)/rtgc(i+i0,j+j0)
         enddo
      enddo
   enddo
else
   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i,j)*rtge(i+i0,j+j0)  &
                         *fmapi(i+i0,j+j0)  &
                         -vc3da(k,i-1,j)*rtge(i-1+i0,j+j0)  &
                         *fmapi(i-1+i0,j+j0))  &
                         *dx(i+i0,j+j0)/rtgc(i+i0,j+j0)*fmap(i+i0,j+j0)
         enddo
      enddo
   enddo
endif

if(optyp.ne.'divstr') then
   if(lev.eq.'w') then
      do k=1,m1
         hq4(k)=0.25*hq(k)
      enddo
   else
      do k=2,m1
         hq4(k)=0.25*hq(k-1)
      enddo
   endif

   do j=ja,jz
      do i=ia,iz
         do k=2,m1
            vc1da(k)=hq4(k)*(vc3da(k,i,j)+vc3da(k-1,i,j)  &
                         +vc3da(k,i-1,j)+vc3da(k-1,i-1,j))
         enddo
         do k=2,m1-1
            vc3db(k,i,j)=vc3db(k,i,j)  &
                         +fq(i+i0,j+j0)*dz(k)*(vc1da(k+1)-vc1da(k))
         enddo
         vc3db(1,i,j)=vc3db(2,i,j)
         if(lev.eq.'w') vc3db(m1-1,i,j)=vc3db(m1-2,i,j)
         if(lev.eq.'t') vc3db(m1,i,j)=vc3db(m1-1,i,j)
      enddo
   enddo
endif

return
end

!***************************************************************************

subroutine gradxt (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vc1da,rtge,rtgc  &
                  ,dx,dz,fmapi,fmap,fq,hq,hq4,lev,jd)

real vc3da(m1,m2,m3),vc3db(m1,m2,m3),vc1da(*)  &
    ,rtge(n2,n3),rtgc(n2,n3),dx(n2,n3),dy(n2,n3)  &
    ,fmap(n2,n3),fmapi(n2,n3),dz(*),fq(n2,n3),hq(*),hq4(*)
character*(*) optyp,lev

if(optyp.eq.'gradnt') then
   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i+1,j)*rtge(i+1+i0,j+j0)  &
                         -vc3da(k,i,j)*rtge(i+i0,j+j0))  &
                         *dx(i+i0,j+j0)/rtgc(i+i0,j+j0)
         enddo
      enddo
   enddo
else
   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i+1,j)*rtge(i+1+i0,j+j0)  &
                         *fmapi(i+1+i0,j+j0)  &
                         -vc3da(k,i,j)*rtge(i+i0,j+j0)  &
                         *fmapi(i+i0,j+j0))  &
                         *dx(i+i0,j+j0)/rtgc(i+i0,j+j0)*fmap(i+i0,j+j0)
         enddo
      enddo
   enddo
endif

if(optyp.ne.'divstr') then
   if(lev.eq.'w') then
      do k=1,m1
         hq4(k)=0.25*hq(k)
      enddo
   else
      do k=2,m1
         hq4(k)=0.25*hq(k-1)
      enddo
   endif

   do j=ja,jz
      do i=ia,iz
         do k=2,m1
            vc1da(k)=hq4(k)*(vc3da(k,i,j)+vc3da(k-1,i,j)  &
                         +vc3da(k,i+1,j)+vc3da(k-1,i+1,j))
         enddo
         do k=2,m1-1
            vc3db(k,i,j)=vc3db(k,i,j)  &
                         +fq(i+i0,j+j0)*dz(k)*(vc1da(k+1)-vc1da(k))
         enddo
         vc3db(1,i,j)=vc3db(2,i,j)
         if(lev.eq.'w') vc3db(n1-1,i,j)=vc3db(n1-2,i,j)
         if(lev.eq.'t') vc3db(n1,i,j)=vc3db(n1-1,i,j)
      enddo
   enddo
endif

return
end

!***************************************************************************

subroutine gradyv (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vc1da,rtge,rtgc  &
                  ,dy,dz,fmapi,fmap,fq,hq,hq4,lev,jd)

real vc3da(m1,m2,m3),vc3db(m1,m2,m3),vc1da(*)  &
    ,rtge(n2,n3),rtgc(n2,n3),dx(n2,n3),dy(n2,n3)  &
    ,fmap(n2,n3),fmapi(n2,n3),dz(*),fq(n2,n3),hq(*),hq4(*)
character*(*) optyp,lev

if(optyp.eq.'gradnt') then
   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i,j)*rtge(i+i0,j+j0)  &
                         -vc3da(k,i,j-jd)*rtge(i+i0,j-jd+j0))  &
                         *dy(i+i0,j+j0)/rtgc(i+i0,j+j0)
         enddo
      enddo
   enddo
else
   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i,j)*rtge(i+i0,j+j0)  &
                         *fmapi(i+i0,j+j0)  &
                         -vc3da(k,i,j-jd)*rtge(i+i0,j-jd+j0)  &
                         *fmapi(i+i0,j-jd+j0))  &
                         *dy(i+i0,j+j0)/rtgc(i+i0,j+j0)*fmap(i+i0,j+j0)
         enddo
      enddo
   enddo
endif

if(optyp.ne.'divstr') then
   if(lev.eq.'w') then
      do k=1,m1
         hq4(k)=0.25*hq(k)
      enddo
   else
      do k=2,m1
         hq4(k)=0.25*hq(k-1)
      enddo
   endif

   do j=ja,jz
      do i=ia,iz
         do k=2,m1
            vc1da(k)=hq4(k)*(vc3da(k,i,j)+vc3da(k-1,i,j)  &
                         +vc3da(k,i,j-jd)+vc3da(k-1,i,j-jd))
         enddo
         do k=2,m1-1
            vc3db(k,i,j)=vc3db(k,i,j)  &
                         +fq(i+i0,j+j0)*dz(k)*(vc1da(k+1)-vc1da(k))
         enddo
         vc3db(1,i,j)=vc3db(2,i,j)
         if(lev.eq.'w') vc3db(n1-1,i,j)=vc3db(n1-2,i,j)
         if(lev.eq.'t') vc3db(n1,i,j)=vc3db(n1-1,i,j)
      enddo
   enddo
endif

return
end

!***************************************************************************

subroutine gradyt (n1,n2,n3,m1,m2,m3,ia,iz,ja,jz,i0,j0  &
                  ,optyp,vc3da,vc3db,vc1da,rtge,rtgc  &
                  ,dy,dz,fmapi,fmap,fq,hq,hq4,lev,jd)

real vc3da(m1,m2,m3),vc3db(m1,m2,m3),vc1da(*)  &
    ,rtge(n2,n3),rtgc(n2,n3),dx(n2,n3),dy(n2,n3)  &
    ,fmap(n2,n3),fmapi(n2,n3),dz(*),fq(n2,n3),hq(*),hq4(*)
character*(*) optyp,lev

if(optyp.eq.'gradnt') then

   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i,j+jd)*rtge(i+i0,j+j0+jd)  &
                         -vc3da(k,i,j)*rtge(i+i0,j+j0))  &
                         *dy(i+i0,j+j0)/rtgc(i+i0,j+j0)
         enddo
      enddo
   enddo
else

   do j=ja,jz
      do i=ia,iz
         do k=1,m1
            vc3db(k,i,j)=(vc3da(k,i,j+jd)*rtge(i+i0,j+j0+jd)  &
                        *fmapi(i+i0,j+j0+jd)  &
                        -vc3da(k,i,j)*rtge(i+i0,j+j0)  &
                        *fmapi(i+i0,j+j0))  &
                        *dy(i+i0,j+j0)/rtgc(i+i0,j+j0)*fmap(i+i0,j+j0)
         enddo
      enddo
   enddo
endif

if(optyp.ne.'divstr') then

   if(lev.eq.'w') then
      do k=1,m1
         hq4(k)=0.25*hq(k)
      enddo
   else
      do k=2,m1
         hq4(k)=0.25*hq(k-1)
      enddo
   endif

   do j=ja,jz
      do i=ia,iz
         do k=2,m1
            vc1da(k)=hq4(k)*(vc3da(k,i,j)+vc3da(k-1,i,j)  &
                     +vc3da(k,i,j+jd)+vc3da(k-1,i,j+jd))
         enddo
         do k=2,m1-1
            vc3db(k,i,j)=vc3db(k,i,j)  &
                 +fq(i+i0,j+j0)*dz(k)*(vc1da(k+1)-vc1da(k))
         enddo
         vc3db(1,i,j)=vc3db(2,i,j)
         if(lev.eq.'w') vc3db(n1-1,i,j)=vc3db(n1-2,i,j)
         if(lev.eq.'t') vc3db(n1,i,j)=vc3db(n1-1,i,j)
      enddo
   enddo
endif

return
end
