!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

subroutine euler_init()

use hyp_coms
use mem_euler
use mem_scratch

implicit none

integer :: ng,indx,nnp,nsp,nsc,ind,nnpbd,membsz,nnp3d,maxpts

! allocate memory for all grids

print*,'------------------------------------------------------'
print*,'allocating euler memory on RAMS grids'
print*,'------------------------------------------------------'

maxxp=maxval(nnxh(1:ngrh))
maxyp=maxval(nnyh(1:ngrh))
maxzp=maxval(nnzh(1:ngrh))

maxpts=0
do ng=1,ngrh
   nnp3d=nnxh(ng)*nnyh(ng)*nnzh(ng)
   maxpts=max(maxpts,nnp3d)
enddo
print*,111
! allocate species/concentration arrays

allocate(eul(nspecies,ngrh))

do ng=1,ngrh
   call nullify_euler(eul(1:nspecies,ng),nspecies)
   call alloc_euler(eul(1:nspecies,ng),nnzh(ng),nnxh(ng),nnyh(ng),nspecies)
enddo
print*,222

! Allocate scratch arrays
call nullify_scratch()
call alloc_scratch(maxpts)

print*,333

! allocate nesting boundary arrays

!print*,'------------------------------------------------------'
!print*,'allocating eb memory for RAMS grids'
!print*,'------------------------------------------------------'

!print*,'     ng  nspecies nnpbd       added       membsz'
if(ngrh==1) then
   nnpbd=0
   membsz=1
   !write(*,'(3i8,2i12)') ngrh,nspecies,nnpbd,nnpbd*nspecies,membsz
else
   membsz=0
   do ng=2,ngrh
      nnpbd=(nnxh(ng)*nnyh(ng)+nnxh(ng)*nnzh(ng)+nnyh(ng)*nnzh(ng))*2
      membsz=membsz+nnpbd*nspecies
      !write(*,'(3i8,2i12)') ng,nspecies,nnpbd,nnpbd*nspecies,membsz
   enddo
endif

if(allocated(eb)) deallocate(eb); allocate (eb(membsz))
call azero(membsz,eb)

! fill index arrays for eb

ind=1
do ng=2,ngrh
   !print*
   !print*,'indicies for grid',ng
   do nsp=1,nspecies
      !print*,'indicies for species',nsp
      ibsxh(nsp,ng)=ind
      !print*,'ibsxh =',ibsxh(nsp,ng)
      ind=ind+2*nnzh(ng)*nnyh(ng)
      ibsyh(nsp,ng)=ind
      !print*,'ibsyh =',ibsyh(nsp,ng)
      ind=ind+2*nnzh(ng)*nnxh(ng)
      ibszh(nsp,ng)=ind
      !print*,'ibszh =',ibszh(nsp,ng)
      ind=ind+2*nnxh(ng)*nnyh(ng)
   enddo
enddo

return
end
