!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

subroutine namelist_read

! this routine reads in all the namelist variable - it then looks at
! what sources are to be used and writes the requested source database
! varaibles to the runtime variables

use hyp_coms

integer ispecies(maxem),iemis
character cargv*2,cargs(0:20)*81,cargx*81
character hypin*80,emis*4,lagprob*1,zeromet*1,warn*1
character toksep*1,frtokens(50)*30,line*256
data toksep/','/

! set any necessary defaults

specfile='none'
srcfile='none'
emfile='none'
csimend=' '
ilagprob=0
izeromet=0
iwarn=1
emis=''
iemis=0
hypin='HYPACT_IN'

! read arguments
numarg=iargc()
do n=0,numarg
   call ugetarg(n,cargx)
   cargs(n)=cargx(1:len_trim(cargx))
enddo
print*
print*,'Starting: ', cargs(0)(1:len_trim(cargs(0)))
print*
if(mod(numarg,2)==1.or.numarg.gt.8) call usage
do n=1,numarg,2
   if(cargs(n)(1:1)=='-') then 
      write(*,'(a5,i2,6a)') 'Args ',nint(float(n+1)/2.)  &
                            ,': ',cargs(n)(1:len_trim(cargs(n)))  &
                            ,' ',cargs(n+1)(1:len_trim(cargs(n+1)))
      if(cargs(n)(1:2)=='-f') then
         if(len_trim(cargs(n+1)).gt.80) then
            print*,'max filename length = 80 characters'
            call usage
         endif 
         hypin=cargs(n+1)(1:len_trim(cargs(n+1)))
      elseif(cargs(n)(1:2)=='-e') then
         if(len_trim(cargs(n+1)).gt.4) then
            print*,'max emission number = 9999'
            call usage
         endif 
         emis=cargs(n+1)(1:len_trim(cargs(n+1)))
         read(emis,'(i6)',err=300) iemis
         goto 301
         300 continue
         print*,'emission number must be an integer'
         call usage
         301 continue
      elseif(cargs(n)(1:2)=='-d') then
         if(len_trim(cargs(n+1)).gt.1) then
            print*,'data reduction arg = 0 or 1'
            call usage
         endif 
         lagprob=cargs(n+1)(1:len_trim(cargs(n+1)))
         read(lagprob,'(i1)',err=302) ilagprob
         goto 303
         302 continue
         print*,'data reduction arg = 0 or 1'
         call usage
         303 continue
      elseif(cargs(n)(1:2)=='-w') then
         if(len_trim(cargs(n+1)).gt.1) then
            print*,'warning arg = 0 or 1'
            call usage
         endif 
         warn=cargs(n+1)(1:len_trim(cargs(n+1)))
         read(warn,'(i1)',err=304) iwarn
         goto 305
         304 continue
         print*,'warning arg = 0 or 1'
         call usage
         305 continue
      elseif(cargs(n)(1:2)=='-z') then
         if(len_trim(cargs(n+1)).gt.1) then
            print*,'zero met arg = 0 or 1'
            call usage
         endif 
         zeromet=cargs(n+1)(1:len_trim(cargs(n+1)))
         read(zeromet,'(i1)',err=306) izeromet
         goto 307
         306 continue
         print*,'zero met arg = 0 or 1'
         call usage
         307 continue
      else
         call usage
      endif
   else
      call usage
   endif
enddo
print*

! fill polylat and polylon db arrays with no value flag

do nsrc=1,maxsrc
   do npoly=1,polypts
      polylat_db(npoly,nsrc)=-999.
      polylon_db(npoly,nsrc)=-999.
      polylat(npoly,nsrc)=-999.
      polylon(npoly,nsrc)=-999.
   enddo
enddo

do nsp=1,maxspec
   ioutspec_db(nsp)=1
   specname_db(nsp)='***'
enddo
do nsrc=1,maxsrc
   ioutspec_db(nsrc)=1
   srcname_db(nsrc)='***'
   xsize_db(nsrc)=-1
enddo
do nem=1,maxem
   iemit_db(nem)=1
   type_db(nem)='***'
enddo

! read the namelists
OPEN(1,STATUS='OLD',FILE=hypin,err=1)
print*,'reading $GENERAL'
CALL NAMEIN_hyp(1,'$GENERAL',0)
print*,'reading $OUTPUT'
CALL NAMEIN_hyp(1,'$OUTPUT',0)
print*,'reading $SPECIES'
CALL NAMEIN_hyp(1,'$SPECIES',0)
print*,'reading $SOURCES'
CALL NAMEIN_hyp(1,'$SOURCES',0)
print*,'reading $EMISSIONS'
CALL NAMEIN_hyp(1,'$EMISSIONS',0)
CLOSE(1)
goto 2
1 continue
stop 'error opening namelist file'
2 continue
print*,'Read namelist file: ',hypin(1:len_trim(hypin))

! read species and/or source and/or emissions file(s)

if(len_trim(specfile).ne.0.and.specfile(1:4).ne.'none') then
   print*,'reading species file: ',specfile(1:len_trim(specfile))
   open(2,file=specfile,err=3)
   read(2,*,err=3) iver,nspecies_db
   do nsp=1,nspecies_db
      read(2,'(a)',err=3) line
      lc=len_trim(line)
      if(line(lc:lc).ne.',') line(lc+1:lc+1)=','
      print*,'  ',line(1:lc+1)
      call TOKENIZE1(line,frtokens,ntokfr,toksep)
      specname_db(nsp)=frtokens(1)
      read(frtokens(2),*,err=3) wgtmol_db(nsp)
      units_db(nsp)=frtokens(3)
      read(frtokens(4),*,err=3) ihfall_db(nsp)
      read(frtokens(5),*,err=3) szpwr_db(nsp)
      read(frtokens(6),*,err=3) szmin_db(nsp)
      read(frtokens(7),*,err=3) szmax_db(nsp)
   enddo
   close(2)
   goto 4
   3 continue
   stop 'error reading species file'
   4 continue
endif

if(len_trim(srcfile).ne.0.and.srcfile(1:4).ne.'none') then
   print*,'reading source file: ',srcfile(1:len_trim(srcfile))
   open(3,file=srcfile,err=6)
   read(3,*,err=6) iver,nsources_db
   do nsrc=1,nsources_db
      read(3,'(a)',err=6) line
      lc=len_trim(line)
      if(line(lc:lc).ne.',') line(lc+1:lc+1)=','
      print*,'  ',line(1:lc+1)
      call TOKENIZE1(line,frtokens,ntokfr,toksep)
      srcname_db(nsrc)=frtokens(1)
      shape_db(nsrc)=frtokens(2)
      read(frtokens(3),*,err=6) srcy_db(nsrc)
      ntok=3
      if(shape_db(nsrc)(1:3).ne.'tri') then
         ntok=ntok+1
         read(frtokens(ntok),*,err=6) srcx_db(nsrc)
         ntok=ntok+1
         read(frtokens(ntok),*,err=6) srcz_db(nsrc)
      endif
      if(shape_db(nsrc)(1:3).eq.'rec'.or.  &
         shape_db(nsrc)(1:3).eq.'ell') then
         ntok=ntok+1
         read(frtokens(ntok),*,err=6) xsize_db(nsrc)
         ntok=ntok+1
         read(frtokens(ntok),*,err=6) ysize_db(nsrc)
         ntok=ntok+1
         read(frtokens(ntok),*,err=6) zsize_db(nsrc)
      elseif(shape_db(nsrc)(1:3).eq.'tri'.or.  &
             shape_db(nsrc)(1:3).eq.'pol') then
         if(shape_db(nsrc)(1:3).eq.'pol') then
            ntok=ntok+1
            read(frtokens(ntok),*,err=6) ipts
         else
            ipts=3
         endif
         do ip=1,ipts
            ntok=ntok+1
            read(frtokens(ntok),*,err=6) polylat_db(ip,nsrc)
            ntok=ntok+1
            read(frtokens(ntok),*,err=6) polylon_db(ip,nsrc)
         enddo
      elseif(shape_db(nsrc)(1:3).eq.'poi') then
      else
         stop 'undefined source shape in sources file'
      endif
      read(frtokens(ntok+1),*,err=6) rotation_db(nsrc)
   enddo
   close(3)
   goto 7
   6 continue
   stop 'error reading source file'
   7 continue
endif

if(len_trim(emfile).ne.0.and.emfile(1:4).ne.'none') then
   print*,'reading emissions file: ',emfile(1:len_trim(emfile))
   open(4,file=emfile,err=8)
   read(4,*,err=8) iver,nemissions_db
   do nem=1,nemissions_db
      read(4,'(a)',err=8) line
      lc=len_trim(line)
      if(line(lc:lc).ne.',') line(lc+1:lc+1)=','
      print*,'  ',line(1:lc+1)
      call TOKENIZE1(line,frtokens,ntokfr,toksep)
      read(frtokens(1),*,err=8) isource_db(nem)
      read(frtokens(2),*,err=8) ispecies_db(nem)
      read(frtokens(3),*,err=8) irelstrt_db(nem)
      read(frtokens(5),*,err=8) irelend_db(nem)
      type_db(nem)=frtokens(7)
      scaling_db(nem)=frtokens(8)
      read(frtokens(9),*,err=8) numparts_db(nem)
      read(frtokens(10),*,err=8) rate_db(nem)
      read(frtokens(11),*,err=8) ratio_db(nem)
   enddo
   close(4)
   goto 9
   8 continue
   stop 'error reading emissions file'
   9 continue
endif

! get the number of species, sources and emissions in the databases

npecies_db=0
nsources_db=0
nemissions_db=0
do nsp=1,maxspec
   if(specname_db(nsp)(1:3).ne.'***') nspecies_db=nspecies_db+1
enddo
do nsrc=1,maxsrc
   if(srcname_db(nsrc)(1:3).ne.'***') nsources_db=nsources_db+1
enddo
do nem=1,maxem
   if(type_db(nem)(1:3).ne.'***') nemissions_db=nemissions_db+1
enddo

! if args point to single emission, reset iemit_db
if(iemis.ne.0) then
   do n=1,nemissions_db
      iemit_db(n)=0
   enddo
   iemit_db(iemis)=1
endif

! pass db values to working variables recognizing which
! sources and species are not used in run and adjusting
! the array pointers accordingly

ns=0
do n=1,nemissions_db
   if(iemit_db(n).ge.1) then
      ns=ns+1
      if(ns.gt.maxem) stop 'too many emissions for maxem'
      psource(ns)=isource_db(n)
      srcname(ns)=srcname_db(isource_db(n))
      srcx(ns)=srcx_db(isource_db(n))
      srcy(ns)=srcy_db(isource_db(n))
      srcz(ns)=srcz_db(isource_db(n))
      sshape(ns)=shape_db(isource_db(n))
      if (sshape(ns)(1:3).eq.'poi') then
         xsize(ns)=0.
         ysize(ns)=0.
         zsize(ns)=0.
         sshape(ns)='rec'
      else
         xsize(ns)=xsize_db(isource_db(n))
         ysize(ns)=ysize_db(isource_db(n))
         zsize(ns)=zsize_db(isource_db(n))
      endif
      if (srcz(ns).lt.zsize(ns)/2.) then
         print*,'Source:',isource_db(n)
         print*,' zsize_db:',zsize_db(n),' srcz_db:',srcz_db(n)
         stop 'source extends below ground level'
      endif
      rotation(ns)=rotation_db(isource_db(n))
      do nplat=1,polypts
         if(polylat_db(nplat,isource_db(n)).lt.-900.) goto 20
      enddo
      20 continue
      do nplon=1,polypts
         if(polylon_db(nplon,isource_db(n)).lt.-900.) goto 21
      enddo
      21 continue
      if(nplat.ne.nplon) then
         print*,'Source:',isource_db(n)
         print*,' polylat:',polylat,' polylon:',polylon
         stop 'differnt number of polylat and polylon pts'
      else
         npolypts(ns)=nplat-1
      endif
      if(nplat.eq.3) sshape(ns)='tri'
      do npoly=1,npolypts(ns)
         polylat(npoly,ns)= polylat_db(npoly,isource_db(n))
         polylon(npoly,ns)= polylon_db(npoly,isource_db(n))
      enddo

      if(ispecies_db(n).gt.nspecies_db) then
         print*,'n,ispecies_db(n),nspecies_db'  &
                ,n,ispecies_db(n),nspecies_db
         stop 'species not defined'
      endif
      ispecies(ns)=ispecies_db(n)

      crelstrt(ns)=irelstrt_db(n)
      crelend(ns)=irelend_db(n)
      type(ns)=type_db(n)
      scaling(ns)=scaling_db(n)
      numparts(ns)=numparts_db(n)
      emission(ns)=rate_db(n)
      ratio(ns)=ratio_db(n)
   endif
enddo
nsources=ns
if(nsources.eq.0) then
   stop 'no sources initiated'
else
   print*,nsources,' emission sources initiated'
endif

iuse=0
ns=1
do n=1,nspecies_db
   if (iuse.eq.1) ns=ns+1
   iuse=0
   do nsrc=1,nsources
      if (ispecies(nsrc).eq.n) then
         species(nsrc)=ns
         if (iuse.eq.0) then
            iuse=1
            pspecies(ns)=n
            specname(ns)=specname_db(n)
            wgtmol(ns)=wgtmol_db(n)
            units(ns)=units_db(n)
            ihfall(ns)=ihfall_db(n)
            szpwr(ns)=szpwr_db(n)
            szmin(ns)=szmin_db(n)
            szmax(ns)=szmax_db(n)
            ioutspec(ns)=ioutspec_db(n)
         endif
      endif
   enddo
enddo
if (iuse.eq.0) ns=ns-1
nspecies=ns
if(nspecies.eq.0) then
   stop 'no species used'
else
   print*,nspecies,' species used'
endif

if(izeromet==1) ihturb=0

! note that psource and pspecies are the internal HYAPCT id numbers
! which differ to the database id numbers if species or sources are
! not used in the run - thus care is required in which id numbers to
! select when viewing with revu, etc

print*,'quick source summary'
print*,'            source id               species id'
print*,'       internal    external    internal    external'
do nsrc=1,nsources
   print*,nsrc,psource(nsrc),species(nsrc),pspecies(species(nsrc))
enddo
print*

return
end

!***************************************************************************

subroutine usage ()

implicit none

print*
print*,'USAGE: hypact [-f HYPACT_IN-filename] [-e emission-number] [-w show warnings 0|1]'
print*
stop

return
end

!***************************************************************************

SUBROUTINE NAMEIN_hyp (IUNIT,GROUP,IFATAL)

PARAMETER (MAXREC=1000,LINVAR=10,MAXVAR=100,MAXVAL=100)
CHARACTER*(*) GROUP
CHARACTER*20 VA
CHARACTER*80 LINE,LINEW,VALUE(MAXVAL),TOKENS(50)
COMMON/NREAD/NRFLAG,NFATAL

! This routine is called by routine NAMELIST_READ to input the values
! for the NAMELIST specified by the character string GROUP from input
! unit IUNIT

REWIND IUNIT

NFATAL=IFATAL
NRFLAG=0
NVALUE=0
NVA=0
CALL FINDGR(IUNIT,GROUP,MAXREC)
IF(NRFLAG.EQ.1.AND.IFATAL.EQ.1) STOP 'NAMEIN_hyp'
DO 10 NR=1,MAXREC
  READ(IUNIT,'(A80)',END=100) LINE
  CALL STRIP(LINE,LINEW,NCW)
  NCW=MAX(NCW,1)
  CALL TOKNZE(LINEW,NCW,TOKENS,NTOK)
  IF(LINEW(1:NCW).EQ.'$END') THEN
    GOTO 100
  ENDIF

  NT=1
  20 CONTINUE
  IF(NT.GT.NTOK) GOTO 10
  IF(LETTER(TOKENS(NT)).EQ.1) THEN
    IF(NVA.GT.0)  &
       CALL NVTRAN_hyp(GROUP,VA,IS1,IS2,VALUE,NVALUE)
    NVALUE=0
    IS1=1
    IS2=1
    VA=TOKENS(NT)
    NVA=NVA+1
    NT=NT+1
    IF(TOKENS(NT).EQ.'(') THEN
      NT=NT+1
      CALL CH2INT(TOKENS(NT),IS1)
      NT=NT+1
      IF(TOKENS(NT).EQ.',') THEN
        NT=NT+1
        CALL CH2INT(TOKENS(NT),IS2)
        NT=NT+1
      ENDIF
    ENDIF
  ELSEIF(NUMBER(TOKENS(NT)).EQ.1.OR.  &
         LETQUO(TOKENS(NT)).EQ.1) THEN
    NVALUE=NVALUE+1
    VALUE(NVALUE)=TOKENS(NT)
  ENDIF
  NT=NT+1
  GOTO 20
10 CONTINUE

100 CONTINUE
CALL NVTRAN_hyp(GROUP,VA,IS1,IS2,VALUE,NVALUE)
VA='$END'
CALL NVFILL_hyp(GROUP,VA,IS1,IS2,INT,FNUM,LINEW(1:NCW))

RETURN
END

!***************************************************************************

SUBROUTINE NVTRAN_hyp (GROUP,VA,IS1,IS2,VALUE,NVALUE)

CHARACTER CHVAL*80
CHARACTER*(*) GROUP,VA,VALUE(*)

! This routine converts a variable value(s) (VALUE) read in as a
! character string(s) to the proper type (integer, real, or character)
! and assigns it (them) to the storage location(s) corresponding to
! the NAMELIST variable VA(IS1,IS2).  GROUP is the NAMELIST
! group name.  NVALUE is the number of values to be assigned.

ncw = 1

IF(LETINT(VA).EQ.1) THEN
   DO NVA=1,NVALUE
      IF(LETQUO(VALUE(NVA)).EQ.0) THEN
         CALL CH2INT(VALUE(NVA),INT)
         CALL NVFILL_hyp(GROUP,VA,IS1+NVA-1,IS2,INT,FNUM,CHVAL(1:NCW))
      ELSE
         CALL CH2CH(VALUE(NVA),CHVAL,NCW)
         CALL NVFILL_hyp(GROUP,VA,IS1+NVA-1,IS2,INT,FNUM,CHVAL(1:NCW))
      ENDIF
   ENDDO
ELSE
   DO NVA=1,NVALUE
      IF(LETQUO(VALUE(NVA)).EQ.0) THEN
         CALL CH2REAL(VALUE(NVA),FNUM)
         CALL NVFILL_hyp(GROUP,VA,IS1+NVA-1,IS2,INT,FNUM,CHVAL(1:NCW))
      ELSE
         CALL CH2CH(VALUE(NVA),CHVAL,NCW)
         CALL NVFILL_hyp(GROUP,VA,IS1+NVA-1,IS2,INT,FNUM,CHVAL(1:NCW))
      ENDIF
   ENDDO
ENDIF

RETURN
END

!***************************************************************************

SUBROUTINE NVFILL_hyp(GROUP,VA,IS1,IS2,INn,FV,CH)

use hyp_coms

CHARACTER*(*) GROUP,VA,CH
COMMON/NREAD/NRFLAG
PARAMETER (NVGENERAL=16,NVOUTPUT=11,NVSPECIES=9  &
          ,NVSOURCES=13,NVEMISSIONS=12)
DIMENSION IGENERAL(NVGENERAL),IOUTPUT(NVOUTPUT)  &
         ,ISPECIES(NVSPECIES)  &
         ,ISOURCES(NVSOURCES),IEMISSIONS(NVEMISSIONS)
CHARACTER*20 GENERAL(NVGENERAL),OUTPUT(NVOUTPUT)  &
            ,SPECIES1(NVSPECIES),SOURCES(NVSOURCES)  &
            ,EMISSIONS(NVEMISSIONS)
DATA IGENERAL/NVGENERAL*0/,IOUTPUT/NVOUTPUT*0/  &
    ,ISPECIES/NVSPECIES*0/,ISOURCES/NVSOURCES*0/  &
    ,IEMISSIONS/NVEMISSIONS*0/
DATA GENERAL/'ihyprun','histfile','metpref','dtpart'  &
            ,'maxpart','npartbl','freqavg','ihturb','iadvord'  &
            ,'hybfreq','ihybpart','ihybmin','hybhoriz','hybvert'  &
            ,'ihgrid','hgridtop'/
DATA OUTPUT/'hyppref','hypfreq','histpref','histfreq','ipartout'  &
           ,'ieulout','ilagout','imetout','avgtime','ioutfmt'  &
           ,'irgrid'/
DATA SPECIES1/'specfile','specname','units','wgtmol'  &
             ,'ihfall','szpwr','szmin','szmax'  &
             ,'ioutspec'/
DATA SOURCES/'srcfile','srcname','shape','gridfile'  &
            ,'polylat','polylon','srcy','srcx'  &
            ,'xsize','ysize','zsize','srcz'  &
            ,'rotation'/
DATA EMISSIONS/'emfile','iemit','isource'  &
              ,'ispecies','crelstrt'  &
              ,'crelend','csimend'  &
              ,'type','scaling'  &
              ,'numparts','rate','ratio'/

if(GROUP.eq.'$GENERAL') then
  CALL VARCHK(VA,GROUP,GENERAL,IGENERAL,NVGENERAL,INRFLG)
  IF(VA.EQ.'ihyprun')  &
     CALL VARSETI_hyp(VA,ihyprun,IS1,1,INn,1,4)
  IF(VA.EQ.'histfile')  &
     CALL VARSETC_hyp(VA,histfile,IS1,1,CH,0,80)
  IF(VA.EQ.'metpref')  &
     CALL VARSETC_hyp(VA,metpref,IS1,1,CH,0,80)
  IF(VA.EQ.'dtpart')  &
     CALL VARSETF_hyp(VA,dtpart,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'maxpart')  &
     CALL VARSETI_hyp(VA,maxpart,IS1,1,INn,0,100000000)
  IF(VA.EQ.'npartbl')  &
     CALL VARSETI_hyp(VA,npartbl,IS1,1,INn,0,100000000)
  IF(VA.EQ.'freqavg')  &
     CALL VARSETF_hyp(VA,freqavg,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'ihturb')  &
     CALL VARSETI_hyp(VA,ihturb,IS1,1,INn,0,1)
  IF(VA.EQ.'iadvord')  &
     CALL VARSETI_hyp(VA,iadvord,IS1,1,INn,0,4)
  IF(VA.EQ.'hybfreq')  &
     CALL VARSETF_hyp(VA,hybfreq,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'ihybpart')  &
     CALL VARSETI_hyp(VA,ihybpart,IS1,1,INn,0,1000)
  IF(VA.EQ.'ihybmin')  &
     CALL VARSETI_hyp(VA,ihybmin,IS1,1,INn,2,1000)
  IF(VA.EQ.'hybhoriz')  &
     CALL VARSETF_hyp(VA,hybhoriz,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'hybvert')  &
     CALL VARSETF_hyp(VA,hybvert,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'ihgrid')  &
     CALL VARSETI_hyp(VA,ihgrid,IS1,1,INn,1,10)
  IF(VA.EQ.'hgridtop')  &
     CALL VARSETF_hyp(VA,hgridtop,IS1,1,FV,0.,1.e20)
endif

if(GROUP.eq.'$OUTPUT') then
  CALL VARCHK(VA,GROUP,OUTPUT,IOUTPUT,NVOUTPUT,INRFLG)
  IF(VA.EQ.'hyppref')  &
     CALL VARSETC_hyp(VA,hyppref,IS1,1,CH,0,80)
  IF(VA.EQ.'hypfreq')  &
     CALL VARSETF_hyp(VA,hypfreq,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'histpref')  &
     CALL VARSETC_hyp(VA,histpref,IS1,1,CH,0,80)
  IF(VA.EQ.'histfreq')  &
     CALL VARSETF_hyp(VA,histfreq,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'ipartout')  &
     CALL VARSETI_hyp(VA,ipartout,IS1,1,INn,0,1)
  IF(VA.EQ.'ieulout')  &
     CALL VARSETI_hyp(VA,ieulout,IS1,1,INn,0,3)
  IF(VA.EQ.'ilagout')  &
     CALL VARSETI_hyp(VA,ilagout,IS1,1,INn,0,3)
  IF(VA.EQ.'imetout')  &
     CALL VARSETI_hyp(VA,imetout,IS1,1,INn,0,3)
  IF(VA.EQ.'avgtime')  &
     CALL VARSETF_hyp(VA,avgtime,IS1,1,FV,0.,1.e20)
  IF(VA.EQ.'ioutfmt')  &
     CALL VARSETI_hyp(VA,ioutfmt,IS1,1,INn,0,1)
  IF(VA.EQ.'irgrid')  &
     CALL VARSETI_hyp(VA,irgrid,IS1,1,INn,0,10)
endif

if(GROUP.eq.'$SPECIES') then
  CALL VARCHK(VA,GROUP,SPECIES1,ISPECIES,NVSPECIES,INRFLG)
  IF(VA.EQ.'specfile')  &
    CALL VARSETC_hyp(VA,specfile,IS1,1,CH,0,80)
  IF(VA.EQ.'specname')  &
    CALL VARSETC_hyp(VA,specname_db(IS1),IS1,maxspec,CH,0,30)
  IF(VA.EQ.'units')  &
    CALL VARSETC_hyp(VA,units_db(IS1),IS1,maxspec,CH,0,30)
  IF(VA.EQ.'wgtmol')  &
    CALL VARSETF_hyp(VA,wgtmol_db(IS1),IS1,maxspec,FV,0.,500.)
  IF(VA.EQ.'ihfall')  &
    CALL VARSETI_hyp(VA,ihfall_db(IS1),IS1,maxspec,INn,0,1)
  IF(VA.EQ.'szpwr')  &
    CALL VARSETF_hyp(VA,szpwr_db(IS1),IS1,maxspec,FV,-1.e20,1.e20)
  IF(VA.EQ.'szmin')  &
    CALL VARSETF_hyp(VA,szmin_db(IS1),IS1,maxspec,FV,-1.e20,1.e20)
  IF(VA.EQ.'szmax')  &
    CALL VARSETF_hyp(VA,szmax_db(IS1),IS1,maxspec,FV,-1.e20,1.e20)
  IF(VA.EQ.'ioutspec')  &
    CALL VARSETI_hyp(VA,ioutspec_db(IS1),IS1,maxspec,INn,0,1)
endif

if(GROUP.eq.'$SOURCES') then
  CALL VARCHK(VA,GROUP,SOURCES,ISOURCES,NVSOURCES,INRFLG)
  IF(VA.EQ.'srcfile')  &
    CALL VARSETC_hyp(VA,srcfile,IS1,1,CH,0,80)
  IF(VA.EQ.'srcname')  &
    CALL VARSETC_hyp(VA,srcname_db(IS1),IS1,maxsrc,CH,0,30)
  IF(VA.EQ.'shape')  &
    CALL VARSETC_hyp(VA,shape_db(IS1),IS1,maxsrc,CH,0,10)
  IF(VA.EQ.'gridfile')  &
    CALL VARSETC_hyp(VA,gridfile_db(IS1),IS1,maxsrc,CH,0,80)
  IF(VA(1:10).EQ.'polylat') CALL VARSETF2_hyp(VA  &
    ,polylat_db(IS1,IS2),IS1,polypts,IS2,maxsrc,FV,-180.,180.)
  IF(VA(1:10).EQ.'polylon') CALL VARSETF2_hyp(VA  &
    ,polylon_db(IS1,IS2),IS1,polypts,IS2,maxsrc,FV,-180.,180.)
  IF(VA.EQ.'srcy')  &
    CALL VARSETF_hyp(VA,srcy_db(IS1),IS1,maxsrc,FV,-180.,180.)
  IF(VA.EQ.'srcx')  &
    CALL VARSETF_hyp(VA,srcx_db(IS1),IS1,maxsrc,FV,-180.,180.)
  IF(VA.EQ.'xsize')  &
    CALL VARSETF_hyp(VA,xsize_db(IS1),IS1,maxsrc,FV,0,1000000.)
  IF(VA.EQ.'ysize')  &
    CALL VARSETF_hyp(VA,ysize_db(IS1),IS1,maxsrc,FV,0,1000000.)
  IF(VA.EQ.'zsize')  &
    CALL VARSETF_hyp(VA,zsize_db(IS1),IS1,maxsrc,FV,0,1000000.)
  IF(VA.EQ.'srcz')  &
    CALL VARSETF_hyp(VA,srcz_db(IS1),IS1,maxsrc,FV,0,1000000.)
  IF(VA.EQ.'rotation')  &
    CALL VARSETF_hyp(VA,rotation_db(IS1),IS1,maxsrc,FV,-360.,360.)
endif

if(GROUP.eq.'$EMISSIONS') then
  CALL VARCHK(VA,GROUP,EMISSIONS,IEMISSIONS,NVEMISSIONS,INRFLG)
  IF(VA.EQ.'emfile')  &
    CALL VARSETC_hyp(VA,emfile,IS1,1,CH,0,80)
  IF(VA.EQ.'iemit')  &
    CALL VARSETI_hyp(VA,iemit_db(IS1),IS1,maxem,INn,0,1)
  IF(VA.EQ.'isource')  &
    CALL VARSETI_hyp(VA,isource_db(IS1),IS1,maxem,INn,1,maxem)
  IF(VA.EQ.'ispecies')  &
    CALL VARSETI_hyp(VA,ispecies_db(IS1),IS1,maxem,INn,1,maxspec)
  IF(VA.EQ.'crelstrt')  &
    CALL VARSETC_hyp(VA,irelstrt_db(IS1),IS1,maxem,CH,0,19)
  IF(VA.EQ.'crelend')  &
    CALL VARSETC_hyp(VA,irelend_db(IS1),IS1,maxem,CH,0,19)
  IF(VA.EQ.'csimend')  &
    CALL VARSETC_hyp(VA,csimend,IS1,1,CH,0,19)
  IF(VA.EQ.'type')  &
    CALL VARSETC_hyp(VA,type_db(IS1),IS1,maxem,CH,0,10)
  IF(VA.EQ.'scaling')  &
    CALL VARSETC_hyp(VA,scaling_db(IS1),IS1,maxem,CH,0,10)
  IF(VA.EQ.'numparts')  &
    CALL VARSETI_hyp(VA,numparts_db(IS1),IS1,maxem,INn,0,1000000)
  IF(VA.EQ.'rate')  &
    CALL VARSETF_hyp(VA,rate_db(IS1),IS1,maxem,FV,0.,1.e20)
  IF(VA.EQ.'ratio')  &
    CALL VARSETF_hyp(VA,ratio_db(IS1),IS1,maxem,FV,0.,1.e20)
    print*,'hname:',isimend
endif

RETURN
END

!***************************************************************************

SUBROUTINE VARSETF_hyp (VA,VAR,IS1,MAX1,FNUM,FMIN,FMAX)

CHARACTER*(*) VA
DIMENSION VAR(1)

! Assign real value read in (FNUM) to the corresponding real variable
! in the NAMELIST and do a bounds check

IF(IS1.LE.MAX1) THEN
  VAR(1)=FNUM
ELSE
  PRINT 9,VA,IS1,MAX1,FNUM
  9 FORMAT(' -- ERROR --   Input variable - ',A12,' - attempting'  &
        ,' to read extra values, values ignored.',/,  &
         ' Subscript, max dimension, value ',2I6,F20.6)
ENDIF

IF(FNUM.LT.FMIN.OR.FNUM.GT.FMAX) THEN
  PRINT 10, VA,FNUM,FMIN,FMAX
  10 FORMAT(' -- ERROR --   Input variable - ',A12,' - set to ',F18.5  &
      ,/,'                 allowable range ',F15.5,' to ',F15.5)
ENDIF

RETURN
END

!***************************************************************************

SUBROUTINE VARSETI_hyp (VA,IVAR,IS1,MAX1,INUM,IMIN,IMAX)

CHARACTER*(*) VA
DIMENSION IVAR(1)

! Assign integer value read in (INUM) to the corresponding integer var
! (IVAR) in the NAMELIST and do a bounds check

IF(IS1.LE.MAX1) THEN
  IVAR(1)=INUM
ELSE
  PRINT 9,VA,IS1,MAX1,INUM
  9 FORMAT(' -- ERROR --   Input variable - ',A12,' - attempting'  &
        ,' to read extra values, values ignored.',/,  &
         ' Subscript, max dimension, value ',2I6,I20)
ENDIF

IF(INUM.LT.IMIN.OR.INUM.GT.IMAX) THEN
  PRINT 10, VA,INUM,IMIN,IMAX
  10 FORMAT(' -- ERROR --   Input variable - ',A12,' - set to ',I10  &
      ,/,'                 allowable range ',I10,' to ',I10)
ENDIF

RETURN
END

!***************************************************************************

SUBROUTINE VARSETC_hyp (VA,VAR,IS1,MAX1,CH,IMIN,IMAX)

CHARACTER*(*) VA,CH,VAR

! Assign character value read in (CH) to the corresponding character
! variable (VAR) in the NAMELIST and do a bounds check

IF(IS1.LE.MAX1) THEN
  VAR=CH
ELSE
  PRINT 9,VA,IS1,MAX1,CH
  9 FORMAT(' -- ERROR --   Input variable - ',A12,' - attempting'  &
        ,' to read extra values, values ignored.',/,  &
         ' Subscript, max dimension, value ',2I6,A20)
ENDIF

LCH=LEN(CH)

IF(LCH.LT.IMIN.OR.LCH.GT.IMAX) THEN
  PRINT 10, VA,CH,IMIN,IMAX
  10 FORMAT(' -- ERROR --   Input variable - ',A12,' - set to ',A40  &
      ,/,'                 allowable length ',I10,' to ',I10)
ENDIF

RETURN
END

!***************************************************************************

SUBROUTINE VARSETF2_hyp (VA,VAR,IS1,MAX1,IS2,MAX2,FNUM,FMIN,FMAX)

CHARACTER*(*) VA
DIMENSION VAR(1)

! Assign real value read in (FNUM) to the corresponding real variable
! in the NAMELIST and do a bounds check

IF(IS1.LE.MAX1.AND.IS2.LE.MAX2) THEN
  VAR(1) = FNUM
ELSE
  PRINT 9,VA,IS1,MAX1,IS2,MAX2,FNUM
  9 FORMAT(' -- ERROR --   Input variable - ',A12,' - attempting'  &
        ,' to read extra values, values ignored.',/,  &
         ' Subscript',I6,', max dimension',I6,/,  &
         ' Subscript',I6,', max dimension',I6,', value ',F20.6)
ENDIF

IF(FNUM.LT.FMIN.OR.FNUM.GT.FMAX) THEN
  PRINT 10, VA,FNUM,FMIN,FMAX
  10 FORMAT(' -- ERROR --   Input variable - ',A12,' - set to ',F18.5  &
      ,/,'                 allowable range ',F15.5,' to ',F15.5)
ENDIF

RETURN
END

!***************************************************************************

SUBROUTINE VARSETI2_hyp (VA,IVAR,IS1,MAX1,IS2,MAX2,INUM,IMIN,IMAX)

CHARACTER*(*) VA
DIMENSION IVAR(1)

! Assign integer value read in (INUM) to the corresponding integer var
! (IVAR) in the NAMELIST and do a bounds check

IF(IS1.LE.MAX2.AND.IS2.LE.MAX2) THEN
  IVAR(1)=INUM
ELSE
  PRINT 9,VA,IS1,MAX1,IS2,MAX2,INUM
  9 FORMAT(' -- ERROR --   Input variable - ',A12,' - attempting'  &
        ,' to read extra values, values ignored.',/,  &
         ' Subscript',I6,', max dimension',I6,/,  &
         ' Subscript',I6,', max dimension',I6,', value ',I10)
ENDIF

IF(INUM.LT.IMIN.OR.INUM.GT.IMAX) THEN
  PRINT 10, VA,INUM,IMIN,IMAX
  10 FORMAT(' -- ERROR --   Input variable - ',A12,' - set to ',I10  &
      ,/,'                 allowable range ',I10,' to ',I10)
ENDIF

RETURN
END

!***************************************************************************

SUBROUTINE VARSETC2_hyp (VA,VAR,IS1,MAX1,IS2,MAX2,CH,IMIN,IMAX)

CHARACTER*(*) VA,CH,VAR

! Assign character value read in (CH) to the corresponding character
! variable (VAR) in the NAMELIST and do a bounds check

IF(IS1.LE.MAX1.AND.IS2.LE.MAX2) THEN
  VAR=CH
ELSE
  PRINT 9,VA,IS1,MAX1,IS2,MAX2,CH
  9 FORMAT(' -- ERROR --   Input variable - ',A12,' - attempting'  &
        ,' to read extra values, values ignored.',/,  &
         ' Subscript',I6,', max dimension',I6,/,  &
         ' Subscript',I6,', max dimension',I6,', value ',A20)
ENDIF

LCH=LEN(CH)

IF(LCH.LT.IMIN.OR.LCH.GT.IMAX) THEN
  PRINT 10, VA,CH,IMIN,IMAX
  10 FORMAT(' -- ERROR --   Input variable - ',A12,' - set to ',A40  &
      ,/,'                 allowable length ',I10,' to ',I10)
ENDIF

RETURN
END
