!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

subroutine lag_ppm ()
   
use hyp_coms
use mem_met

implicit none

integer :: l,ihp,jhp,khp,imp,jmp,kmp,itp,jtp,ktp,indp,indt,mgp
real :: qh200qh020,qh002,topth1,rtgh1,rimp,rjmp,rkmp,ritp,rjtp,rktp  &
       ,qt200,qt020,qt002,qt100,qt010,qt001,qm200,qm020,qm002,qm100  &
       ,qm010,qm001,qt111,qt112,qt121,qt122,qt211,qt212,qt221,qt222  &
       ,pp,tp,qh200,qh020

do l=1,npart

   !write (*,'(a3,x,a2,x,i4,x,3f10.4)') &
   !  '*1*','Pt',l,atp(l,1),atp(l,2),atp(l,3)

   ! find integer coordinates on h grid, grid number, and h-grid topo and rtg

   ihp=int(atp(l)%hi)
   jhp=int(atp(l)%hj)
   khp=int(atp(l)%hk)

   if(ihp < 1 .or. jhp < 1 .or. khp < 1 .or.  &
      ihp >= nih .or. jhp >= njh .or. khp >= nkh) cycle

   mgp=hg%mg(ihp,jhp,khp)
   qh200=atp(l)%hi-float(ihp)
   qh020=atp(l)%hj-float(jhp)
   qh002=atp(l)%hk-float(khp)
   topth1=(1.0-qh020)*((1.0-qh200)*hg%topthg(ihp  ,jhp  )  &
                           +qh200 *hg%topthg(ihp+1,jhp  ))  &
              +qh020 *((1.0-qh200)*hg%topthg(ihp  ,jhp+1)  &
                           +qh200 *hg%topthg(ihp+1,jhp+1))
   rtgh1=1.-topth1/ztoph

   ! find floating point and integer locations on nested grids

   rimp=hg%rim(ihp,jhp,khp)+qh200*drim(ihp,mgp)
   rjmp=hg%rjm(ihp,jhp,khp)+qh020*drjm(jhp,mgp)
   rkmp=hg%rkm(ihp,jhp,khp)+qh002*drkm(khp,mgp)

   ritp=rimp+0.5
   rjtp=rjmp+0.5
   rktp=hg%rkt(ihp,jhp,khp)+(atp(l)%hk-float(khp))*drkm(khp,mgp)

   imp=int(rimp)
   jmp=int(rjmp)
   kmp=int(rkmp)

   itp=int(ritp)
   jtp=int(rjtp)
   ktp=int(rktp)

   ! compute interpolation weights for particles on nested grids

   qt200=ritp-float(itp)
   qt020=rjtp-float(jtp)
   qt002=rktp-float(ktp)

   qt100=1.0-qt200
   qt010=1.0-qt020
   qt001=1.0-qt002

   qm200=rimp-float(imp)
   qm020=rjmp-float(jmp)
   qm002=rkmp-float(kmp)

   qm100=1.0-qm200
   qm010=1.0-qm020
   qm001=1.0-qm002

   qt111=qt100*qt010*qt001
   qt112=qt100*qt010*qt002
   qt121=qt100*qt020*qt001
   qt122=qt100*qt020*qt002
   qt211=qt200*qt010*qt001
   qt212=qt200*qt010*qt002
   qt221=qt200*qt020*qt001
   qt222=qt200*qt020*qt002


   pp=qm100*(qt010*(qt001*metc(mgp)%press(ktp  ,itp  ,jtp  )  &
                   +qt002*metc(mgp)%press(ktp+1,itp  ,jtp  ))  &
            +qt020*(qt001*metc(mgp)%press(ktp  ,itp  ,jtp+1)  &
                   +qt002*metc(mgp)%press(ktp+1,itp  ,jtp+1)))  &
     +qm200*(qt010*(qt001*metc(mgp)%press(ktp  ,itp+1,jtp  )  &
                   +qt002*metc(mgp)%press(ktp+1,itp+1,jtp  ))  &
            +qt020*(qt001*metc(mgp)%press(ktp  ,itp+1,jtp+1)  &
                   +qt002*metc(mgp)%press(ktp+1,itp+1,jtp+1)))

   tp=qm100*(qt010*(qt001*metc(mgp)%temp(ktp  ,itp  ,jtp  )  &
                   +qt002*metc(mgp)%temp(ktp+1,itp  ,jtp  ))  &
            +qt020*(qt001*metc(mgp)%temp(ktp  ,itp  ,jtp+1)  &
                   +qt002*metc(mgp)%temp(ktp+1,itp  ,jtp+1)))  &
     +qm200*(qt010*(qt001*metc(mgp)%temp(ktp  ,itp+1,jtp  )  &
                   +qt002*metc(mgp)%temp(ktp+1,itp+1,jtp  ))  &
            +qt020*(qt001*metc(mgp)%temp(ktp  ,itp+1,jtp+1)  &
                   +qt002*metc(mgp)%temp(ktp+1,itp+1,jtp+1)))

   ! calc the ppm per particle

   if (wgtmol(atp(l)%nspecies) > 0.) then
      atp(l)%ppm=atp(l)%mass*0.083145*tp/(pp*wgtmol(atp(l)%nspecies))
   else
      atp(l)%ppm=0.
   endif

enddo

return
end



