!############################# Change Log ##################################
! 3.0.0
!
!###########################################################################
!  Copyright (C)  2002 - All Rights Reserved
!###########################################################################

subroutine default_colors (ibgnd)

use define_colors

! line and text colors (total of 256 colors starting at index 0)

! 0        reserved for background
! 1        reserved for foreground
! 2  - 58  reserved for standard colors
! 59 - 89  reserved for fixed array of colors
! 90 - 95  reserved for 6 gray scale colors
! 96 - 255 reserved for user specified colors

implicit none

integer :: ibgnd

integer :: i


print*,'start default_colors:',ibgnd

! Define default color table
call colortab_init()
!call colortab_print()



! Set up the "alias", , and vector colors

if(ibgnd == 1) then
   ! Colors intended for computer screens on black background

   ! use specific colors
   call coloralias_add ('background' ,'black' ) 
   call coloralias_add ('foreground' ,'white' ) 
   call coloralias_add ('title0' ,'white' )  ! box divider lines
   call coloralias_add ('title1' ,'midred')  ! experiment name and grid number
   call coloralias_add ('title2' ,'cyan')  ! location, date, time, and
                              !   min-max-inc-lab labels
   call coloralias_add ('axis'   ,'white' )  ! axis labels, perimeter, topo,
                              !   vector low, tile colorbar boxes
                              !   and labels
   call coloralias_add ('roads0' ,'gray70')! roads on (filled)
   call coloralias_add ('roads1' ,'gray60' )  ! roads on (outline)
   call coloralias_add ('land'   ,'darkgreen' )  ! land
   call coloralias_add ('water'  ,'darkblue' )  ! water
   call coloralias_add ('bound0' ,'black' )  ! map boundaries (filled)
   call coloralias_add ('bound1' ,'midred' )  ! map boundaries (outline)
   call coloralias_add ('shadow0','lightgreen' )  ! map boundaries shadow (filled)
   call coloralias_add ('shadow1','darkred' )  ! map boundaries shadow (outline)

   ! fill colors
   call colortab_add ('fill01','hls',340.,92., 75.)
   call colortab_add ('fill02','hls',340.,83., 75.) ! blues
   call colortab_add ('fill03','hls',340.,71., 75.)
   call colortab_add ('fill04','hls',340.,60., 75.)
   
   call colortab_add ('fill05','hls',302.,77., 70.)
   call colortab_add ('fill06','hls',302.,55., 70.)  ! blue greens
   call colortab_add ('fill07','hls',302.,41., 70.)
   call colortab_add ('fill08','hls',302.,33., 70.)
   
   call colortab_add ('fill09','hls',270.,77., 65.)
   call colortab_add ('fill10','hls',270.,55., 65.)  ! greens
   call colortab_add ('fill11','hls',270.,41., 65.)
   call colortab_add ('fill12','hls',270.,33., 65.)
   
   call colortab_add ('fill13','hls',194.,70., 75.)
   call colortab_add ('fill14','hls',194.,50., 75.)  ! green yellows
   call colortab_add ('fill15','hls',194.,41., 75.)
   call colortab_add ('fill16','hls',194.,33., 75.)
   
   call colortab_add ('fill17','hls',180.,62., 90.)  ! yellow
  
   call colortab_add ('fill18','hls',160.,74.,100.)
   call colortab_add ('fill19','hls',160.,61.,100.)  ! oranges
   call colortab_add ('fill20','hls',160.,48.,100.)
   call colortab_add ('fill21','hls',160.,42.,100.)
   
   call colortab_add ('fill22','hls',150.,68., 50.)
   call colortab_add ('fill23','hls',150.,57., 50.)  ! browns
   call colortab_add ('fill24','hls',150.,44., 50.)
   call colortab_add ('fill25','hls',150.,37., 50.)

   call colortab_add ('fill26','hls',135.,80., 70.)
   call colortab_add ('fill27','hls',135.,68., 70.)  ! reds
   call colortab_add ('fill28','hls',135.,49., 70.)
   call colortab_add ('fill29','hls',135.,40., 70.)

   call colortab_add ('fill30','hls', 85.,80., 70.)
   call colortab_add ('fill31','hls', 85.,68., 70.)  ! magentas
   call colortab_add ('fill32','hls', 85.,49., 70.)
   call colortab_add ('fill33','hls', 85.,40., 70.)
   
   call colortab_add ('fill34','hls', 50.,80., 70.)
   call colortab_add ('fill35','hls', 50.,68., 70.)  ! violets
   call colortab_add ('fill36','hls', 50.,49., 70.)
   call colortab_add ('fill37','hls', 50.,40., 70.)
  
   call colortab_add ('fill38','hls', 20.,80., 70.)
   call colortab_add ('fill39','hls', 20.,70., 70.)  ! violet blues
   call colortab_add ('fill40','hls', 20.,56., 70.)
   call colortab_add ('fill41','hls', 20.,40., 70.)

   call colortab_add ('fill42','hls', 00., 90.,  0.)
   call colortab_add ('fill43','hls', 00., 77.,  0.)
   call colortab_add ('fill44','hls', 00., 60.,  0.)
   call colortab_add ('fill45','hls', 00., 43.,  0.)  ! gray shades
   call colortab_add ('fill46','hls', 00., 34.,  0.)

   ! Define a set of 6 lighter colors for vectors
   
   call colortab_add ('vector01','rgb',1., .50 , 1.)
   call colortab_add ('vector02','rgb',.4, .75 , 1.)
   call colortab_add ('vector03','rgb',.6, 1.0 , 0.)
   call colortab_add ('vector04','rgb',1., 1.0 , 0.)
   call colortab_add ('vector05','rgb',1., .75 , 0.)
   call colortab_add ('vector06','rgb',1., .40 , .4)

elseif(ibgnd == 2 ) then

   ! Colors intended for computer screens on white background
   
   ! use specific colors
   call coloralias_add ('background' ,'white' ) 
   call coloralias_add ('foreground' ,'black' ) 
   call coloralias_add ('title0' ,'black' )  ! box divider lines
   call coloralias_add ('title1' ,'red')  ! experiment name and grid number
   call coloralias_add ('title2' ,'cyan')  ! location, date, time, and
                              !   min-max-inc-lab labels
   call coloralias_add ('axis'   ,'black' )  ! axis labels, perimeter, topo,
                              !   vector low, tile colorbar boxes
                              !   and labels
   call coloralias_add ('roads0' ,'gray70')! roads on (filled)
   call coloralias_add ('roads1' ,'gray60' )  ! roads on (outline)
   call coloralias_add ('land'   ,'lightgreen' )  ! land
   call coloralias_add ('water'  ,'lightblue' )  ! water
   call coloralias_add ('bound0' ,'midgreen' )  ! map boundaries (filled)
   call coloralias_add ('bound1' ,'midgreen' )  ! map boundaries (outline)
   call coloralias_add ('shadow0','black' )  ! map boundaries shadow (filled)
   call coloralias_add ('shadow1','black' )  ! map boundaries shadow (outline)

   ! fill colors
   call colortab_add ('fill01','hls',340.,92., 75.)
   call colortab_add ('fill02','hls',340.,83., 75.) ! blues
   call colortab_add ('fill03','hls',340.,71., 75.)
   call colortab_add ('fill04','hls',340.,60., 75.)
   
   call colortab_add ('fill05','hls',302.,77., 70.)
   call colortab_add ('fill06','hls',302.,55., 70.)  ! blue greens
   call colortab_add ('fill07','hls',302.,41., 70.)
   call colortab_add ('fill08','hls',302.,33., 70.)
   
   call colortab_add ('fill09','hls',270.,77., 65.)
   call colortab_add ('fill10','hls',270.,55., 65.)  ! greens
   call colortab_add ('fill11','hls',270.,41., 65.)
   call colortab_add ('fill12','hls',270.,33., 65.)
   
   call colortab_add ('fill13','hls',194.,70., 75.)
   call colortab_add ('fill14','hls',194.,50., 75.)  ! green yellows
   call colortab_add ('fill15','hls',194.,41., 75.)
   call colortab_add ('fill16','hls',194.,33., 75.)
   
   call colortab_add ('fill17','hls',180.,62., 90.)  ! yellow
  
   call colortab_add ('fill18','hls',160.,74.,100.)
   call colortab_add ('fill19','hls',160.,61.,100.)  ! oranges
   call colortab_add ('fill20','hls',160.,48.,100.)
   call colortab_add ('fill21','hls',160.,42.,100.)
   
   call colortab_add ('fill22','hls',150.,68., 50.)
   call colortab_add ('fill23','hls',150.,57., 50.)  ! browns
   call colortab_add ('fill24','hls',150.,44., 50.)
   call colortab_add ('fill25','hls',150.,37., 50.)

   call colortab_add ('fill26','hls',135.,80., 70.)
   call colortab_add ('fill27','hls',135.,68., 70.)  ! reds
   call colortab_add ('fill28','hls',135.,49., 70.)
   call colortab_add ('fill29','hls',135.,40., 70.)

   call colortab_add ('fill30','hls', 85.,80., 70.)
   call colortab_add ('fill31','hls', 85.,68., 70.)  ! magentas
   call colortab_add ('fill32','hls', 85.,49., 70.)
   call colortab_add ('fill33','hls', 85.,40., 70.)
   
   call colortab_add ('fill34','hls', 50.,80., 70.)
   call colortab_add ('fill35','hls', 50.,68., 70.)  ! violets
   call colortab_add ('fill36','hls', 50.,49., 70.)
   call colortab_add ('fill37','hls', 50.,40., 70.)
  
   call colortab_add ('fill38','hls', 20.,80., 70.)
   call colortab_add ('fill39','hls', 20.,70., 70.)  ! violet blues
   call colortab_add ('fill40','hls', 20.,56., 70.)
   call colortab_add ('fill41','hls', 20.,40., 70.)

   call colortab_add ('fill42','hls', 00., 90.,  0.)
   call colortab_add ('fill43','hls', 00., 77.,  0.)
   call colortab_add ('fill44','hls', 00., 60.,  0.)
   call colortab_add ('fill45','hls', 00., 43.,  0.)  ! gray shades
   call colortab_add ('fill46','hls', 00., 34.,  0.)
                   
   ! Define a set of 6 darker colors for vectors
   call colortab_add ('vector01','rgb',.5,.0,.5)
   call colortab_add ('vector02','rgb',.0,.0,.7)
   call colortab_add ('vector03','rgb',.4,.8,.0)
   call colortab_add ('vector04','rgb',.7,.7,.0)
   call colortab_add ('vector05','rgb',.7,.4,.0)
   call colortab_add ('vector06','rgb',.7,.0,.0)
                  
endif

return
end

!***************************************************************************

subroutine default_colindex (iwkstation)
use define_colors

implicit none

integer :: iwkstation
integer :: i

! set gks color 0 to background and all other colors to foreground

call coloralias_set (iwkstation,'background',0)
do i=1,255
   call coloralias_set (iwkstation,'foreground',i)
enddo


return
end

!***************************************************************************

subroutine fillcolors (ilayer,imin,imid,imax)

use pl_params
use define_colors

! set contour and tile colors

implicit none

integer :: ilayer,imin,imid,imax

integer :: i,ip,ischeme,interpl
real :: h_min,l_min,s_min,h_mid,l_mid,s_mid,h_max,l_max,s_max  &
       ,hx,lx,sx,fx,hu_r1,hu_r2,su_r1,su_r2
character(len=16) :: colmin,colmid,colmax
       
! get the color fill options and get the rgb and hls colors

colmin=fillcols(1,ilayer)
colmid=fillcols(2,ilayer)
colmax=fillcols(3,ilayer)

! If min or max color is none, default colors are used, so return

if( colmin(1:4) == 'none' .or. colmax(1:4) == 'none')  return

! See if we have a 2 or 3 color scheme

ischeme=3
if( colmid(1:4) == 'none' )  ischeme = 2

! We also have to find if we interpolate only in lightness value or
!   all three hls

interpl=3
if (colmin(1:5) == 'white' .or. colmin(1:5) == 'black' .or.  &
    colmid(1:5) == 'white' .or. colmid(1:5) == 'black' .or.  &
    colmax(1:5) == 'white' .or. colmax(1:5) == 'black' )  &
    interpl=1
    
! Find HLS values of min,mid,max colors

if(colmin /= 'none') call colortab_vals ('hls',colmin,h_min,l_min,s_min)
if(colmid /= 'none') call colortab_vals ('hls',colmid,h_mid,l_mid,s_mid)     
if(colmax /= 'none') call colortab_vals ('hls',colmax,h_max,l_max,s_max)

         print*,'base-min:',colmin,h_min,l_min,s_min
         print*,'base-mid:',colmid,h_mid,l_mid,s_mid
         print*,'base-max:',colmax,h_max,l_max,s_max

    
! For the interpl=1 schemes, we need to set the h and s values to the 
!     user-specified color. For ischeme=3, we have 2 values to set...

if (interpl == 1) then
   if(ischeme == 2) then
      hu_r1 = h_min  ;   su_r1 = s_min
      if (colmin(1:5) == 'white' .or. colmin(1:5) == 'black') then
         hu_r1 = h_max  ;    su_r1 = s_max
         print*,'setting:',h_max,s_max
      endif
   elseif(ischeme == 3) then
      hu_r1 = h_min  ;   su_r1 = s_min
      hu_r2 = h_max  ;   su_r2 = s_max
      if (colmin(1:5) == 'white' .or. colmin(1:5) == 'black') then
         hu_r1 = h_mid  ;    su_r1 = s_mid
      endif
      if (colmax(1:5) == 'white' .or. colmax(1:5) == 'black') then
         hu_r2 = h_mid  ;    su_r2 = s_mid
      endif
   endif
endif
         
! 2-color scheme - interpolate between min and max colors
!     Two choices : 
!     - if one of the colors is white or black, interpolate only in 
!       lightness value
!     - otherwise, interpolate in all three hls

print*,'flags:',ischeme,interpl
if (ischeme == 2) then
   if (interpl == 1) then
      do i=imin,imax
         fx=float(i-imin)/max(1.,float(imax-imin))
         lx=min(100.,max(0.,l_min + (l_max-l_min)   &
                              * fx**(1./cbias(ilayer))))
    !  print*,fx,fx**(1./cbias(ilayer))
         call hls00 (iwkstation,i,hu_r1,lx,su_r1)    ! fill color into table
    !     print*,'s2-l1:',i,hu_r1,lx,su_r1
         ! set line color
         if(lx <  50.) lx=lx+abs(cgrad(ilayer))
         if(lx >= 50.) lx=lx-abs(cgrad(ilayer))
         call hls00 (iwkstation,i+40,hu_r1,lx,su_r1)
      enddo
   elseif (interpl == 3) then
      do i=imin,imax
         fx=float(i-imin)/max(1.,float(imax-imin))
         hx=h_min + (h_max-h_min) * fx**(1./cbias(ilayer))
         lx=l_min + (l_max-l_min) * fx**(1./cbias(ilayer))
         sx=s_min + (s_max-s_min) * fx**(1./cbias(ilayer))
         call hls00 (iwkstation,i,hx,lx,sx)    ! fill color into table
         ! set line color
         if(lx <  50.) lx=lx+abs(cgrad(ilayer))
         if(lx >= 50.) lx=lx-abs(cgrad(ilayer))
         call hls00 (iwkstation,i+40,hx,lx,sx)
   !      print*,'s2-l3:',hx,lx,sx
      enddo
   endif

! 3-color scheme - interpolate between min-mid and mid-max colors

elseif (ischeme == 3) then
   if (interpl == 1) then
      do i=imin,imid
         fx=float(i-imin)/max(1.,float(imid-imin))
         lx=min(100.,max(0.,l_min + (l_mid-l_min)   &
                              * fx**(1./cbias(ilayer))))
      
         call hls00 (iwkstation,i,hu_r1,lx,su_r1)    ! fill color into table
      !   print*,'s3-l1:',i,h_min,lx,s_min
         ! set line color
         if(lx <  50.) lx=lx+abs(cgrad(ilayer))
         if(lx >= 50.) lx=lx-abs(cgrad(ilayer))
         call hls00 (iwkstation,i+40,hu_r1,lx,su_r1)
      enddo
      do i=imid+1,imax
         fx=float(i-imid)/max(1.,float(imax-imid))
         lx=min(100.,max(0.,l_mid + (l_max-l_mid)   &
                              * fx**(1./cbias(ilayer))))
      
         call hls00 (iwkstation,i,hu_r2,lx,su_r2)    ! fill color into table
      !   print*,'s3-l1:',i,h_max,lx,s_max
         ! set line color
         if(lx <  50.) lx=lx+abs(cgrad(ilayer))
         if(lx >= 50.) lx=lx-abs(cgrad(ilayer))
         call hls00 (iwkstation,i+40,hu_r2,lx,su_r2)
      enddo
   elseif (interpl == 3) then
      do i=imin,imid
         fx=float(i-imin)/max(1.,float(imid-imin))
         hx=h_min + (h_mid-h_min) * fx**(1./cbias(ilayer))
         lx=l_min + (l_mid-l_min) * fx**(1./cbias(ilayer))
         sx=s_min + (s_mid-s_min) * fx**(1./cbias(ilayer))
         call hls00 (iwkstation,i,hx,lx,sx)    ! fill color into table
       !  print*,'ccccc:',i,hx,lx,sx
         ! set line color
         if(lx <  50.) lx=lx+abs(cgrad(ilayer))
         if(lx >= 50.) lx=lx-abs(cgrad(ilayer))
         call hls00 (iwkstation,i+40,hx,lx,sx)
       !  print*,'ccccc:',i+40,hx,lx,sx
      enddo
      do i=imid+1,imax
         fx=float(i-imid)/max(1.,float(imax-imid))
         hx=h_mid + (h_max-h_mid) * fx**(1./cbias(ilayer))
         lx=l_mid + (l_max-l_mid) * fx**(1./cbias(ilayer))
         sx=s_mid + (s_max-s_mid) * fx**(1./cbias(ilayer))
         call hls00 (iwkstation,i,hx,lx,sx)    ! fill color into table
       !  print*,'cccc2:',i,hx,lx,sx
         ! set line color
         if(lx <  50.) lx=lx+abs(cgrad(ilayer))
         if(lx >= 50.) lx=lx-abs(cgrad(ilayer))
         call hls00 (iwkstation,i+40,hx,lx,sx)
       !  print*,'cccc2:',i+40,hx,lx,sx
      enddo
   endif

endif

return
end

!***************************************************************************

subroutine gs00 (iwkstation,ic,ir,ig,ib)

implicit none

integer :: iwkstation,ic,ir,ig,ib

call gscr (iwkstation,ic,float(ir)/255.,float(ig)/255.,float(ib)/255.)

return
end

!***************************************************************************

subroutine hsv00 (iwkstation,ic,h,s,v)

implicit none

integer :: iwkstation,ic
real :: h,s,v

real :: r,g,b

call hsvrgb (h,s,v,r,g,b)
call gscr (iwkstation,ic,r,g,b)

return
end

!***************************************************************************

subroutine hls00 (iwkstation,ic,h,l,s)

implicit none

integer :: iwkstation,ic
real :: h,l,s

real :: r,g,b

call hlsrgb (h,l,s,r,g,b)
!print*,'hls00:',iwkstation,ic,r,g,b
call gscr (iwkstation,ic,r,g,b)

return
end

