!program con

!real :: x(2,2),clevs(100)

!x(2,1)=5.; x(2,2)=10.
!x(1,1)=0.; x(1,2)=-5.

!call opngks


!10 continue
!print*,'lo,hi,inc'
!read*, clo,chi,cinc
!call cont_levels(2,2,x,clo,chi,cinc,cmid,ncl,clevs,imid)
!print '(a,i3,30f7.2)','levs:',ncl,clevs(1:ncl)
!go to 10

!call clsgks
!end




subroutine cont_levels(nii,njj,slab,conrlo,conrhi,conrinc,conrmid &
                      ,ncl,cont_levs,imid)

implicit none

integer :: nii,njj,ncl,imid
real, dimension(nii,njj) :: slab
real :: cont_levs(*)
real :: conrlo,conrhi,conrinc,conrmid


integer,parameter :: lrwk = 5000, liwk = 5000
integer  ::  iwrk(liwk)
real     ::  rwrk(lrwk)
real :: conlo,conhi
integer :: nlev,iset

! Using conpack routines to compute contour/tile/vector contour line values 
!     - do the calls to cprect and cppkcl twice in
!     cases where we want the contours to completely cover the data range
!     (when conrlo and conrhi are 0.) and when the conrlo and conrhi get
!     reset when conrinc is 0
!     if all 3 are specified, just use those numbers

! get set setting
call cpgeti('SET',iset)
! We called set, not conpack
call cpseti('SET',0)

if(conrinc < -1.e-10) then
   ! setting conrinc negative - specifies absolute number of intervals. 
   !     conrlo and conrhi are ignored
   call cpseti('CLS',nint(abs(conrinc)))
   call cpseti('CIS',0.)
   call cpsetr('CMN',0.)
   call cpsetr('CMX',-1.)
elseif(abs(conrlo) < 1.e-10 .and. abs(conrhi) < 1.e-10 .and.  &
       conrinc > 1.e-10) then
   ! setting conrlo and conrhi to zero - let conpack find low and high
   ! setting conrinc > 0. - this is the actual contour interval
   !    This defaults to 12 contour levels????
   call cpseti('CLS',12)
   call cpsetr('CMN',0.)
   call cpsetr('CMX',-1.)
   call cpsetr('CIS',conrinc)
   call cprect(slab,nii,nii,njj,rwrk,lrwk,iwrk,liwk)
   call cppkcl(slab,rwrk,iwrk)
   call cpgeti('NCL',ncl)

   if(ncl==0) goto 100
 
   call cpseti('PAI',1)
   call cpgetr('CLV',conlo)
   call cpseti('PAI',ncl)
   call cpgetr('CLV',conhi)
   call cpsetr('CMN',conlo-(conhi-conlo)/float(ncl-1))
   call cpsetr('CMX',conhi+(conhi-conlo)/float(ncl-1))
   call cpsetr('CIS',(conhi-conlo)/float(ncl-1))
else
   call cpsetr('CMN',conrlo)
   call cpsetr('CMX',conrhi)
   call cpsetr('CIS',conrinc)
   
   ! setting conrlo, conrhi /=0 and conrinc = 0 - 
   if(abs(conrinc) < 1.e-10 .and.  &
      abs(conrlo)  > 1.e-10 .and. abs(conrhi) > 1.e-10) then
      call cprect(slab,nii,nii,njj,rwrk,lrwk,iwrk,liwk)
      call cppkcl(slab,rwrk,iwrk)
      call cpgeti('NCL',ncl)

      if(ncl == 0) goto 100

      call cpseti('PAI',1)
      call cpgetr('CLV',conlo)
      call cpseti('PAI',ncl)
      call cpgetr('CLV',conhi)
      call cpsetr('CMN',conrlo)
      call cpsetr('CMX',conrhi)
      call cpsetr('CIS',(conhi-conlo)/float(ncl-1))
   endif
   
   ! setting conrlo, conrhi == 0  
   if(abs(conrlo) < 1.e-10 .and. abs(conrhi) < 1.e-10) then
      call cprect(slab,nii,nii,njj,rwrk,lrwk,iwrk,liwk)
      call cppkcl(slab,rwrk,iwrk)
      call cpgeti('NCL',ncl)

      if(ncl == 0) goto 100

      call cpseti('PAI',1)
      call cpgetr('CLV',conlo)
      call cpseti('PAI',ncl)
      call cpgetr('CLV',conhi)
      call cpsetr('CMN',conlo-(conhi-conlo)/float(ncl-1))
      call cpsetr('CMX',conhi+(conhi-conlo)/float(ncl-1))
      call cpsetr('CIS',(conhi-conlo)/float(ncl-1))
   endif
endif

call cprect(slab,nii,nii,njj,rwrk,lrwk,iwrk,liwk)
call cppkcl(slab,rwrk,iwrk)

! get number of contour lines
call cpgeti('NCL',ncl)
if(ncl == 0) go to 100

! get the levels
do nlev=1,ncl
   call cpseti('PAI',nlev)
   call cpgetr('CLV',cont_levs(nlev))
enddo

! get the mid value
do imid=1,ncl
   if(cont_levs(nlev) >= conrmid) exit
enddo
imid=imid-1

100 continue

! Re-set set
call cpseti('SET',iset)

return
end
