subroutine info_labels(iwk,boxtype,cdname,cdunits,tilelo,tilehi &
                      ,coninc,clabscl,boxtop,boxhite,colbox,collab)

use define_colors

implicit none

integer :: iwk
real :: tilelo,tilehi,coninc,clabscl,boxtop,boxhite
character(len=*) :: cdname,cdunits,colbox,collab,boxtype

character(len=80) :: title
integer :: ic,lcdname,lcdunits,nc
real :: sz,box5

! Draw boxes for info labels

call set(0.,1.,0.,1.,0.,1.,0.,1.,1)

ic=5
call coloralias_set(iwk,colbox,ic)
call gsplci(ic)
call gstxci(ic)

boxtop=boxtop-boxhite

! Draw the label box outline
call frstpt(.01,boxtop)
call vector(.01,boxtop-boxhite)
call vector(.99,boxtop-boxhite)
call vector(.99,boxtop)

if(boxtype(1:3) == 'con' .or. boxtype(1:3) == 'til' .or. &
   boxtype(1:1) == 'v'   .or. boxtype(1:3) == 'bar') then
   call frstpt(.20,boxtop)
   call vector(.20,boxtop-boxhite)

   call frstpt(.55,boxtop)
   call vector(.55,boxtop-boxhite)

   call frstpt(.675,boxtop)
   call vector(.675,boxtop-boxhite)

   call frstpt(.79,boxtop)
   call vector(.79,boxtop-boxhite)

   call frstpt(.915,boxtop)
   call vector(.915,boxtop-boxhite)
endif


call sflush

box5=boxtop-.5*boxhite

! Make nice labels under the plot with contouring information

ic=5
call coloralias_set(iwk,collab,ic)
call gsplci(ic)
call gstxci(ic)


lcdname=len_trim(cdname)
if(cdname(lcdname:lcdname) == ';') lcdname=lcdname-1
lcdunits=len_trim(cdunits)
if(cdunits(lcdunits:lcdunits) == ';') lcdunits=lcdunits-1

if(lcdunits <= 0) then
   title=cdname(1:lcdname)
else
   title=cdname(1:lcdname)//' ('//cdunits(1:lcdunits)//')'
endif

call plchhq (.03,box5,trim(boxtype)//' ',-.7,0.,-1.)

call plchhq (.21,box5,title(1:(lcdname+lcdunits+3)),-.7,0.,-1.)


! If these come in as -1.e20, it means don't plot them.

sz=-.6
if(tilelo > -1.e19) then
   write (title,'(g10.4)') tilelo
   call plchmq (.56,box5,title,sz,0.,-1.)
endif
if(tilehi > -1.e19) then
   write (title,'(g10.4)') tilehi
   call plchmq (.685,box5,title,sz,0.,-1.)
endif
if(coninc > -1.e19) then
   write (title,'(g10.4)') coninc
   call plchmq (.795,box5,title,sz,0.,-1.)
endif
if(clabscl > -1.e19) then
   write (title,'(''1e'',i2)') nint(log10(clabscl))
   call plchmq (.920,box5,title,sz,0.,-1.)
endif
 
return
end


