!############################# Change Log ##################################
! 1.0.0
!
!
!###########################################################################
!  Copyright (C)  2002 - All Rights Reserved
!###########################################################################

subroutine RAMS_mkmap (iwksta,platn,plonn,xt1,yt1,xt2,yt2,mfill  &
                      ,px1,px2,py1,py2,icplotinfo)

use define_colors

! Now using NCARG 4.3.0 and RANGS maps

implicit none


real :: platn,plonn,xt1,yt1,xt2,yt2,px1,px2,py1,py2
integer :: mfill,icplotinfo,iwksta

integer, dimension(10) :: iaia,igia

integer, parameter :: nama=10000000, ncra=100000
integer :: iama
real :: xcra,ycra
common /mapspc/iama(nama),xcra(ncra),ycra(ncra)
integer, external :: fill

integer :: iroads
common/misc/iroads


integer, save :: ittt
real, save :: ppx1,ppx2,ppy1,ppy2,xx1,xx2,yy1,yy2

integer , save :: mfillo=-1
real, save :: xt1o=0.,xt2o=0.,yt1o=0.,yt2o=0.,py1o=-1.  &
             ,plato=-361.,plono=-91.

real :: xlat1,xlon1,xlat2,xlon2,xlat3,xlon3,xlat4,xlon4,xplat,xplon,offset
integer :: icol(5),icsf(5),ic
integer :: imres
common/mp_misc/imres

!print*,'in rg mkmap' ,platn,plonn


if(mfill == mfillo.and.xt1 == xt1o.and.xt2 == xt2o.and.  &
   yt1   == yt1o  .and.yt2 == yt2o.and.  &
   platn == plato .and.plonn == plono.and.  &
   py1   == py1o  .and.icplotinfo == 0) then

   ! call set with previous map call  and we're done...

   call set (ppx1,ppx2,ppy1,ppy2,xx1,xx2,yy1,yy2,ittt)

else

   ! Compute new map
   
   xplat=platn
   xplon=plonn

   call xy_ll (xlat1,xlon1,platn,plonn,xt1,yt1)
   call xy_ll (xlat2,xlon2,platn,plonn,xt2,yt2)
   call xy_ll (xlat3,xlon3,platn,plonn,xt2,yt1)
   call xy_ll (xlat4,xlon4,platn,plonn,xt1,yt2)

   print*,'pol coords-',platn,plonn
   print*,'corners-',xlat1,xlon1,xlat2,xlon2
   print*,'corners-',xt1,yt1,xt2,yt2
   print*,'fill-',mfill
   
   if(xlat1 == xlat2.or.xlon1 == xlon2) then
      print*,'ERROR in RAMS_mkmap - grid has no size!'
      return
   endif
   
   !!!!!
   !!!!! Due to the use of flash buffers, unique gks color indices
   !!!!! must be used until the buffer is actually written to the metafile.
   !!!!!  We will use 11-17
   
   
   ! Define colors to use for the outlines and filled areas
   ! produced from the RANGS/GSHHS data.
   ! 1-Ocean, 2-Land, 3-Lake, 4-Island in lake, 5-Pond on island

   call coloralias_set (iwksta,'water',11)
   call coloralias_set (iwksta,'land' ,12)
   call coloralias_set (iwksta,'roads0',13)
   call coloralias_set (iwksta,'roads1',14)
   call coloralias_set (iwksta,'roads0',15)
   icol(1:5)=11
   icsf(1)=11 ; icsf(2)=12 ; icsf(3)=13 ; icsf(4)=14 ; icsf(5)=15

   call mdrgsc (icol,icsf)

   ! Set map projection, corners, lat-lon spacing, and political outlines 
   call mappos (px1,px2,py1,py2)
   call maproj ('ST',platn,plonn,0.)
   call mapset ('CO',xlat1,xlon1,xlat2,xlon2)
   call mapsti ('GR',5)
   call mapstc ('OU','PS')
   call mapint
   
   ! Get the suggested resolution of the RANGS/GSHHS data.
   call mdrgdl(imres)  
   print* , '  Using RANGS/GSHHS database - res=',imres,mfill
   imres=imres+1
   
   ! Decision point here: if plotting really big map, drop back to old 
   !    low-res NCAR datasets. If smaller area, use high-res RANGS/GSHHS data.
   if(imres < 4) then

      ! Do solid fill of RANGS/GSHHS data. Use flash buffer 1.
      if(abs(mfill) >= 2) then
         call gflas1(1)
         call mdrgsc (icol,icsf)
         call mdrgsf (imres,xcra,ncra,iama,nama)
         call gflas2
      endif
      
   else
      
      ! Do old low-res fill
      if(abs(mfill) >= 2) then
         ! map fill
         call gflas1(1)
      
         call gsfais (1)              ! force solid fill
         call arinam (iama,300000)    ! initialize the area map
 
         ! Fixes lack of fill at lowest level by adding an all land
         ! box out to the edges of the plot.  The subsequent call
         ! to mapbla changes some of those to water as they should
         ! be.  B.T. Jan 1997
         call mapita (xlat1,xlon1,0,iama,1,1,2)
         call mapita (xlat3,xlon3,1,iama,1,1,2)
         call mapita (xlat2,xlon2,1,iama,1,1,2)
         call mapita (xlat4,xlon4,1,iama,1,1,2)
         call mapita (xlat1,xlon1,1,iama,1,1,2)
         call mapiqa (iama,1,1,2)
         call mapbla (iama)  ! draw the map into the area map
      
         call arscam(iama,xcra,ycra,50000,iaia,igia,10,fill)
         call gflas2
      endif
   endif

   ! Compute thick shadow outlines on filled map. Put in flash 11.
   if(mfill < 0) then
   
      call gflas1 (11)
      
      ic=16
      if(abs(mfill) >= 2) then
         call coloralias_set (iwksta,'shadow0',ic)
      else
         call coloralias_set (iwksta,'shadow1',ic)
      endif
      call gsplci (ic)
      call gslwsc (2.0)
 
      call mplndr ('Earth..3',4)

      if(imres < 4) then      
         icol(1:5)=ic
         call mdrgsc (icol,icsf)
         call mdrgol (imres,xcra,ncra)
      endif
   
      ! close outline buffer 11
      call gflas2
   endif
   
   
   ! Compute regular and RANGS outlines. Put in flash buffer 10
   call gflas1 (10)
   offset=0.001
   offset=0.001
   call mappos (min(1.,px1+offset),min(1.,px2+offset)  &
               ,max(0.,py1-offset),max(0.,py2-offset))

   ! set color index for political outlines
   ic=17
   if(abs(mfill) >= 2) then
       call coloralias_set (iwksta,'bound0',ic)
   else
       call coloralias_set (iwksta,'bound1',ic)
   endif
   call gsplci (ic)
   
   ! line width
   call gslwsc (1.)
   if(mfill == 0) call gslwsc (1.5)

   print*,'============here'
   ! First do regular map outlines to get political boundaries
   call mplndr ('Earth..3',4)
  ! call mapdrw
   
   if(imres < 4) then      
      ! Add outlines of the RANGS/GSHHS data.
      icol(1:5)=ic
      call mdrgsc (icol,icsf)
      call mdrgol (imres,xcra,ncra)
   endif
   
   ! close outline buffer 10
   call gflas2()
   
   

   
   call getset (ppx1,ppx2,ppy1,ppy2,xx1,xx2,yy1,yy2,ittt)

   ! Save basic map parameters
   xt1o=xt1
   xt2o=xt2
   yt1o=yt1
   yt2o=yt2
   plato=platn
   plono=plonn
   mfillo=mfill
   py1o=py1
   
endif

call gslwsc (1.)

return
end


! User routine to eliminate coastal outines from Earth..x
subroutine mpchln (iact,ilty,ioal,ioar,npts,pnts)

integer :: imres
common/mp_misc/imres

if(imres >= 4) return

if (ilty == 1) npts=0

return
end

!***************************************************************************

subroutine RAMS_sendmap (imap)

! gflash map

implicit none

integer :: imap

!print*,'gflashing',imap
call gflas3 (imap)

return
end

!***************************************************************************

subroutine RAMS_sendroads ()

common/misc/iroads

if(iroads == 1) then
   !call lndmrk(1,0)
   call dcw_map (1,0,0.,0.,0.,0.)
endif

!call drawroads(1,imap)
!call drawbuild(1,imap)

return
end

!***************************************************************************

subroutine fill (xwrk,ywrk,nwrk,iarea,igrp,ngrps)

implicit none

! Fills the area map

integer :: nwrk, ngrps
integer :: iarea(ngrps),igrp(ngrps)
real    :: xwrk(nwrk),ywrk(nwrk)

integer :: idmap,i,mapaci

! Ignore current region if it is defined by 2 or fewer points
if(nwrk <= 3) return

! Get area ID -- group ID of 1 == map info
!  New for NCARG 4.2????  return if any iarea's are -1
idmap=-1
do i=1,ngrps
   if(iarea(i) == -1) return
   if(igrp(i) == 1) idmap=iarea(i)
enddo

! Fill the region with appropriate color
if(idmap > 0) then
   if(mapaci(idmap) == 1) then
      !call colortab_ind ('water',ic) !!!! These were set in mkmap
      call gsfaci(11)
      call gfa(nwrk-1,xwrk,ywrk)
   else
      !call colortab_ind ('land',ic) !!!! These were set in mkmap
      call gsfaci(12)
      call gfa(nwrk-1,xwrk,ywrk)
   endif
endif

return
end

!***************************************************************************

subroutine drawroads (iflash,detlev)

integer detlev,segnum,detail
real lat,lon
character mapfile*100

ierr=0

if(detlev > 1) goto 9000

!call gqplci(ierr,ioldci)
!call gsplci(12)

if(iflash == 1) then
   !print*,'gflash-ing roads'
   call gflas3(2)
else
   call gflas1(2)
   ! Open the road map file
   !call fegetenv('MAP_ROADS',mapfile,ierr)
   if(ierr /= 0) then
      print *, 'mkmap error: Cannot get road map file name'
      stop 404
   endif
   open(unit=92,file=mapfile,status='old',err=1)
   goto 100
   1 print *, 'mkmap error: Cannot open road map file: ',mapfile
   stop 405

   100 continue
   read(92,101,end=200) segnum,detail,xmin,xmax,ymin,ymax
   101 format(2i10.0,//,4f10.0)

   !if(detail <= detlev) then
   if(detail >= 0) then
      !print *, 'Drawing segnum ',segnum,' detail ',detail
      read(92,*,end=200)a,b,lat,lon
      call mapit(lat,lon,0)

      110 read(92,*) a,b,lat,lon

      if(a == -9999.) then
         call mapiq
      else if(a == 1.) then
         call mapiq
         read(92,*,end=200) a,b,lat,lon
         call mapit(lat,lon,0)
         goto 110
      else
         call mapit(lat,lon,1)
         goto 110
      endif
   else
      !print *, 'Skipping segnum ',segnum,' detail ',detail
      120 read(92,*) a,b,lat,lon
      if(a /= -9999.) goto 120
   endif

   goto 100

   200 continue
   close(92)
   call gflas2
   !bob: I think this should be off here: call gflas3(2)
endif

!call gsplci(ioldci)

9000 return
end

!***************************************************************************

subroutine drawbuild (iflash,detlev)

integer detlev,detail
real lat,lon
character mapfile*100

ierr=0

if(detlev > 1) goto 9000

!call gqplci(ierr,ioldci)
!call gsplci(4)

if(iflash == 1) then
   !print*,'gflash-ing buildings'
   call gflas3(3)
else
   call gflas1(3)
   ! Open the building map file
   !call fegetenv('MAP_BUILDINGS',mapfile,ierr)
   if (ierr  /=  0) then
      print *, 'mkmap error: Cannot get building map file name'
      stop 404
   endif
   open(unit=92,file=mapfile,status='old',err=1)
   goto 100
   1 print *, 'mkmap error: Cannot open building map file: ',mapfile
   stop 405

   100 continue
   read(92,101,end=200) detail
   if(detail < 0) goto 200
   101 format(i10.0)
   read(92,*)

   !if (detail  >=  detlev) then
   if(detail >= 0) then
      ! DO THE FIRST POINT
      read(92,*,end=200)a,b,lat,lon
      !print *,'first point ',lat,lon
      call mapit(lat,lon,0)

      110 read(92,*) a,b,lat,lon
      if(a == -9999.) then
         call mapiq
         goto 100
      else
         call mapit(lat,lon,1)
         goto 110
      endif
   else
      120 read(92,*) a,b,lat,lon
      if(a /= -1.) goto 120
   endif

   goto 100

   200 continue
   close(92)
   call gflas2
   !bob: I think this should be off here:        call gflas3(3)
endif

!call gsplci(ioldci)

9000 return
end

!***************************************************************************

subroutine lndmrk (iflash,detlev)

integer detlev,detail
real lat,lon
character mapfile*100
character line*80, alatlon*15,name*80, ns*1, ew*1

ierr=0

if(detlev > 1) goto 9000

!call gqplci(ierr,ioldci)
!call gsplci(4)

if(iflash == 1) then
   !print*,'gflash-ing landmarks'
   call gflas3(4)
else
   call gflas1(4)
   ! Open the landmarks file
   !call fegetenv('MAP_BUILDINGS',mapfile,ierr)
   if(ierr /= 0) then
      print *, 'mkmap error: Cannot get building map file name'
      stop 404
   endif
   !open(unit=92,file=mapfile,status='old',err=1)
   open(unit=92,file='new_mexico',status='old',err=1)
   goto 100
   1 print *, 'mkmap error: Cannot open landmarks file: ',lndmrkfl
   stop 405

   100 continue
   read(92,'(a80)',end=200) line

   read(line,105,err=106)istate,icnty,ityp,alatlon,ipop,ielev,name
   105 format(i2,i3,i4,a15,i8,i7,a80)
   106 continue
   if(detail < 0) goto 200

   do ic=1,80
      if( name(ic:ic+1) == '  ') goto 107
   enddo
   107 continue
   lc=ic-1

   read(alatlon,'(3i2,a1,i3,2i2,a1)')llat,latm,lats,ns,llon,lonm,lons,ew
   alat=real(llat)+real(latm)/60.+real(lats)/3600.
   alon=real(llon)+real(lonm)/60.+real(lons)/3600.
   if(ns == 'S') alat=-alat
   if(ew == 'W') alon=-alon

   if(detail >= 0) then
      call maptra(alat,alon,xpos,ypos)
      size=0.0075
      angd=0.
      cntr=-1
      if(xpos < 999.0.and.ypos < 999.0) then
         if(ityp == 44.or.ityp == 55) then
            call plchlq (xpos,ypos,name(1:lc),size,angd,cntr)
            !print*,'plt sta@lat,lon=',name(1:lc),alat,alon,xpos,ypos
         !else
            !print*,'not plotting',ityp,name(1:lc)
         endif
      endif
      goto 100
   endif

   200 continue

  close(92)
  call gflas2
  call gflas3(4)

endif

!call gsplci(ioldci)

9000 return
end

!***************************************************************************

subroutine dcw_map (iflash,detlev,xlat1,xlat2,xlon1,xlon2)

integer detlev,detail
character*1 clat, clon
character*80 sdir, iname

ierr=0

if(detlev > 1) goto 9000

!call gqplci(ierr,ioldci)
!call gsplci(4)

if(iflash == 1) then
   !print*,'gflash-ing dcw'
   call gflas3(4)
else
   call gflas1(4)
   ! Open the DCW database

   !========================================
   ! Selecting high resolution tiles to read

   !xminm=-175. ;xmaxm=0. ;yminm=0. ;ymaxm=90.
   !xminm=mod(xlon1,5.)*5.
   !xmaxm=mod(xlon2,5.)*5.
   !yminm=mod(xlat1,5.)*5.
   !ymaxm=mod(xlat2,5.)*5.
   xminm=xlon1
   xmaxm=xlon2
   yminm=xlat1
   ymaxm=xlat2
   !print*,'xlat1....=',xlat1,xlat2,xlon1,xlon2
   !print*,'xlmin....=',yminm,ymaxm,xminm,xmaxm

   imin=int(xminm/5.0)
   if(xminm < 0) imin=imin-1
   imax=int(xmaxm/5.0-1.e-6)
   if(xmaxm < 0) imax=imax-1
   jmin=int(yminm/5.0)
   if(yminm < 0) jmin=jmin-1
   jmax=int(ymaxm/5.0-1.e-6)
   if(ymaxm < 0) jmax=jmax-1

   jmin=max0(jmin,-13)

   !==========================================================
   ! Looping for tiles and building high resolution file names

   do jj=jmin,jmax
  
      if(jj == -13) then
         lat0=-90
      else
         lat0=5*jj
      endif

      if(lat0 >= 0) then
         clat='n'
      else
         clat='s'
      endif

      if(jj == -13) then
         i1=int(xmin/90.0)
         i2=int(xmax/90.0-1.e-6)
         klon=90
      else
         i1=imin
         i2=imax
         klon=5
      endif

      !print*,'i1,i2=',i1,i2
      do ii=i1,i2
 
         lon0=klon*ii
         if(lon0 >= 0) then
            clon='e'
         else
            clon='w'
         endif

         call fegetenv('DCW_DATADIR',sdir,ierr)
         if(ierr == 1) goto 210
 
         nchs=index(sdir,' ')-1
         !nchs = LEN(TRIM(sdir))

         ! Basic map segements
         !print*,'Basic map segements'
         write(iname,200) sdir(1:nchs),clon,iabs(lon0),clat,iabs(lat0),'.po'
         !call read_dcw(iname)

         ! Road segements
         !print*,'Road segements'
         write(iname,200) sdir(1:nchs),clon,iabs(lon0),clat,iabs(lat0),'.rd'
         !call read_dcw(iname)

         ! Railrod map segements
         !print*,'Railrod map segements'
         write(iname,200) sdir(1:nchs),clon,iabs(lon0),clat,iabs(lat0),'.rr'
         !call read_dcw(iname)

         ! Populated place areas
         !print*,'Populated place areas'
         write(iname,200) sdir(1:nchs),clon,iabs(lon0),clat,iabs(lat0),'.pp'
         !call read_dcw(iname)

         ! Airports symbols/text
         !print*,'Airports symbols/text'
         write(iname,200) sdir(1:nchs),clon,iabs(lon0),clat,iabs(lat0),'.apt'
         !call read_dcw(iname)

         ! Populated places symbols/text
         !print*,'Populated places symbols/text'
         write(iname,200) sdir(1:nchs),clon,iabs(lon0),clat,iabs(lat0),'.ppt'
         !call read_dcw(iname)
 
         200 format(a,'/',a,i3.3,a,i2.2,a)

         210 continue

      enddo
   enddo

   !===========================
   !  Low resolution file names
  
   ! Basic map segements
   !print*,'Basic map segements'
   iname = sdir(1:nchs)//'/browse.po'
   !print*,iname

   ! Populated places symbols/text
   !print*,'Populated places symbols/text'
   iname = sdir(1:nchs)//'/browse.ppt'
   !print*,iname

   !=============================
   !if (detail  >=  0) then
   !    call maptra(alat,alon,xpos,ypos)
   !    size=0.0075;angd=0.;cntr=-1
   !    if(xpos < 999.0.and.ypos < 999.0)then
   !      if(ityp == 44.or.ityp == 55)then
   !        call plchlq (xpos,ypos,name(1:lc),size,angd,cntr)
   !        print*,'plt sta@lat,lon=',name(1:lc),alat,alon,xpos,ypos
   !      else
   !        print*,'not plotting',ityp,name(1:lc)
   !      endif
   !    endif
   !    goto 100
   !endif

   close(92)
   call gflas2
   !call gflas3(4)

endif

!call gsplci(ioldci)

9000 return
end

!***************************************************************************

subroutine read_dcw (iname)

character*(*) iname
dimension yr(10000), xr(10000)
character*3 ftype
character*80 filename, text
real*4 xmin,ymin

ierr=0

! Opening map files - direct access 1 word/record

1000 continue

lun_tmp=27
filename=iname
lch=lastchar(filename)
!print*,'about to open filename=',filename(1:lch)

idot=index(filename,'.')
ftype=filename(idot+1:idot+3)

! Specify the record length in bytes, with 4 bytes/word
if(ftype == 'po '.or.ftype == 'rd '.or.ftype == 'rr '.or.ftype == 'pp ') then
!  Map segements and area files
   ireclen = 1
   !print*,'ftype,irecl,MACHLEN=',ftype,ireclen,IRAN_RECSIZE()
elseif(ftype == 'ppt') then
!  Populated places text/symbol files
   ireclen = 12
   !print*,'ftype,irecl,MACHLEN=',ftype,ireclen,IRAN_RECSIZE()
else
!  All other text/symbol files
   ireclen=16
   !print*,'ftype,irecl,MACHLEN=',ftype,ireclen,IRAN_RECSIZE()
endif

ireclen=ireclen*IRAN_RECSIZE()

open(unit=lun_tmp,file=filename(1:lch),access='direct'  &
    ,recl=ireclen, form='unformatted',status='old',iostat=ierr)

!if(ierr /= 0) print*,'not finding file ',filename(1:lch)

IF(FTYPE == 'po '.OR.FTYPE == 'rd '.OR.FTYPE == 'rr '.or.ftype == 'pp ') then
                 
!=====================================
!  Reading line segment and area files

!  File Header

   read(lun_tmp,rec=1,err=210) nseg        ! Number of segments/areas in file
   !print*,'nseg=',nseg
   call swap32(nseg,1)
   read(lun_tmp,rec=2,err=210) xmin        ! S/W corner of file
   !print*,'xmin=',xmin
   call swap32(xmin,1)
   read(lun_tmp,rec=3,err=210) ymin
   !print*,'ymin=',ymin
   call swap32(ymin,1)
   !print*,'nseg,xmin,ymin=',nseg,xmin,ymin

   irec = 3

!  Read segments

! mjb problem in here on origin

   !print*,'nsegs',nseg
   do i=1,nseg
      !print*,'nseg',i
      irec=irec+1
      read(lun_tmp,rec=irec,err=110) n        ! Number of points in segment/area
      !print*,'irec,n:',irec,n
      call swap32(n,1)
      !print*,'irec,n:',irec,n
      irec=irec+1
      read(lun_tmp,rec=irec,err=110) itype    ! Segment type - used to set color
      call swap32(itype,1)
      !print*,'irec,itype:',irec,itype
                                              ! of line or area fill type
      do j=1,n
         irec=irec+1
         read(lun_tmp,rec=irec,err=110) xr(j) ! X coordinate of jth point
         call swap32(xr(j),1)
         irec=irec+1
         read(lun_tmp,rec=irec,err=110) yr(j) ! Y coordinate of jth point
         call swap32(yr(j),1)
         !print*,'num,xr,yr=',j,xr(j),yr(j)
 
!        Draw the roads

         if(j == 1) then
            call mapit(yr(j),xr(j),0)
         else
            call mapit(yr(j),xr(j),1)
         endif
      enddo

   enddo

else

!===========================
!  Reading text/symbol files

!  File Header - Number of text items and S/W corner of tile

   read(lun_tmp,rec=1,err=210) ntxt,xmin,ymin
   call swap32(ntxt,1)
   call swap32(xmin,1)
   call swap32(ymin,1)
   !print*,'ntxt,xmin,ymin=',ntxt,xmin,ymin

   irec = 1

!  Set maximum text length

   if(ireclen  ==  16*4) then
      ncht=50
   else
      ncht=40
   endif

!  Read text items
!       x     = x coordinate
!       y     = y coordinate
!       itype = color/symbol indicator
!       text  = text string

   do i=1,ntxt
      irec=irec+1
      if(ireclen == 16*4) then
         read(lun_tmp,rec=irec,err=110) x,y,ityp,text(1:ncht)
         call swap32(x,1)
         call swap32(y,1)
         call swap32(ityp,1)
         !print*,'x,y,ityp,text=',x,y,ityp,text(1:ncht)
      else
         read(lun_tmp,rec=irec,err=110) x,y,text(1:ncht)
         call swap32(x,1)
         call swap32(y,1)
         ityp=0
         !print*,'x,y,text=',x,y,text(1:ncht)
      endif
 
      if(detail >= 0) then
         call maptra(y,x,xpos,ypos)
         !print*,'y,x,xpos,ypos=',y,x,xpos,ypos
         size=0.0075
         angd=0.
         cntr=-1
         if(xpos < 999.0.and.ypos < 999.0) then
            call plchlq (xpos,ypos,text(1:ncht),size,angd,cntr)
            !print*,'plt sta@lat,lon=',text(1:ncht),y,x,xpos,ypos
         endif
      endif
 
   enddo
 
endif

210 return
110 stop 110

return
end

!***************************************************************************

subroutine swap16 (a,n)

! reverse order of two bytes in integer*2

integer * 2  a(n)
integer * 2  itemp
character*1  jtemp(2)
character*1  ktemp

equivalence  (itemp,jtemp(1))

do i=1,n
   itemp    = a(i)
   ktemp    = jtemp(1)
   jtemp(1) = jtemp(2)
   jtemp(2) = ktemp
   a(i)     = itemp
enddo

return
end

!***************************************************************************

subroutine swap32 (a,n)

! reverse order of bytes in integer*4 word, or real*4

integer*4   a(n)
integer*4   itemp

character*1 jtemp(4)
character*1 ktemp

equivalence (jtemp(1),itemp)

do i=1,n
  itemp    = a(i)
  ktemp    = jtemp(4)
  jtemp(4) = jtemp(1)
  jtemp(1) = ktemp
  ktemp    = jtemp(3)
  jtemp(3) = jtemp(2)
  jtemp(2) = ktemp
  a(i)     = itemp
enddo

return
end

!***************************************************************************

subroutine swap64 (a,n)

! reverse order of eight bytes in real*8 word

real*8      a(n)
real*8      itemp

character*1 jtemp(8)
character*1 ktemp

equivalence (jtemp(1),itemp)

do i = 1,n
  itemp    = a(i)
  ktemp    = jtemp(8)
  jtemp(8) = jtemp(1)
  jtemp(1) = ktemp
  ktemp    = jtemp(7)
  jtemp(7) = jtemp(2)
  jtemp(2) = ktemp
  ktemp    = jtemp(6)
  jtemp(6) = jtemp(3)
  jtemp(3) = ktemp
  ktemp    = jtemp(5)
  jtemp(5) = jtemp(4)
  jtemp(4) = ktemp
  a(i)     = itemp
enddo

return
end

