!############################# Change Log ##################################
! 3.0.0
!
!
!###########################################################################
!  Copyright (C)  2002 - All Rights Reserved
!  ATMET, LLC
!###########################################################################

subroutine pl_driver ()
                     
use an_header
use pl_params
use pl_arrays

use ra_file_info

implicit none

include 'interface.h'

character(len=100) :: listvar,str_grids
character(len=256) :: flnm
character(len=80)  :: cfile,hfiles(100),errmess
character(len=16)  :: cinfo

real, dimension(1000) :: xmplot,xtplot,ymplot,ytplot
integer :: ngrx,ngry,ngrz

real :: xx1,xx2,yy1,yy2,boxtop,boxhite,xdist,ydist,vioff,vjoff

integer :: itime,idate,ittt,icmp,ng,ivtype,iovtype,i,j,k,mfill_now
integer :: nf,nval,lenhf,nv,nvgr,nnnn,iu,iuu,iv,ivv,ipts(3),npt,n

integer, external ::  ichvar_changed,intvar_changed

integer,save :: ncall=0,ncall2=0,icfile,icfilen,icgrid,icplotinfo,icvar,iocvar  &
               ,icwinds,ictrans,iccoor,iciwoff,ireload=1,nfl
               
character(len=1), save :: cddel=';'

print*,'pld:0:anpref:',anpref,'--------'

! Get basic file list and parameters if initial call
if (ireload == 1 ) then
   call ra_init (nfl,anpref)
   ireload=0
endif
print*,'back from ra_init'

! Start checking input paramaters and set flags to see if values 
!    have changed since the last call to the routine

!  icfile - if file time has changed
icfile=ichvar_changed('ctime',ctime)
read(ctime,*) nf

call ra_set_file(1,nf)

call ra_get_cdata (0,flnm,nval)
f(idfile)%flnm = flnm


lenhf=len_trim(f(idfile)%flnm)
cfile = f(idfile)%flnm(1:lenhf-9)
f(idfile)%flnm_base = cfile

!  icfilen - if file name has changed (can happen on a Ringi Load)
icfilen=ichvar_changed('cfile',cfile)
if(icfilen == 1) icfile=1

print*,'pld:1',icfile,ctime,cfile,itrans
if(icfile == 1 .or. ncall == 0) then
   ! if file name changed or first time, read header file info and commons.
   !   This is really only here for Ringi Load or if ngrids changes during run.
   ncall = 1
   call rams_read_header ( flnm=trim(f(idfile)%flnm_base), action='read' )
   print*,'pld:1a'
   
   ! Allocate new arrays 
   
   call pl_fill_coords_rams(1)
   print*,'pld:1b'

   call pl_comp_mem(1)
   print*,'pld:1c'
   
   call alloc_pl_arrays(1)
   print*,'pld:1d'
   
endif

! The grid we want...convert char grid number to int
read(cgrid,*) nvgr

f(idfile)%nvgr = nvgr

print*,'pld:1a',nvgr,f(idfile)%nvgr,f(idfile)%nnxp(nvgr),csize(1)
                    
! More flags to see if things have changed since last call:
!     icgrid - grid number            ; icplotinfo - what info???
!     icvar - primary var name        ; iocvar - secondary var name
!     icwinds - whether to plot winds ; ictrans - vertical coord transfor
!     iccoor - slab coordinate        ; iciwoff - main 2d window offsets

icgrid=ichvar_changed('cgrid',cgrid)
icplotinfo=intvar_changed('iplotinfo',ipinfo)
icvar=ichvar_changed('cvar',cvar(1))
iocvar=ichvar_changed('ocvar',cvar(2))
icwinds=ichvar_changed('cwinds',cwinds)
ictrans=intvar_changed('itrans',itrans)
iccoor=intvar_changed('icoor',icoor)
iciwoff=intvar_changed('niboff',niboff)  &
       +intvar_changed('nieoff',nieoff)  &
       +intvar_changed('njboff',njboff)  &
       +intvar_changed('njeoff',njeoff)
print*,'pld:2',nvgr,f(idfile)%nvgr,f(idfile)%nnxp(nvgr),cvar(1)

!  Read in the fields for this plot

call read_pl_fields(1,cvar(1),icfile,icgrid,ictrans,iccoor,icvar  &
            ,cwinds,icwinds,itrans)

ivtype=f(idfile)%vars(1)%ivartype
iovtype=f(idfile)%vars(2)%ivartype

print*,'************:',ivtype,iovtype

if(cvar(1)(1:4) /= 'none' ) then
   if (ivtype == 0) then
      errmess='Primary variable not found -'//trim(cvar(1))
      go to 300
   elseif (ivtype == -1) then
      errmess='Primary variable file not found -'//trim(cvar(1))
      call error_mess(errmess)
      goto 310
   endif
endif
if(cvar(2)(1:4) /= 'none' ) then
   if (iovtype == 0) then
      errmess='Secondary variable not found -'//trim(cvar(2))
      go to 300
   elseif (iovtype == -1) then
      errmess='Secondary variable file not found -'//trim(cvar(2))
      call error_mess(errmess)
      goto 310
   endif
endif


print*,'pld:2a',ivtype,iovtype,islab,f(idfile)%nnxp(nvgr)

! Set the actual grid point coords for this plot, taking into account 
!    offsets, transformation type (sigmaz, p, cartesian), 
!    and variable type (for the damn LEAF tile plots!).

call set_gpoint_coords(horiz,vert,ivtype,itrans,islab,icoor  &
                       ,f(idfile)%nnxp(nvgr),f(idfile)%nnyp(nvgr),f(idfile)%nnzp(nvgr) &
                       ,f(idfile)%nzg,f(idfile)%nzs,nplevs &
                       ,nib,nie,niboff,nieoff  &
                       ,njb,nje,njboff,njeoff  &
                       ,nnb,nne,nnboff,nneoff, nii,njj,nnn )

print*,'pld:3',niboff,nieoff,njboff,njeoff
print*,'pld:3',nib,nie,njb,nje

! Exit cleanly if grid too small to view
if((nii <= 1.and.ngrx > 1).or.(nii < 1.and.ngrx == 1)) then
   print*,'Warning: Selected grid too small in x direction'
   goto 301
endif
if((njj <= 1.and.ngry > 1).or.(njj < 1.and.ngry == 1)) then
   print*,'Warning: Selected grid too small in y direction'
   goto 302
endif



! Theoretically, eveything we will be plotting is now read, converted,
!    interpolated. Next we slice!

call slice_pl_fields(1,nib,nie,njb,nje,icoor,nii,njj  &
                    ,cvar,cwinds,islab,icoord)
print*,'pld:4',ivtype,iovtype

! We have actually finished with all the reading and slicing.
!    We can actually plot stuff now!

! Get all info needed for the frame "background", which may include 
!    topography, land fraction, and who knows what else at this point!

call framset (horiz,vert,xmplot(1),xtplot(1),ymplot(1),ytplot(1)  &
             ,f(idfile)%xmn(1,nvgr),f(idfile)%ymn(1,nvgr),f(idfile)%zmn(1,nvgr)  &
             ,f(idfile)%xtn(1,nvgr),f(idfile)%ytn(1,nvgr),f(idfile)%ztn(1,nvgr)  &
             ,f(idfile)%slz(1),f(idfile)%vars(f(idfile)%iv_topo)%arr(1)  &
             ,f(idfile)%nnxp(nvgr),f(idfile)%nnyp(nvgr)  &
             ,f(idfile)%zmn(f(idfile)%nnzp(nvgr)-1,nvgr),nii,njj  &
             ,icoord  &
             ,ivtype,f(idfile)%vars(f(idfile)%iv_pctlnd)%arr(1)  &
             ,f(idfile)%vars(f(idfile)%iv_topta)%arr(1))

print*,'pld:5',ivtype,iovtype,csize(1)

! Set the actual frame plotting coordinates, based on number of panels,
!    whether the colorbar is drawn, and whatever the hell ipinfo is!

call set_frame_window (px1,px2,py1,py2,vioff,vjoff,vert)


! Get data and time for labels
call ra_get_idata (3,nvgr,itime,nnnn)
call ra_get_idata (2,nvgr,idate,nnnn)

call setframe ()  ! not sure why we have to do this, really does a clear procedure.
print*,'pld:6',ivtype,iovtype,mfill,csize(1)


! Call the various routines to perform actual plotting of the frame elements.
!    Depending on how things are filled, there is an order-dependence as 
!    on how things are put in the metafile.


! Compute the map background
if (islab == 3 .and. abs(mfill) > 0) then
   call RAMS_mkmap (iwkstation  &
                   ,f(idfile)%platn(nvgr),f(idfile)%plonn(nvgr),xmin  &
                   ,ymin,xmax,ymax  &
                   ,mfill,px1,px2,py1,py2,icplotinfo)
   call getset (px1,px2,py1,py2,xx1,xx2,yy1,yy2,ittt)
   mfill_now=mfill
else
   mfill_now=0
   if(horiz == 'X'.and.vert == 'Y') then
      xdist=xmax-xmin
      ydist=ymax-ymin
      px2=px1+min(px2-px1,(xdist/ydist)*.74)
      py2=py1+(ydist/xdist)*(px2-px1)
   endif
endif
print*,'pld:7',ivtype,iovtype,csize(1),mfill_now

! Plot the filled map
if(abs(mfill_now) >= 2) call RAMS_sendmap(1)
if(abs(mfill_now) == 2) then
   if(mfill_now < 0)      call RAMS_sendmap (11)   ! shadow
   if(abs(mfill_now) > 0) call RAMS_sendmap (10)   ! outline
   if(abs(mfill_now) > 0) call RAMS_sendroads ()   ! other stuff
endif
print*,'pld:8',ivtype,iovtype,mfill_now

!  Plot the background labels
boxtop=py1-0.06
boxhite=0.03
call backlab (horiz,vert,nvgr  &
             ,f(idfile)%xtn(icoor,nvgr),f(idfile)%ytn(icoor,nvgr) &
             ,f(idfile)%ztn(icoor,nvgr)  &
             ,f(idfile)%slz(icoor),itime,idate,f(idfile)%ihtran  &
             ,iplevs(icoor),boxtop,boxhite,ivtype,iovtype,nf)
print*,'pld:9',cvar(1),icover(1),conttyp(1),csize(1)

! Plot contours, tiles and parts

! Plot primary contour field - no fill
if(cvar(1)(1:4) /= 'none'.and.icover(1)==0.and.conttyp(1) == 'c')  &
   call contour (nvgr,1,2,f(idfile)%vars(1)%slab(1)  &
                ,nii,njj,boxtop,boxhite &
                ,f(idfile)%vars(1)%cdname,f(idfile)%vars(1)%cdunits)
                
! Plot primary contour field - filled
if(cvar(1)(1:4) /= 'none'.and.conttyp(1) == 'f')  &
   call contour (nvgr,1,icover(1),f(idfile)%vars(1)%slab(1)  &
                ,nii,njj,boxtop,boxhite &
                ,f(idfile)%vars(1)%cdname,f(idfile)%vars(1)%cdunits)

! Plot primary tiled field
if(cvar(1)(1:4) /= 'none'.and.conttyp(1) == 't')  &
   call tileplot (nvgr,1,f(idfile)%vars(1)%slab(1)  &
                 ,f(idfile)%vars(f(idfile)%iv_parea)%slab(1)  &
                 ,nii,njj,f(idfile)%npatch,xmplot,xtplot,ymplot  &
                 ,ivtype,boxtop,boxhite &
                ,f(idfile)%vars(1)%cdname,f(idfile)%vars(1)%cdunits)
                 
! Plot secondary contour field - no fill
if(cvar(2)(1:4) /= 'none'.and.icover(2)==0.and.conttyp(2) == 'c')  &
   call contour (nvgr,2,2,f(idfile)%vars(2)%slab(1)  &
                ,nii,njj,boxtop,boxhite &
                ,f(idfile)%vars(2)%cdname,f(idfile)%vars(2)%cdunits)

! Plot secondary contour field - filled
if(cvar(2)(1:4) /= 'none'.and.conttyp(2) == 'f')  &
   call contour (nvgr,2,icover(2),f(idfile)%vars(2)%slab(1)  &
                ,nii,njj,ymax,boxtop,boxhite &
                ,f(idfile)%vars(2)%cdname,f(idfile)%vars(2)%cdunits)
                
! Plot secondary tiled field
if(cvar(2)(1:4) /= 'none'.and.conttyp(2) == 't')  &
   call tileplot (nvgr,2,f(idfile)%vars(2)%slab(1)  &
                 ,f(idfile)%vars(f(idfile)%iv_parea)%slab(1)  &
                 ,nii,njj,f(idfile)%npatch,xmplot,xtplot,ymplot  &
                 ,ivtype,boxtop,boxhite &
                ,f(idfile)%vars(2)%cdname,f(idfile)%vars(2)%cdunits)

! Plot primary contour field - no fill
if(cvar(1)(1:4) /= 'none'.and.icover(1)==1.and.  &
   (conttyp(1) == 'c'.or.conttyp(1) == 'f'))  &
   call contour (nvgr,1,2,f(idfile)%vars(1)%slab(1)  &
                ,nii,njj,boxtop,boxhite &
                ,f(idfile)%vars(1)%cdname,f(idfile)%vars(1)%cdunits)

! Plot secondary contour field - no fill
if(cvar(2)(1:4) /= 'none'.and.icover(2)==1.and.  &
   (conttyp(2) == 'c'.or.conttyp(2) == 'f'))  &
   call contour (nvgr,2,2,f(idfile)%vars(2)%slab(1)  &
                ,nii,njj,boxtop,boxhite &
                ,f(idfile)%vars(2)%cdname,f(idfile)%vars(2)%cdunits)

! Plot primary particles
if(cvar(1)(1:4) /= 'none'.and.conttyp(1) == 'a'.or.  &
   conttyp(1) == 's'.or.conttyp(1) == 'l')  &
   call parts (1,icoord  &
              ,f(idfile)%xmn(1,nvgr),f(idfile)%ymn(1,nvgr),f(idfile)%zmn(1,nvgr)  &
              ,f(idfile)%nnxp(nvgr),f(idfile)%nnyp(nvgr),f(idfile)%nnzp(nvgr)  &
              ,boxtop,boxhite  &
              ,f(idfile)%vars(1)%cdname,f(idfile)%vars(1)%cdunits)
    
! Plot secondary particles
if(cvar(2)(1:4) /= 'none'.and.conttyp(2) == 'a'.or.  &
   conttyp(2) == 's'.or.conttyp(2) == 'l')  &
   call parts (2,icoord  &
              ,f(idfile)%xmn(1,nvgr),f(idfile)%ymn(1,nvgr),f(idfile)%zmn(1,nvgr)  &
              ,f(idfile)%nnxp(nvgr),f(idfile)%nnyp(nvgr),f(idfile)%nnzp(nvgr)  &
              ,boxtop,boxhite  &
              ,f(idfile)%vars(2)%cdname,f(idfile)%vars(2)%cdunits)

print*,'pld:10',ivtype,iovtype,csize(1)

! Plot wind vectors, barbs, or streamlines
if(cwinds /= 'n')  then
   if (islab == 1) then
      iu  = f(idfile)%iv_u    ;  iv = f(idfile)%iv_w  
      iuu = f(idfile)%iv_tu  ;  ivv = f(idfile)%iv_tw  
   elseif (islab == 2) then
      iu  = f(idfile)%iv_v    ;  iv = f(idfile)%iv_w  
      iuu = f(nf)%iv_tv  ;  ivv = f(idfile)%iv_tw  
   elseif (islab == 3) then
      iu  = f(idfile)%iv_u    ;  iv = f(idfile)%iv_v  
      iuu = f(idfile)%iv_tu  ;  ivv = f(idfile)%iv_tv
   endif
     
   call windplot (f(idfile)%vars(iu)%slab(1),f(idfile)%vars(iv)%slab(1)  &
                ,nii,njj  &
                ,f(idfile)%vars(2)%slab(1)  &
                ,f(idfile)%vars(2)%cdname,f(idfile)%vars(2)%cdunits  &
                ,boxtop,boxhite,xtplot,ytplot  &
                ,f(idfile)%zmn(f(idfile)%nnzp(nvgr)-1,nvgr)  &
                ,f(idfile)%vars(iuu)%slab(1),f(idfile)%vars(ivv)%slab(1)  &
                ,nvgr,2,vioff,vjoff)
print*,'pld:11',ivtype,iovtype,csize(1)

endif

! Plot the map outlines
if(abs(mfill_now) == 1 .or. abs(mfill_now) == 3) then
   if(mfill_now < 0)      call RAMS_sendmap (11)   ! shadow
   if(abs(mfill_now) > 0) call RAMS_sendmap (10)   ! outline
   if(abs(mfill_now) > 0) call RAMS_sendroads ()   ! other stuff
endif
print*,'pld:12',ivtype,iovtype,csize(1)

! Plot the LANDMARKS
if(islab == 3 .and. landmark(1:4) /= 'none')   &
               call landmks (xx1,xx2,yy1,yy2  &
                            ,idate,itime  &
                            ,nvgr,f(idfile)%ngrids &
                            ,icfile,nf,(xtplot(3)-xtplot(2))  &
                            ,f(idfile)%ztn(icoor,nvgr)  &
             ,f(idfile)%nnxp(nvgr),f(idfile)%nnyp(nvgr)  &
             ,f(idfile)%vars(f(idfile)%iv_topo)%arr(1)  )

! Draw the frame
call framdrw (horiz,vert,xmplot,xtplot,ymplot,ytplot  &
             ,f(idfile)%vars(f(idfile)%iv_topo)%arr(1)  &
             ,f(idfile)%nnxp(nvgr),f(idfile)%nnyp(nvgr)  &
             ,nii,njj  &
             ,icoord  &
             ,f(idfile)%zmn(f(idfile)%nnzp(nvgr)-1,nvgr),ivtype,vioff,vjoff &
             ,f(idfile)%vars(f(idfile)%iv_volt)%slab(1)  &
             ,f(idfile)%if_adap)
             
! Draw the nested grid outlines if requested. Only hooked up for horizontal now.
if(drawgrids(1:3) == 'yes' .and. islab == 3)  &
         call dr_grids(f(idfile)%ngrids,nvgr)

print*,'pld:end',ivtype,iovtype,csize(1)

return

300 continue
call plchhq(.5,.5,trim(errmess),-1.,0.,0.)
return

301 continue
call plchhq(.5,.5,'Selected grid too small in x direction',-1.,0.,0.)
return

302 continue
call plchhq(.5,.5,'Selected grid too small in y direction',-1.,0.,0.)
return
   
310 continue
ivvar=ivvar-1
return
end

!--------------------------------------------------------------------------

subroutine set_frame_window (vioff,vjoff)

use pl_params

implicit none

real :: vioff,vjoff

if(ipanl == 1) then

   px1=.09
   if(ipinfo == 2.or.ipinfo == 3) px1=.01
   
   px2=.99
   if((cvar(1)(1:4) /= 'none'.and.colorbar(1) == 'b').or.  &
      (cvar(2)(1:4) /= 'none'.and.colorbar(2) == 'b'))  &
       px2=.87
   
   py2=.99
   if(ipinfo == 2) py2=.96
   
   py1=.07
   if(ipinfo == 1) py1=.22
   if(ipinfo == 2) py1=.04
   if(ipinfo == 3) py1=.01
   
elseif(ipanl >= 2.and.ipanl<= 4) then

   ipinfo=0
   
   if(mod(ivvar+ipanl-1,ipanl) == 0) then
      px1=0.02 ;  py2=0.972
      px2=0.48 ;  py1=0.524
   elseif(mod(ivvar+ipanl-1,ipanl) == 1) then
      px1=0.52 ;  py2=0.972
      px2=0.98 ;  py1=0.524
   elseif(mod(ivvar+ipanl-1,ipanl) == 2) then
      px1=0.02 ;  py2=0.472
      px2=0.48 ;  py1=0.024
   elseif(mod(ivvar+ipanl-1,ipanl) == 3) then
      px1=0.52 ;  py2=0.472
      px2=0.98 ;  py1=0.024
   endif
   
   if((cvar(1)(1:4) /= 'none'.and.colorbar(1) == 'b') .or.  &
      (cvar(2)(1:4) /= 'none'.and.colorbar(2) == 'b'))   px2=px2-.06
      
   if(cvar(1)(1:4) /= 'none'.and.cvar(2)(1:4) /= 'none') py1=py1+0.01 
     
   vioff=.1
   if (cwinds == 'v'.or.cwinds == 't') vioff=.08
   if (cwinds == 'b') vioff=.07
   
   vjoff=.03
   if(vert == 'Z'.and.cwinds /= 'b') vjoff=.05
   
else
   stop 'read_RAMS: unknown panels for frame'
endif

return
end

!----------------------------------------------------------------------------

subroutine set_gpoint_coords(horiz,vert,ivtype,itrans,islab,icoor  &
                            ,ngrx,ngry,ngrz,nzg,nzs,nplevs &
                            ,nib,nie,niboff,nieoff  &
                            ,njb,nje,njboff,njeoff  &
                            ,nnb,nne,nnboff,nneoff,nii,njj,nnn )

implicit none

integer :: ivtype,itrans,islab,icoor &
           ,ngrx,ngry,ngrz,nzg,nzs,nplevs &
           ,nib,nie,niboff,nieoff  &
           ,njb,nje,njboff,njeoff  &
           ,nnb,nne,nnboff,nneoff, nii,njj,nnn
character(len=1) :: horiz,vert

! Set the actual grid point coords for this plot, taking into account 
!    offsets, transformation type (sigmaz, p, cartesian), 
!    and variable type (for the damn LEAF tile plots!).
!
!  WHAT A MESS!!!

if(islab == 1) then

   horiz='X'
   vert='Z'
   
   if(niboff.le.0) nib=1-niboff
   if(niboff.gt.0) nib=niboff
   nib=max(0,min(nib,ngrx))
   
   if(nieoff.le.0) nie=ngrx+nieoff
   if(nieoff.gt.0) nie=nieoff
   nie=max(nib,min(nie,ngrx))
   
   if(njboff.le.0) njb=1-njboff
   if(njboff.gt.0) njb=njboff
   if(ivtype.le.3.and.itrans == 3) njb=max(0,min(njb,nplevs))
   if(ivtype.le.3.and.itrans /= 3) njb=max(0,min(njb,ngrz))
   if(ivtype==8.or.ivtype==5) njb=max(0,min(njb,nzg))
   if(ivtype==7.or.ivtype==4) njb=max(0,min(njb,nzs))
   if(ivtype==10) njb=max(0,min(njb,nzg+nzs+3))
   if(njeoff.le.0) then
      if(ivtype.le.3.and.itrans == 3) nje=nplevs+njeoff
      if(ivtype.le.3.and.itrans /= 3) nje=ngrz+njeoff
      if(ivtype==8.or.ivtype==5) nje=nzg+njeoff
      if(ivtype==7.or.ivtype==4) nje=nzs+njeoff
      if(ivtype==10) nje=nzg+nzs+3+njeoff
   endif
   if(njeoff.gt.0) nje=njeoff
   if(ivtype.le.3.and.itrans == 3) nje=max(njb,min(nje,nplevs))
   if(ivtype.le.3.and.itrans /= 3) nje=max(njb,min(nje,ngrz))
   if(ivtype==8.or.ivtype==5) nje=max(njb,min(nje,nzg))
   if(ivtype==7.or.ivtype==4) nje=max(njb,min(nje,nzs))
   if(ivtype==10) nje=max(njb,min(nje,nzg+nzs+3))
   
   if(nnboff.le.0) nnb=1-nnboff
   if(nnboff.gt.0) nnb=nnboff
   nnb=max(0,min(nnb,ngry))
   if(nneoff.le.0) nne=ngry+nneoff
   if(nneoff.gt.0) nne=nneoff
   nne=max(nnb,min(nne,ngry))
   
elseif(islab == 2) then

   horiz='Y'
   vert='Z'
   
   if(niboff.le.0) nib=1-niboff
   if(niboff.gt.0) nib=niboff
   nib=max(0,min(nib,ngry))
   if(nieoff.le.0) nie=ngry+nieoff
   if(nieoff.gt.0) nie=nieoff
   nie=max(nib,min(nie,ngry))
   
   if(njboff.le.0) njb=1-njboff
   if(njboff.gt.0) njb=njboff
   if(ivtype.le.3.and.itrans == 3) njb=max(0,min(njb,nplevs))
   if(ivtype.le.3.and.itrans /= 3) njb=max(0,min(njb,ngrz))
   if(ivtype==8.or.ivtype==5) njb=max(0,min(njb,nzg))
   if(ivtype==7.or.ivtype==4) njb=max(0,min(njb,nzs))
   if(ivtype==10) njb=max(0,min(njb,nzg+nzs+3))
   if(njeoff.le.0) then
      if(ivtype.le.3.and.itrans == 3) nje=nplevs+njeoff
      if(ivtype.le.3.and.itrans /= 3) nje=ngrz+njeoff
      if(ivtype==8.or.ivtype==5) nje=nzg+njeoff
      if(ivtype==7.or.ivtype==4) nje=nzs+njeoff
      if(ivtype==10) nje=nzg+nzs+3+njeoff
   endif
   if(njeoff.gt.0) nje=njeoff
   if(ivtype.le.3.and.itrans == 3) nje=max(njb,min(nje,nplevs))
   if(ivtype.le.3.and.itrans /= 3) nje=max(njb,min(nje,ngrz))
   if(ivtype==8.or.ivtype==5) nje=max(njb,min(nje,nzg))
   if(ivtype==7.or.ivtype==4) nje=max(njb,min(nje,nzs))
   if(ivtype==10) nje=max(njb,min(nje,nzg+nzs+3))
   
   if(nnboff.le.0) nnb=1-nnboff
   if(nnboff.gt.0) nnb=nnboff
   nnb=max(0,min(nnb,ngrx))
   if(nneoff.le.0) nne=ngrx+nneoff
   if(nneoff.gt.0) nne=nneoff
   nne=max(nnb,min(nne,ngrx))
   
elseif(islab == 3) then

   horiz='X'
   vert='Y'
   
   if(niboff.le.0) nib=1-niboff
   if(niboff.gt.0) nib=niboff
   nib=max(0,min(nib,ngrx))
   if(nieoff.le.0) nie=ngrx+nieoff
   if(nieoff.gt.0) nie=nieoff
   nie=max(nib,min(nie,ngrx))
   
   if(njboff.le.0) njb=1-njboff
   if(njboff.gt.0) njb=njboff
   njb=max(0,min(njb,ngry))
   if(njeoff.le.0) nje=ngry+njeoff
   if(njeoff.gt.0) nje=njeoff
   nje=max(njb,min(nje,ngry))
   
   if(nnboff.le.0) nnb=1-nnboff
   if(nnboff.gt.0) nnb=nnboff
   if(ivtype.le.3.and.itrans == 3) nnb=max(0,min(nnb,nplevs))
   if(ivtype.le.3.and.itrans /= 3) nnb=max(0,min(nnb,ngrz))
   if(ivtype==8.or.ivtype==5) nnb=max(0,min(nnb,nzg))
   if(ivtype==7.or.ivtype==4) nnb=max(0,min(nnb,nzs))
   if(ivtype==10) nnb=max(0,min(nnb,nzg+nzs+3))
   if(nneoff.le.0) then
      if(ivtype.le.3.and.itrans == 3) nne=nplevs+nneoff
      if(ivtype.le.3.and.itrans /= 3) nne=ngrz+nneoff
      if(ivtype==8.or.ivtype==5) nne=nzg+nneoff
      if(ivtype==7.or.ivtype==4) nne=nzs+nneoff
      if(ivtype==10) nne=nzg+nzs+3+nneoff
   endif
   if(nneoff.gt.0) nne=nneoff
   if(ivtype.le.3.and.itrans == 3) nne=max(nnb,min(nne,nplevs))
   if(ivtype.le.3.and.itrans /= 3) nne=max(nnb,min(nne,ngrz))
   if(ivtype==8.or.ivtype==5) nne=max(nnb,min(nne,nzg))
   if(ivtype==7.or.ivtype==4) nne=max(nnb,min(nne,nzs))
   if(ivtype==10) nne=max(nnb,min(nne,nzg+nzs+3))
   
endif

! Some final grid point numbers
nnb=icoor
nne=icoor
nii=nie-nib+1
njj=nje-njb+1
nnn=nne-nnb+1

print*,'horiz,vert:',horiz,' ',vert
print*,'nib,nie:',nib,nie
print*,'njb,nje:',njb,nje
print*,'nnb,nne:',nnb,nne


return
end
