Module pl_params

! pl_driver (formerly read_RAMS) needs potentially alot of 
!   arguments. Let's put them all in a module to reduce the errors.
!---------------------------------------------------------------------------
integer, parameter :: maxlayers=2,maxframes=30,maxgds=8

! ID for specifying current fileset and filetype
!     Set these constant for now.
integer :: idfile=1
character(len=16) :: typefile='rams'

!!!!!!!!!!!!!! Parameters which control frame - need to be passed from driver !!!!!
character(len=2)  :: cgrid
character(len=5)  :: ctime
character(len=80) :: head1
character(len=256) :: anpref,revpref
character(len=128) :: landmark,colors
character(len=8)   :: lmarkers
character(len=  1) :: horiz,vert
!---------------------------------------------------------------------------
character(len=24), dimension(maxlayers)   :: cvar
character(len=1),  dimension(maxlayers)   :: conttyp,colorbar
character(len=20), dimension(3,maxlayers) :: fillcols
character(len=20), dimension(maxlayers)   :: labcol
character(len=1)                          :: cwinds
character(len=20) :: windcol
character(len=3)  :: drawgrids

integer :: ivvar,itrans  &
          ,niboff,nieoff,njboff,njeoff,nnboff,nneoff  &
          ,niinc,njinc,nninc

integer :: ipanl, ipinfo, mfill,ibgnd
integer :: igrid,iplevel,iztran,icoor,islab


!---------------------------------------------------------------------------
real, dimension(maxlayers)    :: conrinc,conrlo,conrhi,cbias,ccent  &
                                ,cgrad,cthick,csize
real                          :: velomax,stemleng,headleng0,headleng  &
                                ,headang
integer                       :: iwcolor,intwindi,intwindj,ibscale
integer, dimension(maxlayers) :: icmeth,icint,icdash,icline,ichigh,icol  &
                                ,icover
!---------------------------------------------------------------------------
integer           :: ilandlab,itypelandmk
real              :: bufflandmk,sizelandmk,sizelandlab
character(len=20) :: collandmk,collandlab

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!---------------------------------------------------------------------------
! Pressure levels for interpolation.

integer, parameter :: nplevs=11
integer, save :: iplevs(nplevs),zplevz(nplevs)
data iplevs/1000, 925, 850, 700, 500, 400, 300,  250,  200,  150,  100/
data zplevz/100 , 500,1500,3000,5600,7200,9200,10500,11800,14000,16200/

!---------------------------------------------------------------------------
integer :: itbeg,itstep,itend,ixbeg,ixstep,ixend  &
          ,iybeg,iystep,iyend,izbeg,izstep,izend  &
          ,ihbeg,ihstep,ihend,ivbeg,ivstep,ivend  &
          ,inbeg,instep,inend

real    :: xmin,xmax,ymin,ymax,zmin,zmax
real    :: px1,px2,py1,py2
!****************************************************************************
character(len=16) :: action,prog
character(len=2) :: slab_type
integer :: iwkstation=1, islab_coor

integer :: nii,nib,nie,njj,njb,nje,nnn,nnb,nne,icoord


!------- CONPACK transform stuff ---------------------------------------------
integer :: ivtran,izstran
real    :: xlonl,xlonr,ylatb,ylatt,yans
real    :: ztr(1000),zs(1000),zmodtop,zfactor,zuv(1000)
common/trans/itrans,m_cp,n_cp,xlonl,xlonr,ylatb,ylatt,yans
common /trans2/ivtran,ztr,izstran,zs,zmodtop

End Module
