
subroutine rams_read_header(flnm,action,ldata)

use an_header

implicit none

character(len=*) :: flnm
character(len=*), optional :: action
logical, dimension(*), optional :: ldata

character(len=128) :: flnm2
integer :: lenf,nv


if(allocated(anal_table)) deallocate(anal_table)

! open analysis file and read in commons

flnm2=flnm
if(index(flnm2,'-head.txt') == 0) flnm2=trim(flnm)//'-head.txt'
open(10,file=flnm2(1:len_trim(flnm2)),status='old')
read(10,*) nvbtab
allocate (anal_table(nvbtab))
do nv=1,nvbtab
   read(10,*)  anal_table(nv)%string   &
              ,anal_table(nv)%npointer  &
              ,anal_table(nv)%idim_type  &
              ,anal_table(nv)%ngrid  &
              ,anal_table(nv)%nvalues
enddo

! Do some optional activities...
if(present(action)) then

   if(action == 'grid_inv') then
      
      ! grid_inventory: set logical flags if a grid exists at this time...
      
      if(.not.present(ldata)) then
         print*,'rams_read_header: grid_inv action specified, ldata not passed'
         stop 'rams_read_header: no ldata'
      endif
      
      do nv=1,nvbtab
         ldata( anal_table(nv)%ngrid ) = .true.
      enddo
   else
      print*,'rams_read_header: unknown action:',action
      stop 'rams_read_header: unknow action'
   endif

endif  


close(10)


return
end
