!############################# Change Log ##################################
! 1.0.0
!
!###########################################################################
!  Copyright (C)  1990, 1995, 1999, 2000 - All Rights Reserved
!  Regional Atmospheric Modeling System - RAMS
!  Mission Research Corporation / *ASTeR Division
!###########################################################################

program revu_pl

use pscript

use pl_params

implicit none

character(len=81) :: cargs(0:20),cargx
character(len=128) :: revuin
character(len=2)  :: cargv*2
integer :: i,numarg,n
integer, external :: iargc

! argument defaults
revuin='REVU_IN'

! read arguments
numarg=iargc()
do n=0,numarg
   call ugetarg(n,cargx)
   cargs(n)=cargx(1:len_trim(cargx))
enddo
print*
print*,'Starting: ', cargs(0)(1:len_trim(cargs(0)))
print*
if(mod(numarg,2)==1.or.numarg.gt.2) call usage
do n=1,numarg,2
   if(cargs(n)(1:1)=='-') then 
      write(*,'(a5,i2,6a)') 'Args ',nint(float(n+1)/2.)  &
                            ,': ',cargs(n)(1:len_trim(cargs(n)))  &
                            ,' ',cargs(n+1)(1:len_trim(cargs(n+1)))
      if(cargs(n)(1:2)=='-f') then
         if(len_trim(cargs(n+1)).gt.128) then
            print*,'max script filename length = 128 characters'
            call usage
         endif 
         revuin=cargs(n+1)(1:len_trim(cargs(n+1)))
      else
         call usage
      endif
   else
      call usage
   endif
enddo
print*,'Input script file:',revuin(1:len_trim(revuin))

! read the contour.defaults file (only used for ringi)
!      - needs to be in runtime dir
!print*
!call var_defaults_read ('contour.defaults')
!!!! MAY WANT TO USE THIS SOMETIME...

! Call routines to set default values

! Contour/wind/slab/landmarks settings
call continit ()

! Default color table and alias
call default_colors(1)



! Call the main script interpreter
call proc_script(revuin)



print*
print*, 'REVU_pl finished normally'
print*

end

!***************************************************************************

subroutine open_metafile (fname)

use pl_params

implicit none

character(len=*) :: fname

call gopks (6,0)
call ngsetc('ME',fname)

call gopwk (iwkstation,111,1)
call gacwk (iwkstation)

call gopwk(2,112,3)

revpref=fname

print*
print*,'Opened NCAR metafile: ', trim(revpref)
print*

return
end
      
!***************************************************************************

subroutine close_metafile ()

use pl_params

implicit none

! Close metafile and buffer workstation

call gclwk(2)
call gdawk (iwkstation)
call gclwk (iwkstation)
call gclks

print*
print*,'Closed NCAR metafile:', trim(revpref)
print*

return
end
      

!***************************************************************************

subroutine usage ()

implicit none

print*
print*,'USAGE: revu_pl [-f script-filename]'
print*
stop

return
end
      
