!############################# Change Log ##################################
! 2.3.1.4
!
!###########################################################################
!  Copyright (C)  1990, 1995, 1999, 2000 - All Rights Reserved
!  Regional Atmospheric Modeling System - RAMS
!  Mission Research Corporation / *ASTeR Division
!###########################################################################

subroutine tileplot (nngd,ilayer,slab,fracarea  &
                    ,nic,njc,npatch,xmplot,xtplot,ymplot  &
                    ,ivtype,boxtop,boxhite,cdname,cdunits)
use pl_params
use define_colors

implicit none
                    
integer :: nngd,ilayer,nic,njc,npatch,ivtype
real :: boxtop,boxhite
real, dimension(nic,njc,npatch) :: slab,fracarea
real, dimension(*) :: xmplot,xtplot,ymplot
character(len=*) :: cdname,cdunits

integer :: isaf(18),ln,ib,ncn,numboxes,lcdunits,lcdname,i,j,ip  &
          ,ici,ipat,ic,ifllbeg,ndum,iasf(18),imid,icmj,labstep,ii &
          ,ihalfbar
real :: rif(6),rjf(6),ric(7),rjc(7),dst(6),ind(8),yinc,valuelab,box7  &
       ,box5,box3,fracar,fracdist,slb,disty,distx,donedist,conrhi1  &
       ,conrlo1,conrinc1,conrlo2,tilelo,tilehi,sz,cbargap,clabscl  &
       ,step,sszz,cont_levs(100)
character(len=1)  :: cpoint
character(len=80) :: title
character(len=8)  :: number,numbr
character(len=6)  :: tcol
character(len=10) :: cconinc

data iasf /18*1/

! This routine makes tile plots WITH patches

! Turn off the clipping indicator - turned off as didn't hide topo
!call gsclip (0)

! Set all the GKS aspect source flags to "individual"
call gsasf (iasf)

! Force solid fill
call gsfais (1)

call set (px1,px2,py1,py2,xmin,xmax,ymin,ymax,1)

call sfseti ('TYPE OF FILL',0)

if(ivtype.le.5) then
   ipat=1
else
   ipat=npatch
endif

! Find max and min in plotted region of field.  Used for contour scaling
! if conrlo(ilayer) and conrhi(ilayer) = 0

tilelo=1.e15
tilehi=-1.e15
do j=njj,1,-1
   do i=1,nii
      do ip=1,ipat
         if(fracarea(i,j,ip) > 1.e-6 .or. ipat == 1) then
            tilelo=min(tilelo,slab(i,j,ip))
            tilehi=max(tilehi,slab(i,j,ip))
         endif
      enddo
   enddo
enddo
if(abs(tilelo).lt.1.e-20) tilelo=0.
if(abs(tilehi).lt.1.e-20) tilehi=0.
print*,'lo========hi:',tilelo,tilehi

! set tile values. We will specify the high and low since the conpack routines
!  won't handle the patch array correctly 

if(abs(conrlo(ilayer)) < 1.e-10 .and. abs(conrhi(ilayer)) < 1.e-10) then
   conrlo1=tilelo
   conrhi1=tilehi
else
   conrlo1=conrlo(ilayer)
   conrhi1=conrhi(ilayer)
endif

call cont_levels(nii,njj,slab(1,1,1) ,conrlo1 &
               ,conrhi1,conrinc(ilayer),ccent(ilayer)  &
               ,numboxes,cont_levs,imid)
if(numboxes == 0) goto 100

if(numboxes > 46) then
   print*,'WARNING: too many tile fill levels in tileplot for '  &
         ,trim(cvar(ilayer)),' - max=46: ',numboxes
   return
endif

conrinc1=(conrhi1-conrlo1)/float(numboxes)
                   
! set the initial color index
ifllbeg=170
if(icmeth(ilayer) == 0) then
   ! Use default set of colors
   do i=1,numboxes
      write(tcol,'(a4,i2.2)') 'fill',i
      call coloralias_set(iwkstation,tcol,ifllbeg+i)
   enddo
else
   ! compute fill colors based on number of lines
   call fillcolors (ilayer,ifllbeg+1,ifllbeg+imid,ifllbeg+numboxes)
endif

! icmj is used to color-code the labels in the info box.
icmj=160                                    
if(nint(cgrad(ilayer)) < 0) then
   call coloralias_set(iwkstation,labcol(ilayer),icmj)
else
   if(icmeth(ilayer) >= 1 .and. icmeth(ilayer) <= 3) then
      call coloralias_set (iwkstation,fillcols(1,ilayer),icmj) 
   else
      if(imid >  numboxes-imid) &
         call coloralias_set (iwkstation,fillcols(3,ilayer),icmj)
      if(imid <= numboxes-imid) &
         call coloralias_set (iwkstation,fillcols(1,ilayer),icmj)
   endif
endif
if(icmeth(ilayer) == 0) call coloralias_set(iwkstation,'title0',icmj)


if(vert == 'Z' .and. ivtype <= 3) then

   ! Draw tile plot of field with terrain-following coordinate
   ! transformation (i.e., for vertical atmosphere cross section)
   
   do j=njj,1,-1
      if(njb == 1 .and. j == 1) cycle
      do i=1,nii

         rif(1)=xmplot(i)
         rif(2)=xtplot(i)
         rif(3)=xmplot(i+1)
         rif(4)=rif(3)
         rif(5)=rif(2)
         rif(6)=rif(1)

         rjf(1)=ymplot(j)  *(1.-zuv(i)/zmodtop)+zuv(i)
         rjf(2)=ymplot(j)  *(1.-zs(i)/zmodtop)+zs(i)
         rjf(3)=ymplot(j)  *(1.-zuv(i+1)/zmodtop)+zuv(i+1)
         rjf(4)=ymplot(j+1)*(1.-zuv(i+1)/zmodtop)+zuv(i+1)
         rjf(5)=ymplot(j+1)*(1.-zs(i)/zmodtop)+zs(i)
         rjf(6)=ymplot(j+1)*(1.-zuv(i)/zmodtop)+zuv(i)

         do ic=1,6
            ric(ic)=rif(ic)
            rjc(ic)=rjf(ic)
         enddo
         ric(7)=ric(1)
         rjc(7)=rjc(1)
            
         ! plot if within range
         if(slab(i,j,1) >= conrlo1 .and. slab(i,j,1) <= conrhi1) then
         
            ! colors
            slb=max(conrlo1,min(conrhi1,slab(i,j,1)))
            ici=int((slb-conrlo1)/conrinc1)+1+ifllbeg
            
            ! plot
            call sfsgfa (rif,rjf,6,dst,6,ind,8,ici)
            
         endif

      enddo
   enddo

else

   ! Draw tile plot of field without terrain-following coordinate
   ! transformation (i.e., for LEAF-2 variables or for horizontal
   ! atmos plot)
   
   do j=njj,1,-1
      do i=1,nii
         donedist=0.
         distx=xmplot(i+1)-xmplot(i)
         disty=ymplot(j+1)-ymplot(j)
         do ip=1,ipat

            fracar = 1.
            if (ivtype > 5) fracar = fracarea(i,j,ip)

            fracdist=fracar*distx
            rif(1)=max(xmin,xmplot(i)+donedist)
            rif(2)=min(xmax,xmplot(i)+donedist+fracdist)
            rjf(1)=max(ymin,ymplot(j))
            rjf(3)=min(ymax,ymplot(j+1))
            donedist=donedist+fracdist

            rif(3)=rif(2)
            rif(4)=rif(1)
            rif(5)=rif(1)
            rjf(2)=rjf(1)
            rjf(4)=rjf(3)
            rjf(5)=rjf(1)
            
            ! plot if within range
            if(slab(i,j,ip) >= conrlo1 .and. slab(i,j,ip) <= conrhi1) then
            
               ! colors
               slb=max(conrlo1,min(conrhi1,slab(i,j,ip)))
               ici=int((slb-conrlo1)/conrinc1)+1+ifllbeg
               
               ! plot
               call sfsgfa (rif,rjf,4,dst,6,ind,8,ici)
               
            endif

         enddo

         ! this section to outline only grid cells, not patches
         ! the above commented section to outline patches too

         ric(1)=xmplot(i)
         ric(2)=xmplot(i+1)
         ric(3)=ric(2)
         ric(4)=ric(1)
         ric(5)=ric(1)

         rjc(1)=ymplot(j)
         rjc(2)=rjc(1)
         rjc(3)=ymplot(j+1)
         rjc(4)=rjc(3)
         rjc(5)=rjc(1)

      enddo
   enddo
endif

100 continue

   ! Draw boxes for the contour field labels
if(ipinfo == 1) call info_labels(1,'tile',cdname,cdunits,tilelo,tilehi &
         ,conrinc1,clabscl  &
         ,boxtop,boxhite,'title0',labcol(ilayer))


if(ipanl.ne.1) then

   ! Construct the title for multi-panel plots
   
   call set (0.,1.,0.,1.,0.,1.,0.,1.,1)
 
   call gsplci(icmj)
   call gstxci(icmj)

   if(abs(conrinc1).ge.10000.) then
      write(cconinc,'(e8.1)') conrinc1
   elseif(abs(conrinc1).ge.1000.) then
      write(cconinc,'(f6.0)') conrinc1
   elseif(abs(conrinc1).ge.100.) then
      write(cconinc,'(f5.0)') conrinc1
   elseif(abs(conrinc1).ge.10.) then
      write(cconinc,'(f4.0)') conrinc1
   elseif(abs(conrinc1).ge..5) then
      write(cconinc,'(f4.1)') conrinc1
   elseif(abs(conrinc1).ge..05) then
      write(cconinc,'(f5.2)') conrinc1
   else
      write(cconinc,'(e8.1)') conrinc1
   endif
   

   lcdname=len_trim(cdname)-1
   lcdunits=len_trim(cdunits)-1
   title=cdname(1:lcdname)//  &
         ' ['//cconinc(1:len_trim(cconinc))//  &
         ' '//cdunits(1:lcdunits)//']'
          
   if(ilayer==1.or.(ilayer==2.and.cvar(1)(1:4)=='none')) then
      if(ipanl==1) then
         call plchlq (px1,py1-.018,title(1:len_trim(title)),-.8,0.,-1.)
      else
         call plchlq (px1,py1-.01,title(1:len_trim(title)),-.55,0.,-1.)
      endif
   else
      if(ipanl==1) then
         call plchlq (px2,py1-.018,title(1:len_trim(title)),-.8,0.,1.)
      else
         call plchlq (px1,py1-.026,title(1:len_trim(title)),-.55,0.,-1.)
      endif
   endif
          
endif

if(colorbar(ilayer).eq.'b'.and.numboxes.ne.0) then

   ! Draw a color bar for the plot
   ihalfbar=0
   if(colorbar(1) == 'b' .and. cvar(1)(1:4) /= 'none' .and. &
      colorbar(2) == 'b' .and. ilayer <= 2) ihalfbar=ilayer
   
   call draw_colorbar(1,'title0',numboxes,conrlo1,conrinc1,imid  &
         ,px1,px2,py1,py2 &
         ,ipanl,ihalfbar,cdunits,1,ifllbeg)

endif

print*,'Tiled ',trim(cdname)//' ('//trim(cdunits)//')'

return
end
