!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

subroutine hadvect ()
     
use hyp_coms
use mem_met

implicit none


integer :: l,ihp,jhp,khp,mgp,imp,jmp,kmp,itp,jtp,ktp

real ::    rimp,rjmp,rkmp,ritp,rjtp,rktp,topth1,rtgh1,entfac  &
          ,qh200,qh020,qh002  &
          ,qt200,qt020,qt002,qt100,qt010,qt001  &
          ,qm200,qm020,qm002,qm100,qm010,qm001  &
          ,qt111,qt112,qt121,qt122,qt211,qt212,qt221,qt222  &
          ,ulp,vlp,wlp,dsw2,sigu,sigv,sigw,tlulp,tlvlp,tlwlp  &
          ,acu,acv,acw,acu2,acv2,acw2,uppp,vppp,wppp  &
          ,anorm01,wdrift,wplus,wminus,topth2,rtgh2,zstar1,zstar2
real, external :: hifromx
          
integer, save :: ix1=1000,ix2=2000,ix3=3000,ix4=4000
integer, save :: ia=129,ib=1,it=1048576,mm=0

entfac=float(nent-1)/float(it)
mm=mm+1

do l=1,npart

   ! don't do this particle if not active

   if(atp(l)%ncluster == 0) cycle
   
   ! find integer coordinates on h grid, grid number, and h-grid topo and rtg

   ihp=int(atp(l)%hi)
   jhp=int(atp(l)%hj)
   khp=int(atp(l)%hk)

   mgp=hg%mg(ihp,jhp,khp)

   qh200=atp(l)%hi-float(ihp)
   qh020=atp(l)%hj-float(jhp)
   qh002=atp(l)%hk-float(khp)
   topth1=(1.0-qh020)*((1.0-qh200)*hg%topthg(ihp  ,jhp  )  &
                           +qh200 *hg%topthg(ihp+1,jhp  ))  &
              +qh020 *((1.0-qh200)*hg%topthg(ihp  ,jhp+1)  &
                           +qh200 *hg%topthg(ihp+1,jhp+1))
   rtgh1=1.-topth1/ztoph

   ! find floating point and integer locations on nested grids

   rimp=hg%rim(ihp,jhp,khp)+qh200*drim(ihp,mgp)
   rjmp=hg%rjm(ihp,jhp,khp)+qh020*drjm(jhp,mgp)
   rkmp=hg%rkm(ihp,jhp,khp)+qh002*drkm(khp,mgp)

   ritp=rimp+0.5
   rjtp=rjmp+0.5
   rktp=hg%rkt(ihp,jhp,khp)+(atp(l)%hk-float(khp))*drkm(khp,mgp)

   imp=int(rimp)
   jmp=int(rjmp)
   kmp=int(rkmp)

   itp=int(ritp)
   jtp=int(rjtp)
   ktp=int(rktp)

   ! compute interpolation weights for particles on nested grids

   qt200=ritp-float(itp)
   qt020=rjtp-float(jtp)
   qt002=rktp-float(ktp)

   qt100=1.0-qt200
   qt010=1.0-qt020
   qt001=1.0-qt002

   qm200=rimp-float(imp)
   qm020=rjmp-float(jmp)
   qm002=rkmp-float(kmp)

   qm100=1.0-qm200
   qm010=1.0-qm020
   qm001=1.0-qm002

   qt111=qt100*qt010*qt001
   qt112=qt100*qt010*qt002
   qt121=qt100*qt020*qt001
   qt122=qt100*qt020*qt002
   qt211=qt200*qt010*qt001
   qt212=qt200*qt010*qt002
   qt221=qt200*qt020*qt001
   qt222=qt200*qt020*qt002

   !print*,'adv indices:mgp,iuph,ivph,itlwh',mgp,iuph(mgp),ivph(mgp),itlwh(mgp)
   !print*,'advection indices: indu,indv,itlw',indu,indv,itlw

   ! interpolate velocity components, sigmas, and Lagrangian time scales
   !    from nested grid to particle location

   ulp=qm100*(qt010*(qt001*metc(mgp)%u(ktp  ,imp  ,jtp  )  &
                    +qt002*metc(mgp)%u(ktp+1,imp  ,jtp  )) &
             +qt020*(qt001*metc(mgp)%u(ktp  ,imp  ,jtp+1)  &
                    +qt002*metc(mgp)%u(ktp+1,imp  ,jtp+1)))&
      +qm200*(qt010*(qt001*metc(mgp)%u(ktp  ,imp+1,jtp  )  &
                    +qt002*metc(mgp)%u(ktp+1,imp+1,jtp  )) &
             +qt020*(qt001*metc(mgp)%u(ktp  ,imp+1,jtp+1)  &
                    +qt002*metc(mgp)%u(ktp+1,imp+1,jtp+1)))
                    

   vlp=qt100*(qm010*(qt001*metc(mgp)%v(ktp  ,itp  ,jmp  )  &
                    +qt002*metc(mgp)%v(ktp+1,itp  ,jmp  )) &
             +qm020*(qt001*metc(mgp)%v(ktp  ,itp  ,jmp+1)  &
                    +qt002*metc(mgp)%v(ktp+1,itp  ,jmp+1)))&
      +qt200*(qm010*(qt001*metc(mgp)%v(ktp  ,itp+1,jmp  )  &
                    +qt002*metc(mgp)%v(ktp+1,itp+1,jmp  )) &
             +qm020*(qt001*metc(mgp)%v(ktp  ,itp+1,jmp+1)  &
                    +qt002*metc(mgp)%v(ktp+1,itp+1,jmp+1)))

   wlp=qt100*(qt010*(qm001*metc(mgp)%w(kmp  ,itp  ,jtp  )  &
                    +qm002*metc(mgp)%w(kmp+1,itp  ,jtp  )) &
             +qt020*(qm001*metc(mgp)%w(kmp  ,itp  ,jtp+1)  &
                    +qm002*metc(mgp)%w(kmp+1,itp  ,jtp+1)))&
      +qt200*(qt010*(qm001*metc(mgp)%w(kmp  ,itp+1,jtp  )  &
                    +qm002*metc(mgp)%w(kmp+1,itp+1,jtp  )) &
             +qt020*(qm001*metc(mgp)%w(kmp  ,itp+1,jtp+1)  &
                    +qm002*metc(mgp)%w(kmp+1,itp+1,jtp+1)))

   if(l==1) print*,'vels:',ulp,vlp,wlp
   if(l==1) print*,'vels:',mgp,imp,jmp,kmp
   if(l==1) print*,'vels:',mgp,itp,jtp,ktp
   if(l==1) print*,'vels:',rimp,rjmp,rkmp
   if(l==1) print*,'vels:',ritp,rjtp,rktp
   if(l==1) print*,'atps:',atp(l)%hi,atp(l)%hj,atp(l)%hk
   !stop 

   if(ihturb == 1) then

      dsw2=             qt111*metc(mgp)%ds2(ktp  ,itp  ,jtp  )  &
                       +qt112*metc(mgp)%ds2(ktp+1,itp  ,jtp  )  &
                       +qt121*metc(mgp)%ds2(ktp  ,itp  ,jtp+1)  &
                       +qt122*metc(mgp)%ds2(ktp+1,itp  ,jtp+1)  &
                       +qt211*metc(mgp)%ds2(ktp  ,itp+1,jtp  )  &
                       +qt212*metc(mgp)%ds2(ktp+1,itp+1,jtp  )  &
                       +qt221*metc(mgp)%ds2(ktp  ,itp+1,jtp+1)  &
                       +qt222*metc(mgp)%ds2(ktp+1,itp+1,jtp+1)

      sigu=             qt111*metc(mgp)%sigu(ktp  ,itp  ,jtp  )  &
                       +qt112*metc(mgp)%sigu(ktp+1,itp  ,jtp  )  &
                       +qt121*metc(mgp)%sigu(ktp  ,itp  ,jtp+1)  &
                       +qt122*metc(mgp)%sigu(ktp+1,itp  ,jtp+1)  &
                       +qt211*metc(mgp)%sigu(ktp  ,itp+1,jtp  )  &
                       +qt212*metc(mgp)%sigu(ktp+1,itp+1,jtp  )  &
                       +qt221*metc(mgp)%sigu(ktp  ,itp+1,jtp+1)  &
                       +qt222*metc(mgp)%sigu(ktp+1,itp+1,jtp+1)

      sigv=             qt111*metc(mgp)%sigv(ktp  ,itp  ,jtp  )  &
                       +qt112*metc(mgp)%sigv(ktp+1,itp  ,jtp  )  &
                       +qt121*metc(mgp)%sigv(ktp  ,itp  ,jtp+1)  &
                       +qt122*metc(mgp)%sigv(ktp+1,itp  ,jtp+1)  &
                       +qt211*metc(mgp)%sigv(ktp  ,itp+1,jtp  )  &
                       +qt212*metc(mgp)%sigv(ktp+1,itp+1,jtp  )  &
                       +qt221*metc(mgp)%sigv(ktp  ,itp+1,jtp+1)  &
                       +qt222*metc(mgp)%sigv(ktp+1,itp+1,jtp+1)

      sigw=             qt111*metc(mgp)%sigw(ktp  ,itp  ,jtp  )  &
                       +qt112*metc(mgp)%sigw(ktp+1,itp  ,jtp  )  &
                       +qt121*metc(mgp)%sigw(ktp  ,itp  ,jtp+1)  &
                       +qt122*metc(mgp)%sigw(ktp+1,itp  ,jtp+1)  &
                       +qt211*metc(mgp)%sigw(ktp  ,itp+1,jtp  )  &
                       +qt212*metc(mgp)%sigw(ktp+1,itp+1,jtp  )  &
                       +qt221*metc(mgp)%sigw(ktp  ,itp+1,jtp+1)  &
                       +qt222*metc(mgp)%sigw(ktp+1,itp+1,jtp+1)

      tlulp=            qt111*metc(mgp)%tlu(ktp  ,itp  ,jtp  )  &
                       +qt112*metc(mgp)%tlu(ktp+1,itp  ,jtp  )  &
                       +qt121*metc(mgp)%tlu(ktp  ,itp  ,jtp+1)  &
                       +qt122*metc(mgp)%tlu(ktp+1,itp  ,jtp+1)  &
                       +qt211*metc(mgp)%tlu(ktp  ,itp+1,jtp  )  &
                       +qt212*metc(mgp)%tlu(ktp+1,itp+1,jtp  )  &
                       +qt221*metc(mgp)%tlu(ktp  ,itp+1,jtp+1)  &
                       +qt222*metc(mgp)%tlu(ktp+1,itp+1,jtp+1)

      tlvlp=            qt111*metc(mgp)%tlv(ktp  ,itp  ,jtp  )  &
                       +qt112*metc(mgp)%tlv(ktp+1,itp  ,jtp  )  &
                       +qt121*metc(mgp)%tlv(ktp  ,itp  ,jtp+1)  &
                       +qt122*metc(mgp)%tlv(ktp+1,itp  ,jtp+1)  &
                       +qt211*metc(mgp)%tlv(ktp  ,itp+1,jtp  )  &
                       +qt212*metc(mgp)%tlv(ktp+1,itp+1,jtp  )  &
                       +qt221*metc(mgp)%tlv(ktp  ,itp+1,jtp+1)  &
                       +qt222*metc(mgp)%tlv(ktp+1,itp+1,jtp+1)

      tlwlp=            qt111*metc(mgp)%tlw(ktp  ,itp  ,jtp  )  &
                       +qt112*metc(mgp)%tlw(ktp+1,itp  ,jtp  )  &
                       +qt121*metc(mgp)%tlw(ktp  ,itp  ,jtp+1)  &
                       +qt122*metc(mgp)%tlw(ktp+1,itp  ,jtp+1)  &
                       +qt211*metc(mgp)%tlw(ktp  ,itp+1,jtp  )  &
                       +qt212*metc(mgp)%tlw(ktp+1,itp+1,jtp  )  &
                       +qt221*metc(mgp)%tlw(ktp  ,itp+1,jtp+1)  &
                       +qt222*metc(mgp)%tlw(ktp+1,itp+1,jtp+1)
                       
                       
      !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      !      compute turbulent and drift correction velocity
      !    based on sigs and tls, and add to ulp, vlp, and wlp

      !NG
      ! IMPORTANT NOTE

      ! THE SIGMAS COMPUTED IN THE TURBULENCE ROUTINES ARE ACTUALLY
      ! VARIANCES, NOT STANDARD DEVIATIONS. IN THE FOLLOWING THEY
      ! WERE ASSUMED TO BE THE LATTER. TO FIX THIS, PUT

      sigu = sqrt(sigu)
      sigv = sqrt(sigv)
      sigw = sqrt(sigw)

      ! ALSO, DSW2 HAS BEEN CORRECTED IN HTURB.F.

      acu=exp(-dtpart/tlulp)
      acv=exp(-dtpart/tlvlp)
      acw=exp(-dtpart/tlwlp)
      acu2=acu*acu
      acv2=acv*acv
      acw2=acw*acw


      ! compute random turbulent velocity components as products of
      ! normally-distributed random numbers gx and the standard
      ! deviations computed in equation (6).  (THEY ARE NOT STANDARD
      !                                          DEVIATIONS).

      ix1=mod(ia*ix1+ib,it)
      ix2=mod(ia*ix2+ib,it)
      ix3=mod(ia*ix3+ib,it)
      uppp=sigu*sqrt(1.-acu2)*anorm(1+int(entfac*float(ix1)))
      vppp=sigv*sqrt(1.-acv2)*anorm(1+int(entfac*float(ix2)))
      anorm01 = anorm(1+int(entfac*float(ix3)))

      ! NG CHOICE OF RANDOM BIT FOR VERTICAL COMPONENT

      ! ORIGINAL
      wppp=sigw*sqrt(1.-acw2)*anorm01

      ! LINEARISED IN DTPART TO BE CONSISTENT WITH LADM FORMULA.
      ! DTPART MUST BE SMALL, OR PROBS OCCUR NEAR SURFACE. HENCE TWO FORMULA
      ! SHOULD BE ALMOST THE SAME. THE ORIGINAL IS RETAINED.
      !wppp=sigw*sqrt(2.0*dtpart/tlwlp)*anorm01

      ! NG CHOICE OF DRIFT VELOCITY
      ! ORIGINAL (WEAKLY INHOMOGENEOUS ONLY)
      !wdrift=tlwlp*dsw2*(1.-acw) !Careful of dsw2
      !print*,wdrift,tlwlp,dsw2,acw

      ! LADM FORMULA FOR GENERAL INHOMOGENEOUS GAUSSIAN TURBULENCE
      wdrift = dtpart*0.5*dsw2*(1.0 + ( atp(l)%wpp/sigw )**2.)

      !print*,'turb-',l,sigu,sigv,sigw,tlulp,tlvlp,tlwlp,uppp,vppp,wppp,wdrift

      ! DIFFERENT FINITE DIFFERENCES GIVE BETTER RESULTS. DSW2 IS NOW THE
      ! GRADIENT OF THE STANDARD DEVIATION, NOT THE VARIANCE.
      !wdrift=dtpart*sigw*dsw2*(1.0+(atp(l,6)/sigw )**2.)
      !print*,wdrift,dtpart,sigw,dsw2,atp(l,6)

      ! Compute Lagrangian turbulent velocity fluctuation from equation (5).

      atp(l)%upp=atp(l)%upp*acu+uppp
      atp(l)%vpp=atp(l)%vpp*acv+vppp

      !NG CHOICE OF FORM FOR VERTICAL TURBULENT TERM

      ! EITHER
      !-------

      ! SCHEME PROPERLY ALLOWS FOR NON-HOMOGENEOUS GAUSSIAN TURBULENCE IN THE
      ! VERTICAL DIRECTION.
      ! ORIGINAL (NOT INCLUDING DRIFT TERM IN DEFN OF ATP(L,6))
      ! - but the drift term is included later anyway
      !print*,atp(l)%wpp,atp(l)%wpp*acw+wppp,acw,atp(l)%wpp*acw,wppp

      atp(l)%wpp=atp(l)%wpp*acw+wppp

      ! INCLUDING DRIFT TERM IN DEFINITION
      !atp(l)%wpp=atp(l)%wpp*acw+wppp+wdrift
 
      ! LINEARISING IN DTPART FOR CONSISTENCY WITH LADM FORMULA.
      ! NO DIFFERENCE IF DTPART SMALL ENOUGH. IF DTPART TOO BIG, ITS BEST TO
      ! AVOID THE LINEARISED TERM ANYWAY
      !atp(l)%wpp=atp(l)%wpp*(1.0-dtpart/tlwlp)+wppp + wdrift

      !wdrift=0.
 
      ! OR
      !---
 
      ! SKEWED HOMOGENEOUS TURBULENCE - THIS IS INDEPENDENT OF PREVIOUS FORMULAE,
      ! EXCEPT THAT ONLY ONE ATP(L,6) LINE SHOULD EVER BE UN-COMMENTED
      ! Need sigw2, tlagw and hcbl. Just guess at these for now, assuming a
      ! mixing length scale of 100m.
      !sigw2 = 0.0002
      !tlagw = 1.0*100.0/sqrt(sigw2)
      !hcbl = 700.0
      !Sk = 0.8
      !prob = 0.5*(1-(sk**2./(8+sk**2.))**0.5)
      !wplus = sqrt (0.5*sigw2*(1.-prob)/prob)
      !wminus = - wplus*prob/(1.-prob)
      !wturb = atp(l)%wpp
      !gplus = 1./sqrt(sigw2*2.0*3.141592653)*exp(-(wturb-wplus)**2./2./sigw2)
      !gminus = 1./sqrt(sigw2*2.0*3.141592653)*exp(-(wturb-wminus)**2./2./sigw2)
      !aw = - sigw2/tlagw*(prob*gplus*(wturb-wplus)/sigw2 +  &
      !            (1.-prob)*gminus*(wturb-wminus)/sigw2)  &
      !           /(prob*gplus + (1.-prob)*gminus)
      !
      !atp(l)%wpp = wturb+aw*dtpart+sqrt(2.*sigw2*dtpart/tlagw)*anorm01
      !wdrift = 0.00
      ! or
 
      wplus=1.0
      wminus=-1.0

      ! NOTE: HURLEY AND PHYSICK (1991) SAY ADVECTIVE EFFECTS MAY DOMINATE OVER
      ! TRYING TO KEEP THE PARTICLES WELL-MIXED. ADHERING TO THE WELL-MIXED
      ! CONDITION RESTRICTS THE  HYPACT TIME-STEP NEAR TO THE SURFACE (WHERE THE
      ! LAGRANGIAN TIMESCALE IS SMALL). THIS CONFLICTS WITH THE NECESSITY OF
      ! RESOLVING THE SOURCE WELL BY EMITTING MANY PARTICLES PER TIMESTEP.
      ! IT MAY BE PRUDENT TO NOT WORRY ABOUT INHOMOGENEOUS TURBULENCE, AS
      ! (A) 80% OF THE BOUNDARY LAYER HAS ROUGHLY THE SAME SIGMA-W
      ! (B) DISTINCTION IS IMPORTANT NEAR THE SOURCE ONLY. COMPARISONS WITH
      !     MEASUREMENTS IN THE CITY WILL BE WITH NEAR-SOURCE MEASUREMENTS,
      !     BUT EVEN THESE MAY BE DOMINATED BY NEIGHBOURING SOURCES AT
      !     GREATER DISTANCES (WE SHALL SEE).
 
      ! END EITHER/OR
      !--------------

      ! zero out turbulent velocities and drift velocity

   else
      atp(l)%upp=0.
      atp(l)%vpp=0.
      atp(l)%wpp=0.
      wdrift=0.
      wplus=1.0
      wminus=-1.0
   endif

   ! advect particle to new horizontal coordinates

   atp(l)%hi=atp(l)%hi+(ulp+atp(l)%upp)*dtpart*dxhi(ihp)
   
   !rihp2=atp(l)%hi+(ulp+atp(l)%upp)*dtpart*dxhi(ihp)
   !ihp2=int(rihp2)
   !if(ihp2.lt.1.or.ihp2.ge.nih) goto 100
   !atp(l)%hi=rihp2+(rihp2-max(bizon(ihp),bizon(ihp2)))  &
   !        *(dxh(ihp)*dxhi(ihp2)-1.0)
   !atp(l)%hi=max(1.,min(atp(l)%hi,float(nih)))

   atp(l)%hj=atp(l)%hj+(vlp+atp(l)%vpp)*dtpart*dyhi(jhp)
   
   !rjhp2=atp(l)%hj+(vlp+atp(l,5))*dtpart*dyhi(jhp)
   !jhp2=int(rjhp2)
   !if (jhp2.lt.1.or.jhp2.ge.njh) goto 100
   !atp(l)%hj=rjhp2+(rjhp2-max(bjzon(jhp),bjzon(jhp2)))  &
   !        *(dyh(jhp)*dyhi(jhp2)-1.0)
   !atp(l)%hj=max(1.,min(atp(l)%hj,float(njh)))

   ! find new horizontal integer coordinates on h grid, plus h-grid topo

   ihp=int(atp(l)%hi)
   jhp=int(atp(l)%hj)

   ! outside lateral boundary?
   
   if(ihp.lt.1.or.jhp.lt.1.or.ihp.ge.nih.or.jhp.ge.njh) then
      atp(l)%ncluster=0
      if(iwarn==1) print*,'warning - losing particles out sides of domain'
      cycle
   endif

   qh200=atp(l)%hi-float(ihp)
   qh020=atp(l)%hj-float(jhp)
   topth2=(1.0-qh020)*((1.0-qh200)*hg%topthg(ihp  ,jhp  )  &
                           +qh200 *hg%topthg(ihp+1,jhp  ))  &
              +qh020 *((1.0-qh200)*hg%topthg(ihp  ,jhp+1)  &
                           +qh200 *hg%topthg(ihp+1,jhp+1))
   rtgh2=1.-topth2/ztoph

   ! advect particle to new vertical coordinates using h-grid topo info
   
   zstar1=zh(khp)+dzh(khp)*qh002
   zstar2=(zstar1*rtgh1+topth1+(wlp+atp(l)%wpp+wdrift)*dtpart-topth2)/rtgh2

   ! reflect particle if underground and limit to domain top

   ! BOUNDARY CONDITIONS

   ! --Vertical--

   ! ORIGINAL - REFLECT AT SURFACE, BUT STICK TO MODEL DOMAIN TOP!
   !zstar2=min(abs(zstar2),zh(nkh))

   ! allow particles to exit top of domain
   zstar2=abs(zstar2)

   ! NG LOWER BOUNDARY FOR BOTH GAUSSIAN AND SKEWED TURBULENCE
   ! if wplus=1 and wminus=-1, this just reflects at surface
   
   if (zstar2.le.0.0) atp(l)%wpp=atp(l)%wpp*wplus/wminus

   ! NG TOP OF CBL FOR SKEWED TURBULENCE ONLY.
   !if (zstar2.ge.hcbl) atp(l)%wpp=atp(l)%wpp*wminus/wplus

   ! NG SKEWED TURBULENCE - REFLECT AT SURFACE AND TOP OF CBL
   !if (zstar2.le.0.0) zstar2=-zstar2
   !if (zstar2.ge.hcbl) zstar2=2.*hcbl-zstar2

   ! above top boundary?
   
   if(zstar2.gt.zh(nkh)) then
      if(iwarn==1) print*,'warning - losing particles out top of domain'
      atp(l)%ncluster=0
      cycle
   endif

   atp(l)%hk=hifromx(nkh,zh,zstar2)
   khp=int(atp(l)%hk)

   !write(*,'(i8,3(f10.1,i8))') l,atp(l)%hi,nih,atp(l)%hj,njh,atp(l)%hk,nkh
   !write(*,'(i8,2f10.1,i8)') l,zstar2,atp(l)%hk,nkh

enddo

return
end
