!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================

subroutine hgridpts ()

use hyp_coms

ih=0
jh=0
kh=0
do ng=1,ngrh
   in(ng)=1
   jn(ng)=1
   kn(ng)=1
enddo

10 continue
ih=ih+1
xh(ih)=1.e6*delxh(1)
do ng=1,ngrh
   if(xmh(in(ng),ng).lt.xh(ih).and.in(ng).le.nnxh(ng)-1)  &
       xh(ih)=xmh(in(ng),ng)
enddo

do ng=1,ngrh
   if(ih.ge.2.and.in(ng).ge.2.and.in(ng).le.nnxh(ng))drim(ih-1,ng)  &
      =(xh(ih)-xh(ih-1))/(xmh(in(ng),ng)-xmh(in(ng)-1,ng))
   if(xmh(in(ng),ng).lt.xh(ih)+0.01*delxh(ng)  &
      .and.in(ng).le.nnxh(ng)-1)in(ng)=in(ng)+1
enddo
if(xh(ih).lt.xth(nnxh(1)-1,1)) goto 10
nih=ih
xh(nih)=0.99999*xh(nih)+0.00001*xh(nih-1)
bizon(1)=1.

do ih=1,nih-1
   dxh(ih)=xh(ih+1)-xh(ih)
   dxhi(ih)=1.0/dxh(ih)
   if(ih.ge.2)then
      bizon(ih)=bizon(ih-1)
      if(abs(dxh(ih)-dxh(ih-1)).gt.0.01*dxh(ih)) then
         bizon(ih)=float(ih)
      endif
   endif
enddo

20 continue
jh=jh+1
yh(jh)=1.e6*delyh(1)

do ng=1,ngrh
   if(ymh(jn(ng),ng).lt.yh(jh).and.jn(ng).le.nnyh(ng)-1)  &
       yh(jh)=ymh(jn(ng),ng)
enddo

do ng=1,ngrh
   if(jh.ge.2.and.jn(ng).ge.2.and.jn(ng).le.nnyh(ng))drjm(jh-1,ng)  &
      =(yh(jh)-yh(jh-1))/(ymh(jn(ng),ng)-ymh(jn(ng)-1,ng))
   if(ymh(jn(ng),ng).lt.yh(jh)+0.01*delyh(ng)  &

      .and.jn(ng).le.nnyh(ng)-1)jn(ng)=jn(ng)+1
enddo
if(yh(jh).lt.yth(nnyh(1)-1,1)) goto 20
njh=jh
yh(njh)=0.99999*yh(njh)+0.00001*yh(njh-1)
bjzon(1)=1.

do jh=1,njh-1
   dyh(jh)=yh(jh+1)-yh(jh)
   dyhi(jh)=1.0/dyh(jh)
   if(jh.ge.2)then
      bjzon(jh)=bjzon(jh-1)
      if(abs(dyh(jh)-dyh(jh-1)).gt.0.01*dyh(jh)) then
         bjzon(jh)=float(jh)
      endif
   endif
enddo

30 continue
kh=kh+1
zh(kh)=1.e6
do ng=1,ngrh
   if(zmh(kn(ng),ng).lt.zh(kh).and.kn(ng).le.nnzh(ng)-1)  &
       zh(kh)=zmh(kn(ng),ng)
enddo

do ng=1,ngrh
   if(kh.ge.2.and.kn(ng).ge.2.and.kn(ng).le.nnzh(ng))drkm(kh-1,ng)  &

      =(zh(kh)-zh(kh-1))/(zmh(kn(ng),ng)-zmh(kn(ng)-1,ng))
   if(zmh(kn(ng),ng).lt.zh(kh)+0.01*zmh(2,1)  &
      .and.kn(ng).le.nnzh(ng)-1)kn(ng)=kn(ng)+1
enddo
if(zh(kh).lt.zth(nnzh(1)-1,1)) goto 30
nkh=kh
zh(nkh)=0.9999*zh(nkh)+0.0001*zh(nkh-1)

do kh=1,nkh-1
   dzh(kh)=zh(kh+1)-zh(kh)
   dzhi(kh)=1.0/dzh(kh)
   !print*,'zh-',kh,zh(kh),dzh(kh)

enddo

! allocate memory for all h-grid variables

print*,'------------------------------------------------------'
print*,'allocating memory for all h-grid variables'
print*,'------------------------------------------------------'
print*
print*,'h-grid points-',nih,njh,nkh
print*

allocate (hgg(ngrh))

! allocate h-grid arrays

if (associated(hg%mg     ))    nullify (hg%mg     )
if (associated(hg%rkt    ))    nullify (hg%rkt    )
if (associated(hg%rim    ))    nullify (hg%rim    )
if (associated(hg%rjm    ))    nullify (hg%rjm    )
if (associated(hg%rkm    ))    nullify (hg%rkm    )
if (associated(hg%topthg ))    nullify (hg%topthg )
if (associated(hg%pctlhg ))    nullify (hg%pctlhg )
allocate (hg%mg(nih,njh,nkh))
allocate (hg%rkt(nih,njh,nkh))
allocate (hg%rim(nih,njh,nkh))
allocate (hg%rjm(nih,njh,nkh))
allocate (hg%rkm(nih,njh,nkh))
allocate (hg%topthg(nih,njh))
allocate (hg%pctlhg(nih,njh))


do ng = 1,ngrh
   if (associated(hgg(ng)%rkt    ))    nullify (hgg(ng)%rkt    )
   if (associated(hgg(ng)%rim    ))    nullify (hgg(ng)%rim    )
   if (associated(hgg(ng)%rjm    ))    nullify (hgg(ng)%rjm    )
   if (associated(hgg(ng)%rkm    ))    nullify (hgg(ng)%rkm    )
   if (associated(hgg(ng)%topthg ))    nullify (hgg(ng)%topthg )
   if (associated(hgg(ng)%pctlhg ))    nullify (hgg(ng)%pctlhg )
   allocate (hgg(ng)%rkt(nih,njh,nkh))
   allocate (hgg(ng)%rim(nih,njh,nkh))
   allocate (hgg(ng)%rjm(nih,njh,nkh))
   allocate (hgg(ng)%rkm(nih,njh,nkh))
   allocate (hgg(ng)%topthg(nih,njh))
   allocate (hgg(ng)%pctlhg(nih,njh))
enddo


return
end

!***************************************************************************

subroutine hgridset ()

use hyp_coms
use mem_grid

integer :: ngg,ng,kh,jh,ih,kh2,jh2

!print*,'hgridset:',nih,njh,nkh,ngrh

do ng=1,ngrh
   ie1(ng)=nnzh(ng)
   in1(ng)=nnzh(ng)*nnxh(ng)
   iu1(ng)=1
   ie1n1(ng)=ie1(ng)+in1(ng)
   ie1u1(ng)=ie1(ng)+iu1(ng)
   in1u1(ng)=in1(ng)+iu1(ng)
   ie1n1u1(ng)=ie1n1(ng)+iu1(ng)
   ie12d(ng)=1
   in12d(ng)=nnxh(ng)
   ie1n12d(ng)=ie12d(ng)+in12d(ng)
enddo

! Epsilon is a small bias added to model coordinates. The 1.e-5 factor
! is valid for fine grid spacings down to that factor times delta x
! of the coarse grid.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! fix bug epsilon too small and truncated Gil 
epsilon=0.1 * min((xmh(2,ngrh)-xmh(1,ngrh)),(ymh(2,ngrh)-ymh(1,ngrh)))
!epsilon=1.e-5 * (xmh(2,1)-xmh(1,1))
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

do ngg=1,ngrh
  do kh=1,nkh
    do jh=1,njh
      do ih=1,nih
         hg%mg(ih,jh,kh)=0
         ng=ngg+1
         40 continue
         ng=ng-1
          epsilon1 = epsilon
          if(ng==1) epsilon1 = -epsilon
          if(xh(ih).ge.xmh(1,ng) - epsilon  &
               .and.xh(ih).lt.xmh(nnxh(ng)-1,ng) - epsilon1  &
               .and.yh(jh).ge.ymh(1,ng) - epsilon  &
               .and.yh(jh).lt.ymh(nnyh(ng)-1,ng) - epsilon1  &
               .and.zh(kh).ge.zmh(1,ng) - epsilon  &
               .and.zh(kh).lt.zmh(nnzh(ng)-1,ng) - epsilon1) then
            hg%mg(ih,jh,kh)=ng

            kh2 = max(kh,2)
            jh2 = max(jh,2)
            ih2 = max(ih,2)
            if(kh.ge.2.and.ng.eq.hg%mg(ih,jh,kh2-1)) then
               hg%rim (ih,jh,kh)   =hg%rim (ih,jh,kh-1)
               hgg(ng)%rim(ih,jh,kh)=hgg(ng)%rim(ih,jh,kh-1)
            elseif(jh.ge.2.and.ng.eq.hg%mg(ih,jh2-1,kh)) then
               hg%rim (ih,jh,kh)   =hg%rim (ih,jh-1,kh)
               hgg(ng)%rim(ih,jh,kh)=hgg(ng)%rim(ih,jh-1,kh)
            else
               ic=0
               50 continue
               ic=ic+1
               if(xh(ih).ge.xmh(ic,ng).and.xh(ih).lt.xmh(ic+1,ng)) then
                  hg%rim (ih,jh,kh)   =(xh(ih)-xmh(ic,ng))  &
                                   /(xmh(ic+1,ng)-xmh(ic,ng))+float(ic)
                  hgg(ng)%rim(ih,jh,kh)=(xh(ih)-xmh(ic,ng))  &
                                   /(xmh(ic+1,ng)-xmh(ic,ng))+float(ic)
               else
                  goto 50
               endif
            endif
            
            if(kh==2.and.hg%rim(ih,jh,kh)/=hgg(ng)%rim(ih,jh,kh)) then
               print*,'rim',ng,ih,jh,hg%rim(ih,jh,kh),hgg(ng)%rim(ih,jh,kh)
               stop
            endif

            if(ih.ge.2.and.ng.eq.hg%mg(ih2-1,jh,kh)) then
               hg%rjm (ih,jh,kh)   =hg%rjm (ih-1,jh,kh)
               hgg(ng)%rjm(ih,jh,kh)=hgg(ng)%rjm(ih-1,jh,kh)
            elseif(kh.ge.2.and.ng.eq.hg%mg(ih,jh,kh2-1)) then
               hg%rjm (ih,jh,kh)   =hg%rjm (ih,jh,kh-1)
               hgg(ng)%rjm(ih,jh,kh)=hgg(ng)%rjm(ih,jh,kh-1)
            else
               jc=0
               60 continue
               jc=jc+1
               if(yh(jh).ge.ymh(jc,ng).and.yh(jh).lt.ymh(jc+1,ng)) then
                  hg%rjm (ih,jh,kh)   =(yh(jh)-ymh(jc,ng))  &
                                   /(ymh(jc+1,ng)-ymh(jc,ng))+float(jc)
                  hgg(ng)%rjm(ih,jh,kh)=(yh(jh)-ymh(jc,ng))  &
                                   /(ymh(jc+1,ng)-ymh(jc,ng))+float(jc)
               else
                  goto 60
               endif
            endif
            
            if(kh==2.and.hg%rjm(ih,jh,kh)/=hgg(ng)%rjm(ih,jh,kh)) then
               print*,'rjm',ng,ih,jh,hg%rjm(ih,jh,kh),hgg(ng)%rjm(ih,jh,kh)
               stop
            endif

            if(ih.ge.2.and.ng.eq.hg%mg(ih2-1,jh,kh)) then
               hg%rkm (ih,jh,kh)   =hg%rkm (ih-1,jh,kh)
               hgg(ng)%rkm(ih,jh,kh)=hgg(ng)%rkm(ih-1,jh,kh)
            elseif(jh.ge.2.and.ng.eq.hg%mg(ih,jh2-1,kh)) then

               hg%rkm (ih,jh,kh)   =hg%rkm (ih,jh-1,kh)
               hgg(ng)%rkm(ih,jh,kh)=hgg(ng)%rkm(ih,jh-1,kh)
            else
               kc=0
               70 continue
               kc=kc+1
               if(zh(kh).ge.zmh(kc,ng).and.zh(kh).lt.zmh(kc+1,ng)) then
                  hg%rkm (ih,jh,kh)   =(zh(kh)-zmh(kc,ng))  &
                                   /(zmh(kc+1,ng)-zmh(kc,ng))+float(kc)
                  hgg(ng)%rkm(ih,jh,kh)=(zh(kh)-zmh(kc,ng))  &
                                   /(zmh(kc+1,ng)-zmh(kc,ng))+float(kc)
               else    
                  goto 70
               endif
            endif
            
            if(kh==2.and.hg%rkm(ih,jh,kh)/=hgg(ng)%rkm(ih,jh,kh)) then
               print*,'rkm',ng,ih,jh,hg%rkm(ih,jh,kh),hgg(ng)%rkm(ih,jh,kh)
               stop
            endif

            if(ih.ge.2.and.ng.eq.hg%mg(ih2-1,jh,kh)) then
               hg%rkt (ih,jh,kh)   =hg%rkt (ih-1,jh,kh)
               hgg(ng)%rkt(ih,jh,kh)=hgg(ng)%rkt(ih-1,jh,kh)
            elseif(jh.ge.2.and.ng.eq.hg%mg(ih,jh2-1,kh)) then
               hg%rkt (ih,jh,kh)   =hg%rkt (ih,jh-1,kh)
               hgg(ng)%rkt(ih,jh,kh)=hgg(ng)%rkt(ih,jh-1,kh)
            else
               kc=0
               75 continue
               kc=kc+1
               if(zh(kh).ge.zth(kc,ng).and.zh(kh).lt.zth(kc+1,ng)) then
                  hg%rkt (ih,jh,kh)   =(zh(kh)-zth(kc,ng))  &
                                   /(zth(kc+1,ng)-zth(kc,ng))+float(kc)
                  hgg(ng)%rkt(ih,jh,kh)=(zh(kh)-zth(kc,ng))  &
                                   /(zth(kc+1,ng)-zth(kc,ng))+float(kc)

               else
                  goto 75
               endif

            endif
            
            if(kh==2.and.hg%rkt(ih,jh,kh)/=hgg(ng)%rkt(ih,jh,kh)) then
               print*,'rkt',ng,ih,jh,hg%rkt(ih,jh,kh),hgg(ng)%rkt(ih,jh,kh)
               stop
            endif
            
         else
            goto 40
         endif
      enddo
    enddo
  enddo
enddo

do jh=1,njh
   do ih=1,nih
      rit=hg%rim(ih,jh,1)+0.5
      rjt=hg%rjm(ih,jh,1)+0.5
      mgp=hg%mg(ih,jh,1)

      it=int(rit)
      jt=int(rjt)

      qt200=rit-float(it)
      qt020=rjt-float(jt)
      
      hg%topthg(ih,jh)=(1.0-qt020)* ((1.0-qt200)*grid(mgp)%topt(it,jt)  &
                      +     qt200 *              grid(mgp)%topt(it+1,jt))  &
                      +     qt020 * ((1.0-qt200)*grid(mgp)%topt(it,jt+1)  &
                      +     qt200 *              grid(mgp)%topt(it+1,jt+1))
           
      hg%pctlhg(ih,jh)=(1.0-qt020)* ((1.0-qt200)*grid(mgp)%pctl(it,jt)  &
                      +     qt200 *              grid(mgp)%pctl(it+1,jt))  &
                      +     qt020 * ((1.0-qt200)*grid(mgp)%pctl(it,jt+1)  &
                      +     qt200 *              grid(mgp)%pctl(it+1,jt+1))
      
           
   enddo
enddo

return
end
