!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================
!!!!!!!!!!!!!!!!!!!!!! GIL fix time for MS LES also in rainit
subroutine hyp_setup()

use hyp_coms
use ra_file_info
use an_header
use mem_met
use mem_grid

implicit none

character(len=6)  :: timestr
character(len=80) :: flnm

real :: simend,reldur

integer :: irelhrs,irelmins,irelsecs,nsimen,nval
integer :: istarthrs,istartmins,istartsecs
integer :: nsimend,nsrc,nrelst,nrelstrt,nreldur,nrelend,ndrelend

integer :: nfn,lenf,ng
character(len=19) :: wt1
character(len=14) :: work_time

ieuler=0
ilagran=0

!-----------------------------------------------------------------
! construct arrays of RAMS filenames and times
!-----------------------------------------------------------------

call ra_init (numanf,metpref)
print*,'RAMS POST init: ',numanf,' files found with prefix.'

call ra_set_file(1,1)
call ra_get_idata(1,1,ngrh,nval)
print*,'RAMS ngrids: ',ngrh

if (ihyprun == 2) then
   do nfn=1,numanf
      call ra_set_file(1,nfn)
      call ra_get_fdata (1,1,ftimes(nfn),nval)
      fnums(nfn)=nfn

!      print*,'find set ftimes 3' , ihyprun,numanf,ftimes(nfn),nval,fnums(nfn)

      do ng = 1, ngrh
         call ra_get_ldata(0, ng, fexist(nfn,ng), nval)
      enddo
      
   enddo
   call ra_set_file(1,1)
   call ra_get_cdata (0,flnm,nval)
   lenf=len_trim(flnm)

!!!!!!!!!!!!!!!!!!!!!! GIL fix time for MS LES
   time_offset=ftimes(1) 
   do nfn=1,numanf
      ftimes(nfn)=abs(ftimes(nfn)-time_offset)
   enddo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
elseif (ihyprun == 3) then

   ! Reverse order of times
   do nfn=1,numanf
      call ra_set_file(1,nfn)
      call ra_get_fdata (1,1,ftimes(numanf-nfn+1),nval)
      
      do ng = 1, ngrh
         call ra_get_ldata(0, ng, fexist(numanf-nfn+1,ng), nval)
      enddo

   enddo
   ! offset times by max file time
   time_offset=ftimes(1)
   do nfn=1,numanf
      ftimes(nfn)=abs(ftimes(nfn)-time_offset)
      fnums(nfn)=numanf-nfn+1
   enddo
   call ra_set_file(1,numanf)
   call ra_get_cdata (0,flnm,nval)
   lenf=len_trim(flnm)
   
endif


print*,'numanf,ftimes(1),ftimes(numanf),time_offset'
print*,numanf,ftimes(1),ftimes(numanf),time_offset

!-----------------------------------------------------------------
! compute release and simulation times, clipping time to max data
! avail where required
!-----------------------------------------------------------------

print *

call ra_set_file(1,1)
call ra_get_cdata (0,flnm,nval)

lenf=len_trim(flnm)
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!fix MS GIL
if (flnm(lenf-11:lenf-11).eq.'-') then
     wt1=flnm(lenf-28:lenf-12)
else
     wt1=flnm(lenf-25:lenf-9)
endif
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
cstart_time=wt1(1:4)//wt1(6:7)//wt1(9:10)//wt1(12:17)

call ra_set_file(1,numanf)
call ra_get_cdata (0,flnm,nval)

lenf=len_trim(flnm)
wt1=flnm(lenf-28:lenf-12)
cend_time=wt1(1:4)//wt1(6:7)//wt1(9:10)//wt1(12:17)


if (ihyprun == 2) then

! max hypact run time

   print*,'cstart_time:',cstart_time
   print*,'cend_time  :',cend_time
   print*,'csimend    :',csimend
   print*


   wt1=csimend
   work_time=wt1(1:4)//wt1(6:7)//wt1(9:10)  &
        //wt1(12:13)//wt1(15:16)//wt1(18:19)
   call date_subtract(cstart_time,work_time,simend,'s')

   print*,'simend:',csimend
   print*,'simend:',cstart_time
   print*,'simend:',work_time
   print*,'simend:',simend

   do nsrc=1,nsources
      print*
      print*,'emission',nsrc

      ! start of release

      wt1=crelstrt(nsrc)
      work_time=wt1(1:4)//wt1(6:7)//wt1(9:10)  &
              //wt1(12:13)//wt1(15:16)//wt1(18:19)
      call date_subtract(cstart_time,work_time,relstrt(nsrc),'s')
   
      ! end of release
   
      wt1=crelend(nsrc)
      work_time=wt1(1:4)//wt1(6:7)//wt1(9:10)  &
              //wt1(12:13)//wt1(15:16)//wt1(18:19)
      call date_subtract(cstart_time,work_time,relend(nsrc),'s')
      print*,'relend',nsrc,relend(nsrc)
   enddo

elseif (ihyprun == 3) then

   ! max hypact run time
   print*,'simend:',csimend
   print*,'simend:',cend_time
   print*,'simend:',work_time
   print*,'simend:',simend

   wt1=csimend
   work_time=wt1(1:4)//wt1(6:7)//wt1(9:10)  &
        //wt1(12:13)//wt1(15:16)//wt1(18:19)
   call date_subtract(work_time,cend_time,simend,'s')

   print*,wt1(1:4),'^',wt1(6:7),'^',wt1(9:10)  &
        ,'^',wt1(12:13),'^',wt1(15:16),'^',wt1(18:19)
   print*,'simend:',csimend
   print*,'simend:',cend_time
   print*,'simend:',work_time
   print*,'simend:',simend

   do nsrc=1,nsources
      print*
      print*,'emission',nsrc

      ! start of release

      wt1=crelstrt(nsrc)
      work_time=wt1(1:4)//wt1(6:7)//wt1(9:10)  &
              //wt1(12:13)//wt1(15:16)//wt1(18:19)
      call date_subtract(work_time,cend_time,relstrt(nsrc),'s')
      print*,'relstrt',nsrc,relstrt(nsrc)
   
      ! end of release
   
      wt1=crelend(nsrc)
      work_time=wt1(1:4)//wt1(6:7)//wt1(9:10)  &
              //wt1(12:13)//wt1(15:16)//wt1(18:19)
      call date_subtract(work_time,cend_time,relend(nsrc),'s')
      print*,' relend',nsrc,relend(nsrc)
   enddo

endif

! Clip the simulation end time. We must have files from all grids at, or
!  later than simend.

! Find last file time where all grids exist
file1: do nfn=numanf,1,-1
   do ng=1,ngrh
      if (.not.fexist(nfn,ng)) cycle file1
   enddo
   exit
enddo file1
nend=nfn

print *, 'number of file time where all grids exist', nend

if(ihyprun <= 2) then
   print*,'+-----------------------------------------------------'
   print*,'|   FORWARD run'
   print*,'+-----------------------------------------------------'
 
   !print*,'ftimes ', ftimes
   print*,'simend ',simend, ftimes(nend)
   
   if(simend > ftimes(nend)) then
      simend=ftimes(nend)
      print*,'hyp_setup: warning - clipped max run time to:'
      print*,'simend ',simend
   endif
   
   do nsrc=1,nsources
      if(relend(nsrc) >  simend  ) then
         print*,'hyp_setup: warning - clipped release end'
         print*,'nsrc,relend ',nsrc,relend(nsrc)
         relend(nsrc)=simend
      endif
      
      ! limit the averaging time to <= the output freq - doing an averaging time
      ! greater than this means we have to take a moving average - very expensive
      ! on array space

      if(relstrt(nsrc) > simend )   &
            print*, 'hyp_setup: no run time for source: ',nsrc
      if(avgtime > hypfreq) avgtime=hypfreq

      ! set flags if doing lag, eul - do both if flag equal to hyb or both

      if(type(nsrc)(1:3).ne.'eul') ilagran=1
      if(type(nsrc)(1:3).ne.'lag') ieuler=1
   enddo

elseif(ihyprun == 3) then
   print*,'+-----------------------------------------------------'
   print*,'|   BACKWARD run'
   print*,'+-----------------------------------------------------'
   
   print*,'simend ',simend,ftimes(nend)
   if(simend > ftimes(nend)) then
      simend=ftimes(nend)
      print*,'hyp_driver: warning - clipped max run time'
   endif
   
   ilagran=1
   do nsrc=1,nsources
      if (type(nsrc)(1:3) /= 'lag') then
         print*
         print*,' Only Lagrangian sources are allowed in a backward run.'
         stop 'Non-lag in backward'
      endif
   enddo

   ! Change dtpart to negative for a backward run
   
   dtpart =-abs(dtpart)

endif

print*

! set minimum output flags according to what is being done

if(ieuler==0) then
   ieulout=0
endif
if(ilagran==0) then
   ipartout=0
   ilagout=0
endif

! advance time to first release by checking each source's release
! start time and simulation end time - if there are no sources
! specified in the namelist, assume run starts at time=0 and that
! sources will be Eulerian (assuming some hard coded source)

hytimemax = simend

if(nsources > 0) then
   hytime=1.e20
   do nsrc=1,nsources
      hytime=min(hytime,relstrt(nsrc))
   enddo
else
   hytime=0.
   ieuler=1
endif

print*,'HYPACT start time:',hytime,'  finish time:',hytimemax

if(hytime >= hytimemax ) stop 'no HYPACT run time'

! Find analysis file numbers to start from, need to start from a 
!  time when all grids have analysis files

file2: do nfn=1,numanf
   do ng=1,ngrh
      if (.not.fexist(nfn,ng)) cycle file2
   enddo
   if(nint(hytime) >= nint(ftimes(nfn)) ) then
      ipstfl(1:ngrh)=nfn
      exit
   endif
enddo file2

print*,'past files:',ipstfl(1:ngrh)

! Now find future file for each grid
ifutfl(1:ngrh)=0
do ng=1,ngrh
   do nfn = ipstfl(ng)+1,nend
      if (fexist(nfn,ng) .and.  &
          nint(hytime) < nint(ftimes(nfn))) then
         ifutfl(ng)=nfn
         exit
      endif
   enddo
enddo
if(minval(ifutfl(1:ngrh)) == 0 ) then
   print*,'hyp_setup: future file error'
   print*,'future files:',ifutfl(1:ngrh)
   stop 'hyp_setup'
endif

! Reset hytime if doesn't coincide with the past analysis file time
if(hytime /= ftimes(ipstfl(1))) then
   print*,'Shifted HYPACT start time from',hytime,'to',ftimes(nfn)
   hytime=ftimes(nfn)
endif

print*,'First analysis files:pst:',ipstfl(1:ngrh) 
print*,'First analysis files:fut:',ifutfl(1:ngrh) 
print*,'First analysis files:runtimes:',hytime,hytimemax  



! Allocate datatypes

allocate(metp(ngrh),metc(ngrh),metf(ngrh))
allocate(grid(ngrh))

! Nullify pointers in data types
do ng = 1, ngrh
   call nullify_met(metp(ng))
   call nullify_met(metc(ng))
   call nullify_met(metf(ng))
   call nullify_grid(grid(ng))
enddo


!-----------------------------------------------
! read in first two file sets
!-----------------------------------------------

do ng = 1, ngrh
   call hyp_rdanal (metp(ng),ipstfl(ng),ng)
enddo

do ng = 1, ngrh
   call hyp_rdanal (metf(ng),ifutfl(ng),ng)
enddo

return
end
