!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================


Module mem_met

   Type met_vars
   
      ! Variables to be dimensioned by (nzp,nxp,nyp)
   real, pointer, dimension(:,:,:) :: &
                          u,v,w,tke,theta,khv,khh,press,temp  &
                         ,sigu,sigv,sigw,tlu,tlv,tlw,ds2 &
                         ,scr1,scr2,scr3
                         
   End Type
   
   type (met_vars), allocatable :: metp(:), metc(:), metf(:)
  
Contains

   subroutine alloc_met(met,n1,n2,n3)

   implicit none
   type (met_vars) :: met
   integer, intent(in) :: n1,n2,n3

! Allocate arrays based on options (if necessary)

      allocate (met%u      (n1,n2,n3))
      allocate (met%v      (n1,n2,n3))
      allocate (met%w      (n1,n2,n3))
      allocate (met%press  (n1,n2,n3))
      allocate (met%theta  (n1,n2,n3))
      allocate (met%tke    (n1,n2,n3))
      allocate (met%khv    (n1,n2,n3))
      allocate (met%khh    (n1,n2,n3))
      allocate (met%temp   (n1,n2,n3))
      allocate (met%sigu   (n1,n2,n3))
      allocate (met%sigv   (n1,n2,n3))
      allocate (met%sigw   (n1,n2,n3))
      allocate (met%tlu    (n1,n2,n3))
      allocate (met%tlv    (n1,n2,n3))
      allocate (met%tlw    (n1,n2,n3))
      allocate (met%ds2    (n1,n2,n3))
      allocate (met%scr1    (n1,n2,n3))
      allocate (met%scr2    (n1,n2,n3))
      allocate (met%scr3    (n1,n2,n3))

   return
   end subroutine


   subroutine nullify_met(met)

   implicit none
   type (met_vars) :: met
   
   if (associated(met%u    ))    nullify (met%u    )
   if (associated(met%v    ))    nullify (met%v    )
   if (associated(met%w    ))    nullify (met%w    )
   if (associated(met%press))    nullify (met%press)
   if (associated(met%theta))    nullify (met%theta)
   if (associated(met%tke  ))    nullify (met%tke  )
   if (associated(met%khv  ))    nullify (met%khv  )
   if (associated(met%khh  ))    nullify (met%khh  )
   if (associated(met%temp ))    nullify (met%temp )
   if (associated(met%sigu ))    nullify (met%sigu )
   if (associated(met%sigv ))    nullify (met%sigv )
   if (associated(met%sigw ))    nullify (met%sigw )
   if (associated(met%tlu  ))    nullify (met%tlu  )
   if (associated(met%tlv  ))    nullify (met%tlv  )
   if (associated(met%tlw  ))    nullify (met%tlw  )
   if (associated(met%ds2  ))    nullify (met%ds2  )
   if (associated(met%scr1  ))    nullify (met%scr1  )
   if (associated(met%scr2  ))    nullify (met%scr2  )
   if (associated(met%scr3  ))    nullify (met%scr3  )

   return
   end subroutine

   subroutine dealloc_met(met)

   implicit none
   type (met_vars) :: met
   
   if (associated(met%u    ))    deallocate (met%u    )
   if (associated(met%v    ))    deallocate (met%v    )
   if (associated(met%w    ))    deallocate (met%w    )
   if (associated(met%press))    deallocate (met%press)
   if (associated(met%theta))    deallocate (met%theta)
   if (associated(met%tke  ))    deallocate (met%tke  )
   if (associated(met%khv  ))    deallocate (met%khv  )
   if (associated(met%khh  ))    deallocate (met%khh  )
   if (associated(met%temp ))    deallocate (met%temp )
   if (associated(met%sigu ))    deallocate (met%sigu )
   if (associated(met%sigv ))    deallocate (met%sigv )
   if (associated(met%sigw ))    deallocate (met%sigw )
   if (associated(met%tlu  ))    deallocate (met%tlu  )
   if (associated(met%tlv  ))    deallocate (met%tlv  )
   if (associated(met%tlw  ))    deallocate (met%tlw  )
   if (associated(met%ds2  ))    deallocate (met%ds2  )
   if (associated(met%scr1  ))    deallocate (met%scr1  )
   if (associated(met%scr2  ))    deallocate (met%scr2  )
   if (associated(met%scr3  ))    deallocate (met%scr3  )

   return
   end subroutine


End Module mem_met
