!
! Copyright (C) 1991-2003  ; All Rights Reserved ; ATMET, LLC
! 
! This file is free software; you can redistribute it and/or modify it under the
! terms of the GNU General Public License as published by the Free Software 
! Foundation; either version 2 of the License, or (at your option) any later version.
! 
! This software is distributed in the hope that it will be useful, but WITHOUT ANY 
! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
! PARTICULAR PURPOSE.  See the GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License along with this 
! program; if not, write to the Free Software Foundation, Inc., 
! 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
!======================================================================================


Module mem_scratch
   
   ! Added scratch arrays

   type scratch_vars
      real, pointer, dimension(:) ::  &
                              scr1,scr2,scr3,scr4,scr5,scr6,scr7,scr8  &
                             ,scr9,scr10,scr11
   end type

   type (scratch_vars) :: scr
  
Contains
!---------------------------------------------------------------

   subroutine alloc_scratch(npts)
   
   implicit none

   integer :: npts

   ! Allocate arrays based on options (if necessary).

   allocate (scr%scr1 (npts))
   allocate (scr%scr2 (npts))
   allocate (scr%scr3 (npts))
   allocate (scr%scr4 (npts))
   allocate (scr%scr5 (npts))
   allocate (scr%scr6 (npts))
   allocate (scr%scr7 (npts))
   allocate (scr%scr8 (npts))
   allocate (scr%scr9 (npts))
   allocate (scr%scr10(npts))
   allocate (scr%scr11(npts))
          
   return
   end subroutine

!---------------------------------------------------------------

   subroutine dealloc_scratch()

   implicit none

   !  Deallocate arrays

   if (associated(scr%scr1 )) deallocate (scr%scr1 )
   if (associated(scr%scr2 )) deallocate (scr%scr2 )
   if (associated(scr%scr3 )) deallocate (scr%scr3 )
   if (associated(scr%scr4 )) deallocate (scr%scr4 )
   if (associated(scr%scr5 )) deallocate (scr%scr5 )
   if (associated(scr%scr6 )) deallocate (scr%scr6 )
   if (associated(scr%scr7 )) deallocate (scr%scr7 )
   if (associated(scr%scr8 )) deallocate (scr%scr8 )
   if (associated(scr%scr9 )) deallocate (scr%scr9 )
   if (associated(scr%scr10)) deallocate (scr%scr10)
   if (associated(scr%scr11)) deallocate (scr%scr11)
           
   return
   end subroutine

!---------------------------------------------------------------

   subroutine nullify_scratch()

   implicit none

   !  nullify pointers

   if (associated(scr%scr1 ))   nullify (scr%scr1 )
   if (associated(scr%scr2 ))   nullify (scr%scr2 )
   if (associated(scr%scr3 ))   nullify (scr%scr3 )
   if (associated(scr%scr4 ))   nullify (scr%scr4 )
   if (associated(scr%scr5 ))   nullify (scr%scr5 )
   if (associated(scr%scr6 ))   nullify (scr%scr6 )
   if (associated(scr%scr7 ))   nullify (scr%scr7 )
   if (associated(scr%scr8 ))   nullify (scr%scr8 )
   if (associated(scr%scr9 ))   nullify (scr%scr9 )
   if (associated(scr%scr10))   nullify (scr%scr10)
   if (associated(scr%scr11))   nullify (scr%scr11)
           
   return
   end subroutine

End Module
