!############################# Change Log ##################################
! 2.3.1.6
!###########################################################################
!  Copyright (C)  1990, 1995, 1999, 2000 - All Rights Reserved
!  Regional Atmospheric Modeling System - RAMS
!  Mission Research Corporation / *ASTeR Division
!###########################################################################

subroutine contour (nngd,ilayer,ifill,slab  &
                   ,nic,njc,boxtop,boxhite,cdname,cdunits)

use pl_params
use define_colors

implicit none

integer :: nngd,ilayer,ifill,nic,njc
real :: boxtop,boxhite
real, dimension(nic,njc) :: slab
character(len=24) :: cdname,cdunits

integer :: ifllbeg,imax,isolid,idashes,i,j,ncl,lcdname,lcdunits  &
          ,ib,ici,ln,ncn,numboxes,imid,icmj,icmp,icmn,ic,labstep &
          ,labpos,ihalfbar
real :: conlo,conhi,coninc,clabscl,valuelab,cbargap,xnii,xnjj  &
       ,tilelo,tilehi,clv,sz,slsum,slmin,slmax,slmean,smin,smax  &
       ,smean,sconlo,sconhi,sconinc,sclabscl,box5,yinc,step,sszz
real :: c1,c2,c3,cont_levs(100)
character(len=1)  :: cpoint
character(len=80) :: title
character(len=8)  :: number,numbr
character(len=6)  :: tcol
character(len=10) :: cconinc
character(len=20) :: color

integer    lrwk, liwk, lmap, nwrk, ngrps, maxncl,icoloff
parameter  ( lrwk = 5000, liwk = 5000, lmap = 2000000 )
parameter  ( nwrk = 15000, ngrps = 10, maxncl = 20 )
integer    iwrk(liwk), lfin(maxncl+1)
integer    map(lmap), iarea(ngrps), igrp(ngrps)
real       rwrk(lrwk), xwrk(nwrk), ywrk(nwrk)

!common /anacon/ conlo,conhi,coninc,clabscl
common /colorfill/ ifllbeg,imax

external cfill

data isolid /65535/, idashes /43690/
save

print*,'start contour'

xnii=float(nic)
xnjj=float(njc)
if(vert.eq.'Z') then
   call set (px1,px2,py1,py2,1.0,xnii,ymin,ymax,1)
   call cpseti('MAP',3)
else
   call set (px1,px2,py1,py2,1.,xnii,1.,xnjj,1)
   call cpseti('MAP',0)
endif

! Find max and min in plotted region of field.  Used
! for min and max labels.

tilelo=minval(slab(1:nic,1:njc))
tilehi=maxval(slab(1:nic,1:njc))
if(abs(tilelo) < 1.e-20) tilelo=0.
if(abs(tilehi) < 1.e-20) tilehi=0.
print*,'+++++++++ ',tilelo,tilehi,ilayer,conrinc(ilayer)

! Set solid fill
call gsfais(1)

! We called set, not conpack
call cpseti('SET',0)

print*,'+++++++++ ',ilayer,icol(ilayer)
call colortab_ind (labcol(ilayer),icol(ilayer))

! set contour line values 

call cont_levels(nic,njc,slab ,conrlo(ilayer) &
               ,conrhi(ilayer),conrinc(ilayer),ccent(ilayer)  &
               ,ncl,cont_levs,imid)
if(ncl == 0) goto 100

if(ncl > 46) then
   print*,'WARNING: too many contour levels contour in for '  &
         ,trim(cvar(ilayer)),' - max=46: ',ncl
   return
endif

imax=ncl

!------------------------------------------
! set up colors

! set the initial color index
print*,ilayer,icmeth(ilayer),conttyp(ilayer)
ifllbeg=170
if( icmeth(ilayer) == 0 ) then
   ! Use default set of colors
   do i=1,ncl
      write(tcol,'(a4,i2.2)') 'fill',i
      call coloralias_set(iwkstation,tcol,ifllbeg+i)
   enddo
else
   ! Compute fill colors based on color interpolation schemes
   if(conttyp(ilayer) == 'c') then
      call fillcolors (ilayer,ifllbeg+1,ifllbeg+imid,ifllbeg+ncl)
   else
      call fillcolors (ilayer,ifllbeg+1,ifllbeg+imid,ifllbeg+ncl-1)
   endif
endif
print*,'4+++++++++'
! color indices for positive and negative contours and text

! icmj is used to color-code the labels in the info box. Not used for contours
icmj=160                                    
if(cgrad(ilayer) < 1.e-10) then
   ! Same color for all, from icol(ilayer)
   call coloralias_set(iwkstation,labcol(ilayer),icmj)
   icmn=icmj                                   ! negative contours
   icmp=icmj                                   ! positive contours  
else
   if(icmeth(ilayer) >= 1 .and. icmeth(ilayer) <= 3) then
      ! Same color for all, from fillcols(1,ilayer)
      call coloralias_set (iwkstation,fillcols(1,ilayer),icmj) 
      icmn=icmj                                   ! negative contours
      icmp=icmj                                   ! positive contours  
   else
      icmn=161
      icmp=162
      call coloralias_set (iwkstation,fillcols(1,ilayer),icmn) ! positive contours
      call coloralias_set (iwkstation,fillcols(3,ilayer),icmp) ! negative contours
      if(imid >  imax-imid) icmj=icmn                                ! contour title text
      if(imid <= imax-imid) icmj=icmp                                ! contour title text
   endif
endif
print*,'5+++++++++'

! make sure we can see the label colors 
! Doesn't this have to be compared to background color? Comment out for now...
!call colortab_col (color,icmj)
!call colortab_vals ('hls',color,c1,c2,c3)
!if(c2 < 50.) then
!   icmj=icmn
!   call colortab_col (color,icmj)
!   call colortab_vals ('hls',color,c1,c2,c3)
!   if(c2 < 50.) then
!      icmj=icmp
!   endif
!endif

!------------------------------------------
! set up labeling parameters

! contour line labels
call cpseti('LLP',3)                 ! penalty scheme
call cpseti('LBC',0)                 ! boxes filled - foreground color
call cpsetr('LLW',.005)              ! white space
call cpsetr('LLS',csize(ilayer))     ! size

! high/low labels
if(ichigh(ilayer) >= 0) then
   call cpsetc('HLT','H:B:$ZDV$:E''L:B:$ZDV$:E' )  ! box code
   call cpseti('HLB',ichigh(ilayer))               ! label, box, fill
   call cpseti('HLC',icol(ilayer))                 ! color index
   call cpsetr('HLS',csize(ilayer)+.002)           ! size
else
   call cpsetc('HLT',' ' )           ! none
endif

! info label
call cpsetc('ILT',' ')               ! none

print*,'6+++++++++'

! If doing filled contours, do them first

if(conttyp(ilayer) == 'f') then

   ! Do filled contours

   ! initialize area map
   call arinam(map,lmap)

   ! put contour lines in area map
   call cpclam(slab,rwrk,iwrk,map)

   ! fill contours - do only this if ifill=1
   if(ifill /= 2) call arscam(map,xwrk,ywrk,nwrk,iarea,igrp,ngrps,cfill)
   if(ifill == 1) return
   
endif

!------------------------------------------
! Now do line contours. Put on top of fill if desired.

if (conttyp(ilayer) == 'c' .or. icline(ilayer) >= 0) then
   
   ! Color offset for Marty's schemes
   if(conttyp(ilayer) == 'c') icoloff=0
   if(conttyp(ilayer) == 'f') icoloff=40
   
   !------------------------------------------
   ! set up contour line parameters
   ! modify individual lines if desired
   
   do i=1,ncl
!print*,'6a+++++++++',ncl,i,cont_levs(i)
      call cpseti('PAI',i)
      call cpsetr('CLV',cont_levs(i))
      
      if(i >= imid+1) then
      
         call cpseti('CLC',icmp)     ! fixed line color
         if(cgrad(ilayer) > 1.e-10 .and. icmeth(ilayer) /= 0) &
         call cpseti('CLC',ifllbeg+i+icoloff)    ! graduated line color
         
         call cpseti('CLD',isolid)   ! solid line
         if(icdash(ilayer) == 2) &
         call cpseti('CLD',idashes)  ! dashed line
         
      else
      
         call cpseti('CLC',icmn)     ! fixed line color
         if(cgrad(ilayer) > 1.e-10 .and. icmeth(ilayer) /= 0) &
         call cpseti('CLC',ifllbeg+i+icoloff)    ! graduated line color
         
         call cpseti('CLD',isolid)   ! solid line
         if(icdash(ilayer) >= 1) &
         call cpseti('CLD',idashes)  ! dashed line
         
      endif
      
      call cpsetr('CLL',cthick(ilayer)) ! width

      if(icline(ilayer) >= 0 .or. conttyp(ilayer) == 'c') &
                               call cpseti('CLU',1) ! line
      if(icline(ilayer) <  0)  call cpseti('CLU',0) ! no line
         
      ! Set up parameters for the major lines
      if(mod(imid-i+1,icint(ilayer)) == 0) then
   
         if(icline(ilayer) >= 0) then
            call cpseti('CLU',3)               ! line and label
            call cpseti('LLB',icline(ilayer))  ! label, box, fill
         endif
            
         call cpsetr('CLL',1.5*cthick(ilayer)) ! width
         
         if(i >= imid+1) call cpseti('LLC',icmp)  ! label color = line color
         if(i <= imid  ) call cpseti('LLC',icmn)  ! label color = line color
         if(cgrad(ilayer) > 1.e-10.and.icmeth(ilayer) /= 0) &
         call cpseti('LLC',ifllbeg+i+icoloff)    ! graduated line color        
      endif
      
   enddo
print*,'7+++++++++'
   
   !---------------------------------------
   !  Do the actual work

   ! draw any contour lines
   call cpcldr(slab,rwrk,iwrk)

   ! draw the labels
   call cplbdr(slab,rwrk,iwrk)

endif


!---------------------------------------

100 continue
if(conttyp(ilayer) /= 'c' .and. ncl == 0 .and. ifill == 1) return
      
! retrieve contouring parameters
if(ncl > 0) then
   conlo=cont_levs(1)
   conhi=cont_levs(ncl)
   coninc=(conhi-conlo)/max((ncl-1),1)
   call cpgetr('SFU',clabscl)
else
   conlo=0.
   conhi=0.
   coninc=0.
   clabscl=0.
endif

print*,'8+++++++++'

   ! Draw boxes for the contour field labels
if(ipinfo == 1) call info_labels(1,'contour',cdname,cdunits,tilelo,tilehi &
         ,coninc,clabscl,boxtop,boxhite,'title0',labcol(ilayer))



if(ipanl /= 1.or. ipinfo == 2) then

   ! Construct the title for multi-panel plots

   call set(0.,1.,0.,1.,0.,1.,0.,1.,1)

   call gsplci(icmj)
   call gstxci(icmj)

   if(abs(coninc).ge.10000.) then
      write(cconinc,'(e8.1)') coninc
   elseif(abs(coninc).ge.1000.) then
      write(cconinc,'(f6.0)') coninc
   elseif(abs(coninc).ge.100.) then
      write(cconinc,'(f5.0)') coninc
   elseif(abs(coninc).ge.10.) then
      write(cconinc,'(f4.0)') coninc
   elseif(abs(coninc).ge..5) then
      write(cconinc,'(f4.1)') coninc
   elseif(abs(coninc).ge..05) then
      write(cconinc,'(f5.2)') coninc
   else
      write(cconinc,'(e8.1)') coninc
   endif
   
   title=cdname(1:lcdname)//  &
         ' ['//cconinc(1:len_trim(cconinc))//  &
         ' '//cdunits(1:lcdunits)//']'
   
   if(ilayer==1.or.(ilayer==2.and.cvar(1)(1:4)=='none')) then
      if(ipanl==1) then
         call plchlq (px1,py1-.018,title(1:len_trim(title)),-.8,0.,-1.)
      else
         call plchlq (px1,py1-.01,title(1:len_trim(title)),-.55,0.,-1.)
      endif
   else
      if(ipanl==1) then
         call plchlq (px2,py1-.018,title(1:len_trim(title)),-.8,0.,1.)
      else
         call plchlq (px1,py1-.026,title(1:len_trim(title)),-.55,0.,-1.)
      endif
   endif

endif

! Draw a color bar for the plot (max of two colorbars)

if(ilayer <= 2 .and. colorbar(ilayer) == 'b'.and.ncl /= 0) then

   if(coninc > 0.) then
      if(conttyp(ilayer) == 'c') then
         numboxes=ncl
         labpos=0
      else
         numboxes=ncl-1
         labpos=1
      endif
      valuelab=conlo
   else
      numboxes=0
   endif
   
   ihalfbar=0
   if(colorbar(1) == 'b' .and. cvar(1)(1:4) /= 'none' .and. &
      colorbar(2) == 'b' .and. ilayer <= 2) ihalfbar=ilayer
   
   call draw_colorbar(1,'title0',numboxes,conlo,coninc,imid  &
         ,px1,px2,py1,py2 &
         ,ipanl,ihalfbar,cdunits,labpos,ifllbeg)
  
endif

print*,'Contoured ',trim(cdname)//'(',trim(cdunits)//')'

! compute some stats

slsum=0.
slmin=slab(1,1)
slmax=slab(1,1)
do j=1,njc
   do i=1,nic
      slsum=slsum+slab(i,j)
      slmin=min(slmin,slab(i,j))
      slmax=max(slmax,slab(i,j))
   enddo
enddo
slmean=slsum/(nic*njc)

return

!-----------------------------------------------------

entry slab_stats(smin,smax,smean)

! entry to return computed stats

smin=slmin
smax=slmax
smean=slmean

return

!-----------------------------------------------------

entry slab_conts(sconlo,sconhi,sconinc,sclabscl)

! entry to return default contouring levels

sconlo=conlo
sconhi=conhi
sconinc=coninc
sclabscl=clabscl

return
end

!***************************************************************************

subroutine cfill (xcra,ycra,ncra,iaia,igia,naia)

dimension xcra(*),ycra(*),iaia(*),igia(*)
common /colorfill/ ifllbeg,imax

! The arrays XCRA and YCRA, for indices 1 to NCRA, contain the X and Y
! coordinates of points defining a polygon.  The area identifiers in
! the array IAIA, each with an associated group identifier in the array
! IGIA, tell us whether the polygon is to be color-filled or not.

! Assume the polygon will be filled until we find otherwise.

ifll=1

! If any of the area identifiers is negative, don't fill the polygon.

do i=1,naia
   if(iaia(i).lt.0) ifll=0
enddo
if(ifll==0) return

! Otherwise, fill the polygon in the color implied by its area
! identifier relative to edge group 3 (the contour-line group).

ifll=0

do i=1,naia
   if(igia(i)==3) ifll=iaia(i)
   if(ifll==1.or.ifll==imax+1) ifll=0  ! don't fill above and below hi-lo range
enddo
if(ifll.gt.0) then
   !print*,'z',imax,ifll,ifllbeg,ifll-1+ifllbeg
   call gsfaci (ifll+ifllbeg-1)
   call gfa (ncra-1,xcra,ycra)
endif

return
end

!***************************************************************************

subroutine cpmpxy (imap,xinp,yinp,xotp,yotp)

! This version of CPMPXY implements four different mappings:
!
!   IMAP = 1 implies an EZMAP mapping.  XINP and YINP are assumed to be
!   the longitude and latitude, in degrees, of a point on the globe.
!
!   IMAP = 2 implies a polar coordinate mapping.  XINP and YINP are
!   assumed to be values of rho and theta (in degrees).
!
!   IMAP = 3:  If IVTRAN = 1 and IZSTRAN = 0 then the input Y is indexed
!     into the array of heights which is Z.  This is good for
!     irregularly spaced grid points in Z.
!     If IVTRAN = 1 and IZSTRAN = 1 then the vertical direction
!     is not only converted to Z, but also scaled to fit in only
!     the area above the topography, which is found in the array
!     ZS.
!
!   IMAP = 4 is the old EZMAP transform. It may not be necessary anymore.

common/trans/itrans,m,n,xlonl,xlonr,ylatb,ylatt,yans
common/trans2/ivtran,z(1000),izstran,zs(1000),zmodtop

! do the transformation.

if(imap.eq.1) then
   call maptrn (yinp,xinp,xotp,yotp)
elseif(imap.eq.2) then
   xotp=xinp*cos(.017453292519943*yinp)
   yotp=xinp*sin(.017453292519943*yinp)
elseif(imap.eq.3) then
   k=int(yinp)
   fctz=yinp-k
   yotp=z(k)+(z(k+1)-z(k))*fctz
   if(izstran.eq.1)then
      i=int(xinp)
      fctx=xinp-i
      zsx=zs(i)+(zs(i+1)-zs(i))*fctx
      rtg=1.-zsx/zmodtop
      yotp=yotp*rtg+zsx
   endif
   xotp=xinp
elseif(imap.eq.4) then
   xlon=xlonl+(xlonr-xlonl)*(xinp-1.)/(m-1.)
   ylat=ylatb+(ylatt-ylatb)*(yinp-1.)/(n-1.)
   call maptrn (ylat,xlon,xotp,yotp)
else
   xotp=xinp
   yotp=yinp
endif

return
end
