!***************************************************************************

subroutine draw_colours (ncol1,ncol2,title)

use define_colors

! This subroutine just draws the colours in defined by the colour map
! (not including those used by the contouring package)

implicit none

integer :: ncol1,ncol2
character(len=*) :: title

integer :: nx,ny,j,i,ij,ncols,ic
real :: szx,szy,y0,y1,x,y,spx,spy
character(len=20) :: blab,color

blab=''
ncols=ncol2-ncol1+1
nx=5
ny=ncols/nx
if(mod(ncols,nx).ne.0) ny=ny+1
szx=.96/nx
szy=min(.56/ny,0.1)
y0=.10
y1=.90
spx=(1.-nx*szx)/(nx+1)
spy=(y1-y0-ny*szy)/max(ny-1,1)

do j=1,ny
   y = y0+(j-1)*(spy+szy)
   do i=1,nx
      ij=i+(j-1)*nx-1
      if(ij+1.le.ncols) then
         x = spx+(i-1)*(spx+szx)
         ic=ij+ncol1
         write(blab,'(i3)') ic
         call gscr (1,10,colortab(ic)%rgb(1),colortab(ic)%rgb(2)  &
                     ,colortab(ic)%rgb(3))
         call colortab_col(color,ic)
         call drbox(x,y,szx,y0,szy,blab,10,color)
      endif
   enddo
enddo

call plchlq(.5,.95,'REVU '//trim(title),.02,0,0)
call plchlq(.5,.04,'The labels indicate colour index',.012,0,0)

return
end

!***************************************************************************

subroutine drbox (x,y,szx,y0,szy,tlab,indx,color)

use define_colors

! Draw a color square with lower left corner (x,y)

implicit none

integer :: indx
real :: x,y,szx,y0,szy
character(len=*) :: tlab,color

integer :: itlen,ier
real, dimension(5) :: a,b
real :: cr,cg,cb

call gsfaci(indx)
a(1) = x
b(1) = y
a(2) = x+szx
b(2) = y
a(3) = a(2)
b(3) = y+szy
a(4) = x
b(4) = b(3)
a(5) = a(1)
b(5) = b(1)
call gsfais(1)
call gfa(4,a,b)
call gsfais(0)

! if the color is black, draw a boundary

call coloralias_set(1,'title0',1)
call gsplci(1)
call gstxci(1)
call gpl(5,a,b)

if(indx.le.58) then
   call plchlq(x,y-.011,trim(tlab)//' - '//  &
               trim(color),.0098,0.,-1.)
else
   call plchlq(x+.5*szx,y-.011,trim(tlab),.0098,0.,0.)
endif

return
end
