!############################# Change Log ##################################
! 3.0.0
!
!
!###########################################################################
!  Copyright (C)  2002 - All Rights Reserved
!###########################################################################

subroutine RAMS_varlib (nf,cvar,a,flnm)

use pl_arrays
use var_info
use ra_file_info

implicit none

integer :: nf
character(len=*) :: cvar,flnm
real :: a(*)

integer :: lv,lv2,ind,ispec
character(len=3) :: cspec

integer :: ierr_getvar,isize,ierr

integer :: n1,n2,n3,ngrd,nzg,nzs,npatch

real, allocatable, save, dimension(:) :: b,c,d,e,ff
real, allocatable, dimension(:,:,:) :: pv1,pv2,pv3,pv4,pv5,pv6,pv7,pv8
integer, save :: isize_old=0

interface 
   integer function RAMS_getvar(string,ngrd,a,b,flnm)
   real :: a(*),b(*)
   integer :: ngrd
   character(len=*) :: flnm,string
   end
end interface


! Fill dimensions from file structure

ngrd=f(nf)%nvgr
n1=f(nf)%nnxp(ngrd)
n2=f(nf)%nnyp(ngrd)
n3=f(nf)%nnzp(ngrd)
nzg=f(nf)%nzg
nzs=f(nf)%nzs
npatch=f(nf)%npatch

! Set current file id
!finf(nf)%nfl = 



! Allocate scratch arrays. Biggest one we need is nxp*nyp*npatch*max(nzg,nzp,nyp)

!print*,'===> varlib-size: ',isize,allocated(b),size(b)
!print*,'===> varlib-size: ',isize,allocated(c),size(c)
!print*,'===> varlib-size: ',isize,allocated(d),size(d)
!print*,'===> varlib-size: ',isize,allocated(e),size(e)
!print*,'===> varlib-size: ',isize,allocated(ff),size(ff)
isize = n1 * n2 * npatch * max( n3, nzg, nzs)
!print*,'===> varlib-size2: ',isize,allocated(d),isize_old
!print*,'===> varlib-size2: ',isize,allocated(b),isize_old
if( isize > isize_old .or. .not.allocated(b) ) then
   print*,'+++++++allocating',isize
   isize_old=isize
   if (allocated(b)) deallocate (b); allocate(b(isize))
   if (allocated(c)) deallocate (c); allocate(c(isize))
   if (allocated(d)) deallocate (d); allocate(d(isize))
   if (allocated(e)) deallocate (e); allocate(e(isize))
   if (allocated(ff)) deallocate (ff); allocate(ff(isize))
endif
                       
lv=len_trim(cvar)
lv2=min(lv,index(cvar,':')-1)  ! for HYPACT fields

!print*,'===> varlib- ',cvar,n1,n2,n3,ngrd,isize,allocated(b),size(b)
!print*,'===> varlib- ',cvar,n1,n2,n3,ngrd,isize,allocated(d),size(d)

ierr_getvar=0
ierr=0

!-------------------------------------------------------------------------------
! 3D velocity variables

if(cvar(1:lv) == 'u') then
   ierr=RAMS_getvar('UP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='u;', units='m/s;')

elseif(cvar(1:lv) == 'v') then
   ierr=RAMS_getvar('VP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='v;', units='m/s;')

elseif(cvar(1:lv) == 'u_avg') then
   ierr=RAMS_getvar('UP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_avgu(n1,n2,n3,a)
   call set_var_info(class=3, name='u_avg;', units='m/s;')

elseif(cvar(1:lv) == 'v_avg') then
   ierr=RAMS_getvar('VP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_avgv(n1,n2,n3,a)
   call set_var_info(class=3, name='v_avg;', units='m/s;')

elseif(cvar(1:lv) == 'ue') then
   ierr=RAMS_getvar('UP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('VP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_rotate(n1,n2,n3,a,c,ngrd)
   call set_var_info(class=3, name='ue;', units='m/s;')

elseif(cvar(1:lv) == 've') then
   ierr=RAMS_getvar('VP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('UP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_rotate(n1,n2,n3,c,a,ngrd)
   call set_var_info(class=3, name='ve;', units='m/s;')

elseif(cvar(1:lv) == 'ue_avg') then
   ierr=RAMS_getvar('UP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('VP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_rotate(n1,n2,n3,a,c,ngrd)
   call RAMS_comp_avgu(n1,n2,n3,a)
   call set_var_info(class=3, name='ue_avg;', units='m/s;')

elseif(cvar(1:lv) == 've_avg') then
   ierr=RAMS_getvar('VP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('UP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_rotate(n1,n2,n3,c,a,ngrd)
   call RAMS_comp_avgv(n1,n2,n3,a)
   call set_var_info(class=3, name='ve_avg;', units='m/s;')

elseif(cvar(1:lv) == 'w') then
   ierr=RAMS_getvar('WP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='w;', units='m/s;')

elseif(cvar(1:lv) == 'wcms') then
   ierr=RAMS_getvar('WP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_wcms(n1,n2,n3,a)
   call set_var_info(class=3, name='w;', units='cm/s;')

elseif(cvar(1:lv) == 'w_avg') then
   ierr=RAMS_getvar('WP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_avgw(n1,n2,n3,a)
   call set_var_info(class=3, name='w_avg;', units='m/s;')

elseif(cvar(1:lv) == 'speed') then
   ierr=RAMS_getvar('UP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('VP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_avgu(n1,n2,n3,a)
   call RAMS_comp_avgv(n1,n2,n3,c)
   call RAMS_comp_speed(n1,n2,n3,a,c)
   call set_var_info(class=3, name='speed;', units='m/s;')

elseif(cvar(1:lv) == 'speed_mph') then
   ierr=RAMS_getvar('UP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('VP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_avgu(n1,n2,n3,a)
   call RAMS_comp_avgv(n1,n2,n3,c)
   call RAMS_comp_speed(n1,n2,n3,a,c)
   call RAMS_comp_mults(n1,n2,n3,a,2.237)
   call set_var_info(class=3, name='speed;', units='mph;')

elseif(cvar(1:lv) == 'direction') then
   ierr=RAMS_getvar('UP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_avgu(n1,n2,n3,a)
   ierr=RAMS_getvar('VP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_avgv(n1,n2,n3,c)
   call RAMS_comp_dir(n1,n2,n3,a,c,ngrd)
   call set_var_info(class=3, name='direction;', units='deg;')

!----------------------------------------------------------------------
! 3D THERMODYNAMIC PROPERTIES OF AIR

elseif(cvar(1:lv) == 'pi') then
   ierr=RAMS_getvar('PI',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='Exner function;', units='J/(kg K);')

elseif(cvar(1:lv) == 'press') then
   ierr=RAMS_getvar('PI',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_press(n1,n2,n3,a)
   call RAMS_comp_mults(n1,n2,n3,a,.01)
   call set_var_info(class=3, name='pressure;', units='mb;')

elseif(cvar(1:lv) == 'press_pa') then
   ierr=RAMS_getvar('PI',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_press(n1,n2,n3,a)
   call set_var_info(class=3, name='pressure;', units='Pa;')

elseif(cvar(1:lv) == 'theta') then
   ierr=RAMS_getvar('THETA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='potential temp;', units='K;')

elseif(cvar(1:lv) == 'dn0') then
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,c,b,a,e,ngrd)
   call set_var_info(class=3, name='ref density;', units='kg/m3;')

elseif(cvar(1:lv) == 'pi0') then
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,a,b,c,e,ngrd)
   call set_var_info(class=3, name='ref Exner func;', units='J/(kg K);')

elseif(cvar(1:lv) == 'th0') then
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,a,c,e,ngrd)
   call set_var_info(class=3, name='reference virtual potential temp;', units='K;')

elseif(cvar(1:lv) == 'pert_pressure') then
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,c,a,b,e,ngrd)
   ierr=RAMS_getvar('PI',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if (ierr == 0) call RAMS_comp_ppress(n1,n2,n3,a,c)
   call set_var_info(class=3, name='pert pressure;', units='mb;')

elseif(cvar(1:lv) == 'tempk') then
   ierr=RAMS_getvar('THETA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_tempK(n1,n2,n3,a,c)
   call set_var_info(class=3, name='temperature;', units='K;')

elseif(cvar(1:lv) == 'tempc') then
   ierr=RAMS_getvar('THETA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_tempK(n1,n2,n3,a,c)
   call RAMS_comp_tempC(n1,n2,n3,a)
   call set_var_info(class=3, name='temperature;', units='C;')

elseif(cvar(1:lv) == 'tempf') then
   ierr=RAMS_getvar('THETA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_tempK(n1,n2,n3,a,c)
   call RAMS_comp_tempF(n1,n2,n3,a)
   call set_var_info(class=3, name='temperature;', units='F;')

elseif(cvar(1:lv) == 'theta_e') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   call RAMS_comp_thete(n1,n2,n3,a,c,d)
   call set_var_info(class=3, name='equiv pot temp;', units='K;')

elseif(cvar(1:lv) == 'theta_v') then
   ierr=RAMS_getvar('THETA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('RV',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100

   call RAMS_comp_thetv(n1,n2,n3,a,c)
   call set_var_info(class=3, name='virtual pot temp;', units='K;')

!-------------------------------------------------------------
! 3D MOISTURE MASS MIXING RATIOS AND HUMIDITY

elseif(cvar(1:lv) == 'vapor') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='vapor mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'dewptk') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dewK(n1,n2,n3,a,c,d)
   call RAMS_comp_tempK(n1,n2,n3,a,c)
   call set_var_info(class=3, name='dewpoint temp;', units='K;')

elseif(cvar(1:lv) == 'dewptf') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dewK(n1,n2,n3,a,c,d)
   call RAMS_comp_tempF(n1,n2,n3,a)
   call set_var_info(class=3, name='dewpoint temp;', units='F;')

elseif(cvar(1:lv) == 'dewptc') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dewK(n1,n2,n3,a,c,d)
   call RAMS_comp_tempC(n1,n2,n3,a)
   call set_var_info(class=3, name='dewpoint temp;', units='C;')

elseif(cvar(1:lv) == 'relhum') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   call RAMS_comp_rh(n1,n2,n3,a,c,d)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='relative humidity;', units='pct;')

elseif(cvar(1:lv) == 'relhum_frac') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   call RAMS_comp_rh(n1,n2,n3,a,c,d)
   call RAMS_comp_mults(n1,n2,n3,a,.01)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='relative humidity;', units='frac;')

!-------------------------------------------------------------------------------
   ! 2D TOPOGRAPHY AND GEOGRAPHIC VALUES
elseif(cvar(1:lv) == 'topo') then
   ierr=RAMS_getvar('TOPT',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='topo;', units='m;')

elseif(cvar(1:lv) == 'dtopox') then
   ierr=RAMS_getvar('TOPT',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dtopo(n1,n2,c,a,'x')
   call set_var_info(class=2, name='dtopo/dx;', units='m;')

elseif(cvar(1:lv) == 'dtopoy') then
   ierr=RAMS_getvar('TOPT',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dtopo(n1,n2,c,a,'y')
   call set_var_info(class=2, name='dtopo/dy;', units='m;')

elseif(cvar(1:lv) == 'topta') then
   ierr=RAMS_getvar('TOPTA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='topta;', units='m;')

elseif(cvar(1:lv) == 'volt') then
   ierr=RAMS_getvar('VOLT',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='grid volume;', units='m3;')

elseif(cvar(1:lv) == 'lat') then
   ierr=RAMS_getvar('GLAT',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='latitude;', units='deg;')

elseif(cvar(1:lv) == 'lon') then
   ierr=RAMS_getvar('GLON',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='longitude;', units='deg;')

elseif(cvar(1:lv) == 'land') then
   ierr=RAMS_getvar('PATCH_AREA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_1minus(n1,n2,1,a)
   call set_var_info(class=2, name='land frac area;', units=';')

elseif(cvar(1:lv) == 'patch_area') then
   ierr=RAMS_getvar('PATCH_AREA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=6, name='patch fractional area;', units=';')

elseif(cvar(1:lv) == 'sea_press') then
   ierr=RAMS_getvar('TOPT',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_z(n1,n2,n3,c,a,ngrd)
   ierr=RAMS_getvar('PI',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_slpress(n1,n2,n3,a,d,c,a)
   call set_var_info(class=2, name='sea level pressure;', units='mb;')

elseif(cvar(1:lv) == 'sst') then
   ierr=RAMS_getvar('SOIL_ENERGY',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call rams_fill_sst(n1,n2,nzg,a,c)
   call set_var_info(class=2, name='water temperature;', units='C;')

!----------------------------------------------------------------
! 2D SURFACE HEAT, MOISTURE, MOMENTUM AND RADIATIVE FLUXES

elseif(cvar(1:lv) == 'tfz') then
   ierr=RAMS_getvar('TFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='tfz;', units='m;')

elseif(cvar(1:lv) == 'qfz') then
   ierr=RAMS_getvar('QFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='qfz;', units='m;')

elseif(cvar(1:lv) == 'uw') then
   ierr=RAMS_getvar('UW',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='uw;', units='m;')

elseif(cvar(1:lv) == 'vw') then
   ierr=RAMS_getvar('VW',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='vw;', units='m;')

elseif(cvar(1:lv) == 'wfz') then
   ierr=RAMS_getvar('WFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='wfz;', units='m;')

elseif(cvar(1:lv) == 'sens_flux') then
   ierr=RAMS_getvar('TFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,1,a,d)
   call RAMS_comp_mults(n1,n2,1,a,1004.)
   call set_var_info(class=2, name='sfc sens heat flx;', units='W/m2;')

elseif(cvar(1:lv) == 'lat_flux') then
   ierr=RAMS_getvar('QFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,1,a,d)
   call RAMS_comp_mults(n1,n2,1,a,2.5e6)
   call set_var_info(class=2, name='sfc lat heat flx;', units='W/m2;')

elseif(cvar(1:lv) == 'etrans') then
   ierr=RAMS_getvar('QFZ',ngrd,a,b,flnm)
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm)
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,1,a,d)
!                 Divide by water density to get depth and 
!                   convert units from m/s to mm/hour (3600./1000.)
   call RAMS_comp_mults(n1,n2,1,a,3.6)
   call set_var_info(class=2, name='evapo-transpiration;', units='mm/hour;')

elseif(cvar(1:lv) == 'etrans_in') then
   ierr=RAMS_getvar('QFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,1,a,d)
!                 Divide by water density to get depth and 
!                   convert units from m/s to in/hour (39.37 * 3600./1000.)
   call RAMS_comp_mults(n1,n2,n3,a,141.732)
   call set_var_info(class=2, name='evapo-transpiration;', units='in/hour;')

elseif(cvar(1:lv) == 'umom_flx') then
   ierr=RAMS_getvar('UW',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,1,a,d)
   call set_var_info(class=2, name='sfc u-momentum flx;', units='Pa;')

elseif(cvar(1:lv) == 'vmom_flx') then
   ierr=RAMS_getvar('VW',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,1,a,d)
   call set_var_info(class=2, name='sfc v-momentum flx;', units='Pa;')

elseif(cvar(1:lv) == 'wmom_flx') then
   ierr=RAMS_getvar('WFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,1,a,d)
   call set_var_info(class=2, name='sfc w-momentum flx;', units='Pa;')

elseif(cvar(1:lv) == 'bowen') then
   ierr=RAMS_getvar('TFZ',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('QFZ',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_bowen(n1,n2,1,a,c)
   call set_var_info(class=2, name='bowen ratio;', units=' ;')

elseif(cvar(1:lv) == 'rshort') then
   ierr=RAMS_getvar('RSHORT',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='rshort;', units='W/m2;')

elseif(cvar(1:lv) == 'rlong') then
   ierr=RAMS_getvar('RLONG',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='rlong;', units='W/m2;')

elseif(cvar(1:lv) == 'rlongup') then
   ierr=RAMS_getvar('RLONGUP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='rlongup;', units='W/m2;')

elseif(cvar(1:lv) == 'albedt') then
   ierr=RAMS_getvar('ALBEDT',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='albedt;', units=' ;')


!-------------------------------------------------------------------------------
!    3D condensate

elseif(cvar(1:lv) == 'cloud') then
   ierr=RAMS_getvar('RCP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='cloud mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'rain') then
   ierr=RAMS_getvar('RRP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='rain mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'pristine') then
   ierr=RAMS_getvar('RPP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='pristine mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'snow') then
   ierr=RAMS_getvar('RSP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='snow mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'aggregates') then
   ierr=RAMS_getvar('RAP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='aggregate mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'graupel') then
   ierr=RAMS_getvar('RGP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='graupel mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'hail') then
   ierr=RAMS_getvar('RHP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   if(ierr == 0) then
      call RAMS_comp_mults(n1,n2,n3,a,1.e3)
      call RAMS_comp_noneg(n1,n2,n3,a)
   endif
   call set_var_info(class=3, name='hail mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'liquid') then
   call RAMS_comp_zero(n1,n2,n3,a)
   ierr=RAMS_getvar('RCP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RRP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)

   ierr=RAMS_getvar('RGP',ngrd,c,b,flnm)
   if(ierr == 0) then
      ierr=RAMS_getvar('Q6',ngrd,d,b,flnm)
      if(ierr == 0) then
         call RAMS_comp_fracliq(n1,n2,n3,d)
         call RAMS_comp_mult(n1,n2,n3,c,d)
      endif
      call RAMS_comp_accum(n1,n2,n3,a,c)
   endif

   ierr=RAMS_getvar('RHP',ngrd,c,b,flnm)
   if(ierr == 0) then
      ierr=RAMS_getvar('Q7',ngrd,d,b,flnm)
      if(ierr == 0) then
         call RAMS_comp_fracliq(n1,n2,n3,d)
         call RAMS_comp_mult(n1,n2,n3,c,d)
      endif
      call RAMS_comp_accum(n1,n2,n3,a,c)
    endif

   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='liquid mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'ice') then
   call RAMS_comp_zero(n1,n2,n3,a)
   ierr=RAMS_getvar('RPP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RSP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RAP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)

   ierr=RAMS_getvar('RGP',ngrd,c,b,flnm)
   if(ierr == 0) then
      ierr=RAMS_getvar('Q6',ngrd,d,b,flnm)
      if(ierr == 0) then
         call RAMS_comp_fracice(n1,n2,n3,d)
         call RAMS_comp_mult(n1,n2,n3,c,d)
      endif
      call RAMS_comp_accum(n1,n2,n3,a,c)
   endif

   ierr=RAMS_getvar('RHP',ngrd,c,b,flnm)
   if(ierr == 0) then
      ierr=RAMS_getvar('Q7',ngrd,d,b,flnm)
      if(ierr == 0) then
         call RAMS_comp_fracliq(n1,n2,n3,d)
         call RAMS_comp_mult(n1,n2,n3,c,d)
      endif
      call RAMS_comp_accum(n1,n2,n3,a,c)
   endif

   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='ice mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'total_cond') then
   call RAMS_comp_zero(n1,n2,n3,a)
   ierr=RAMS_getvar('RCP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RRP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RPP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RSP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RAP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RGP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RHP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)

   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='total cond mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'r_total') then
   ierr=RAMS_getvar('RV',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('RCP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RRP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RPP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RSP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RAP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RGP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RHP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)

   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='total mix ratio;', units='g/kg;')

elseif(cvar(1:lv) == 'rtotal_orig') then
   ierr=RAMS_getvar('RTP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='total orig mix ratio;', units='g/kg;')


elseif(cvar(1:lv) == 'clear_frac') then
   ierr=RAMS_getvar('RV',ngrd,b,a,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,a,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,a,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_rh(n1,n2,n3,b,c,d)
   call RAMS_comp_noneg(n1,n2,n3,b)
   call cldfraction(n1,n2,n3,a,c,b)
   call set_var_info(class=2, name='clear sky;', units='frac;')

elseif(cvar(1:lv) == 'cloud_frac') then
   ierr=RAMS_getvar('RV',ngrd,b,a,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,a,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('THETA',ngrd,d,a,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_rh(n1,n2,n3,b,c,d)
   call RAMS_comp_noneg(n1,n2,n3,b)
   call cldfraction(n1,n2,n3,a,c,b)
   call RAMS_comp_1minus(n1,n2,n3,a)
   call set_var_info(class=2, name='cloud cover;', units='frac;')

! 3D HYDROMETEOR, CCN, CN, Dep N, AND NONHYGROSCOPIC AEROSOL NUMBER CONCEN

elseif(cvar(1:lv) == 'cloud_concen_mg') then
   ierr=RAMS_getvar('CCP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,n3,a,1.e-6)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='cloud concen;', units='#/mg;')

elseif(cvar(1:lv) == 'rain_concen_kg') then
   ierr=RAMS_getvar('CRP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='rain concen;', units='#/kg;')

elseif(cvar(1:lv) == 'pris_concen_kg') then
   ierr=RAMS_getvar('CPP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='pristine concen;', units='#/kg;')

elseif(cvar(1:lv) == 'snow_concen_kg') then
   ierr=RAMS_getvar('CSP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='snow concen;', units='#/kg;')

elseif(cvar(1:lv) == 'agg_concen_kg') then
   ierr=RAMS_getvar('CAP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='aggregate concen;', units='#/kg;')

elseif(cvar(1:lv) == 'graup_concen_kg') then
   ierr=RAMS_getvar('CGP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='graupel concen;', units='#/kg;')

elseif(cvar(1:lv) == 'hail_concen_kg') then
   ierr=RAMS_getvar('CHP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='hail concen;', units='#/kg;')

elseif(cvar(1:lv) == 'cloud_concen_cm3') then
   ierr=RAMS_getvar('CCP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_mults(n1,n2,n3,a,1.e-6)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='cloud concen;', units='#/cm3;')

elseif(cvar(1:lv) == 'rain_concen_m3') then
   ierr=RAMS_getvar('CRP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='rain concen;', units='#/m3;')

elseif(cvar(1:lv) == 'pris_concen_m3') then
   ierr=RAMS_getvar('CPP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='pristine concen;', units='#/m3;')

elseif(cvar(1:lv) == 'snow_concen_m3') then
   ierr=RAMS_getvar('CSP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='snow concen;', units='#/m3;')

elseif(cvar(1:lv) == 'agg_concen_m3') then
   ierr=RAMS_getvar('CAP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='aggregates concen;', units='#/m3;')

elseif(cvar(1:lv) == 'graup_concen_m3') then
   ierr=RAMS_getvar('CGP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='graupel concen;', units='#/m3;')

elseif(cvar(1:lv) == 'hail_concen_m3') then
   ierr=RAMS_getvar('CHP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,d,e,ngrd)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='hail concen;', units='#/m3;')

elseif(cvar(1:lv) == 'ccn_concen') then
   ierr=RAMS_getvar('CCCNP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call RAMS_comp_mults(n1,n2,n3,a,1.e-6)
   call set_var_info(class=3, name='ccn1 concen;', units='#/mg;')

elseif(cvar(1:lv) == 'ifn_conc') then
   ierr=RAMS_getvar('CIFNP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='CN mix ratio;', units='#/kg;')

! 3D HYDROMETEOR DIAMETERS

elseif(cvar(1:lv) == 'cloud_diam') then
   ierr=RAMS_getvar('RCP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('CCP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_hydrodiam(n1,n2,n3,a,c,cvar,ngrd)
   call RAMS_comp_mults(n1,n2,n3,a,1.e6)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='cloud diam;', units='microns;')

elseif(cvar(1:lv) == 'rain_diam') then
   ierr=RAMS_getvar('RRP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('CRP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_hydrodiam(n1,n2,n3,a,c,cvar,ngrd)
   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='rain diam;', units='mm;')

elseif(cvar(1:lv) == 'pris_diam') then
   ierr=RAMS_getvar('RPP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('CPP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
! more general case: write habit to anal file for cfmas & pwmas index
   call RAMS_comp_hydrodiam(n1,n2,n3,a,c,cvar,ngrd)
   call RAMS_comp_mults(n1,n2,n3,a,1.e6)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='pristine diam;', units='microns;')

elseif(cvar(1:lv) == 'snow_diam') then
   ierr=RAMS_getvar('RSP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('CSP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
! more general case: write habit to anal file for cfmas & pwmas index
   call RAMS_comp_hydrodiam(n1,n2,n3,a,c,cvar,ngrd)
   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='snow diam;', units='mm;')

elseif(cvar(1:lv) == 'agg_diam') then
   ierr=RAMS_getvar('RAP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('CAP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_hydrodiam(n1,n2,n3,a,c,cvar,ngrd)
   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='aggregates diam;', units='mm;')

elseif(cvar(1:lv) == 'graup_diam') then
   ierr=RAMS_getvar('RGP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('CGP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_hydrodiam(n1,n2,n3,a,c,cvar,ngrd)
   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='graupel diam;', units='mm;')

elseif(cvar(1:lv) == 'hail_diam') then 
   ierr=RAMS_getvar('RHP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('CHP',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_hydrodiam(n1,n2,n3,a,c,cvar,ngrd)
   call RAMS_comp_mults(n1,n2,n3,a,1.e3)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='hail diam;', units='mm;')

! 3D HYDROMETEOR TEMPERATURE, THERMAL ENERGY, LIQUID WATER FRACTION

elseif(cvar(1:lv) == 'q2') then
   ierr=RAMS_getvar('Q2',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='q2;', units='J/kg;')

elseif(cvar(1:lv) == 'q6') then
   ierr=RAMS_getvar('Q6',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='q6;', units='J/kg;')

elseif(cvar(1:lv) == 'q7') then
   ierr=RAMS_getvar('Q7',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='q7;', units='J/kg;')

elseif(cvar(1:lv) == 'rain_temp') then
   ierr=RAMS_getvar('Q2',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_raintemp(n1,n2,n3,a)
   call set_var_info(class=3, name='rain temperature;', units='K;')

elseif(cvar(1:lv) == 'graup_temp') then
   ierr=RAMS_getvar('Q6',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_qtcpcp(n1,n2,n3,a)
   call set_var_info(class=3, name='graupel temperature;', units='C;')

elseif(cvar(1:lv) == 'hail_temp') then
   ierr=RAMS_getvar('Q7',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_qtcpcp(n1,n2,n3,a)
   call set_var_info(class=3, name='hail temperature;', units='C;')

elseif(cvar(1:lv) == 'rain_air_tempdif') then
   ierr=RAMS_getvar('Q2',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_raintemp(n1,n2,n3,a)
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm)
   call RAMS_comp_tempK(n1,n2,n3,d,c)
   call RAMS_comp_tempC(n1,n2,n3,d)
   call RAMS_comp_subt(n1,n2,n3,a,d)
   call set_var_info(class=3, name='rain-air temp;', units='K;')

elseif(cvar(1:lv) == 'graup_air_tempdf') then
   ierr=RAMS_getvar('Q6',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_qtcpcp(n1,n2,n3,a)
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm)
   call RAMS_comp_tempK(n1,n2,n3,d,c)
   call RAMS_comp_tempC(n1,n2,n3,d)
   call RAMS_comp_subt(n1,n2,n3,a,d)
   call set_var_info(class=3, name='graupel-air temp;', units='K;')

elseif(cvar(1:lv) == 'hail_air_tempdif') then
   ierr=RAMS_getvar('Q7',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_qtcpcp(n1,n2,n3,a)
   ierr=RAMS_getvar('THETA',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('PI',ngrd,c,b,flnm)
   call RAMS_comp_tempK(n1,n2,n3,d,c)
   call RAMS_comp_tempC(n1,n2,n3,d)
   call RAMS_comp_subt(n1,n2,n3,a,d)
   call set_var_info(class=3, name='hail-air temp;', units='K;')

elseif(cvar(1:lv) == 'graup_fracliq') then
   ierr=RAMS_getvar('Q6',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_fracliq(n1,n2,n3,a)
   call set_var_info(class=3, name='graupel liq frac;', units=';')

elseif(cvar(1:lv) == 'hail_fracliq') then
   ierr=RAMS_getvar('Q7',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_fracliq(n1,n2,n3,a)
   call set_var_info(class=3, name='hail liq frac;', units=';')

! 3D MISCELLANEOUS FIELDS

elseif(cvar(1:lv) == 'geo') then
   ierr=RAMS_getvar('TOPT',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_z(n1,n2,n3,a,c,ngrd)
   call set_var_info(class=3, name='geopotential height;', units='m;')

elseif(cvar(1:lv) == 'tke') then
   ierr=RAMS_getvar('TKEP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='turb kinetic energy;', units='m2/s2;')
   
elseif(cvar(1:lv) == 'eps') then
   ierr=RAMS_getvar('EPSP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='tke diss rate;', units='m2/s3;')

elseif(cvar(1:lv) == 'pbl_ht') then
   ierr=RAMS_getvar('TKEP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TOPT',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_pbl(n1,n2,n3,a,c,ngrd)
   call set_var_info(class=2, name='PBL height;', units='m;')

elseif(cvar(1:lv) == 'scalar1') then
   ierr=RAMS_getvar('SCLP001',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='scalar1 mixing ratio;', units='units/kg;')

elseif(cvar(1:lv) == 'scalar2') then
   ierr=RAMS_getvar('SCLP002',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='scalar2 mixing ratio;', units='units/kg;')

elseif(cvar(1:lv) == 'scalar3') then
   ierr=RAMS_getvar('SCLP003',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='scalar3 mixing ratio;', units='units/kg;')

elseif(cvar(1:lv) == 'scalar4') then
   ierr=RAMS_getvar('SCLP004',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='scalar4 mixing ratio;', units='units/kg;')

!     ; etc. for scalars

elseif(cvar(1:lv) == 'cuparm_thetasrc') then
   ierr=RAMS_getvar('THSRC',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='conv heat rate;', units='K/s;')

elseif(cvar(1:lv) == 'cuparm_rtsrc') then
   ierr=RAMS_getvar('RTSRC',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='conv moist rate;', units='kg/kg/s;')

elseif(cvar(1:lv) == 'rad_thetasrc') then
   ierr=RAMS_getvar('FTHRD',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='rad heat rate;', units='K/s;')

elseif(cvar(1:lv) == 'khh') then
   ierr=RAMS_getvar('HKH',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='horiz diffusion coeff;', units='m2/s;')

elseif(cvar(1:lv) == 'khv') then
   ierr=RAMS_getvar('VKH',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=3, name='vert diffusion coeff;', units='m2/s;')






!-------------------------------------------------------------------------------
! Surface precipitation variables

elseif(cvar(1:lv) == 'totpcp' .or. cvar(1:lv) == 'totpcp_in' .or.  &
       cvar(1:lv) == 'precip' .or. cvar(1:lv) == 'precip_in') then
   call RAMS_comp_zero(n1,n2,1,a)
   ierr=RAMS_getvar('ACCPR',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('ACCPP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('ACCPS',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('ACCPA',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('ACCPG',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('ACCPH',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)

   if (cvar(1:6) == 'precip') then
      ierr=RAMS_getvar('ACONPR',ngrd,c,b,flnm)
      if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
      call set_var_info(class=2, name='total accum precip;', units='mm liq;')
   else
      call set_var_info(class=2, name='total resolved precip;', units='mm liq;')
   endif

   if(index(cvar(1:lv),'_in') > 0)  then
      call set_var_info( units='in liq;')
      call RAMS_comp_mults(n1,n2,n3,a,.03937)
   endif
   call RAMS_comp_noneg(n1,n2,1,a)

elseif(cvar(1:lv) == 'accpr') then
   ierr=RAMS_getvar('ACCPR',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='accum rain;', units='mm;')

elseif(cvar(1:lv) == 'accpp') then
   ierr=RAMS_getvar('ACCPP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='accum pristine;', units='mm;')

elseif(cvar(1:lv) == 'accps') then
   ierr=RAMS_getvar('ACCPS',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='accum snow;', units='mm;')

elseif(cvar(1:lv) == 'accpa') then
   ierr=RAMS_getvar('ACCPA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='accum aggregates;', units='mm;')

elseif(cvar(1:lv) == 'accpg') then
   ierr=RAMS_getvar('ACCPG',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='accum graupel;', units='mm;')

elseif(cvar(1:lv) == 'accph') then
   ierr=RAMS_getvar('ACCPH',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='accum hail;', units='mm;')

elseif(cvar(1:lv) == 'pcprate'.or.cvar(1:lv) == 'pcprate_in'.or.  &
       cvar(1:lv) == 'precipr'.or.cvar(1:lv) == 'precipr_in') then
   call RAMS_comp_zero(n1,n2,1,a)
   ierr=RAMS_getvar('PCPRR',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('PCPRP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('PCPRS',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('PCPRA',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('PCPRG',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   ierr=RAMS_getvar('PCPRH',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
   call RAMS_comp_noneg(n1,n2,1,a)

   if (cvar(1:7) == 'precipr') then
      ierr=RAMS_getvar('CONPRR',ngrd,c,b,flnm)
      if(ierr == 0) call RAMS_comp_accum(n1,n2,1,a,c)
      call set_var_info(class=2, name='total precip rate;', units='mm/hr liq;')
   else
      call set_var_info(class=2, name='resolved precip rate;', units='mm/hr liq;')
   endif
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call RAMS_comp_noneg(n1,n2,1,a)

   if(index(cvar(1:lv),'_in') > 0)  then
      call RAMS_comp_mults(n1,n2,n3,a,.03937)
      call set_var_info( units='in/hr liq;')
   endif

elseif(cvar(1:lv) == 'pcprr') then
   ierr=RAMS_getvar('PCPRR',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call set_var_info(class=2, name='rain precip rate;', units='mm/hr liq;')

elseif(cvar(1:lv) == 'pcprp') then
   ierr=RAMS_getvar('PCPRP',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call set_var_info(class=2, name='pristine precip rate;', units='mm/hr liq;')

elseif(cvar(1:lv) == 'psprs') then
   ierr=RAMS_getvar('PCPRS',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call set_var_info(class=2, name='snow precip rate;', units='mm/hr liq;')

elseif(cvar(1:lv) == 'pcpra') then
   ierr=RAMS_getvar('PCPRA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call set_var_info(class=2, name='aggregates precip rate;', units='mm/hr liq;')

elseif(cvar(1:lv) == 'pcprg') then
   ierr=RAMS_getvar('PCPRG',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call set_var_info(class=2, name='graupel precip rate;', units='mm/hr liq;')

elseif(cvar(1:lv) == 'pcprh') then
   ierr=RAMS_getvar('PCPRH',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call set_var_info(class=2, name='hail precip rate;', units='mm/hr liq;')

elseif(cvar(1:lv) == 'pcpg') then
   ierr=RAMS_getvar('PCPG',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='pcpg;', units='mm;')

elseif(cvar(1:lv) == 'qpcpg') then
   ierr=RAMS_getvar('QPCPG',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='qpcpg;', units='J/m2;')

elseif(cvar(1:lv) == 'dpcpg') then
   ierr=RAMS_getvar('DPCPG',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=2, name='dpcpg;', units='m;')

elseif(cvar(1:lv) == 'conpcp') then
   ierr=RAMS_getvar('CONPRR',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mults(n1,n2,1,a,3600.)
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='convective pcp rate;', units='mm/hr;')

elseif(cvar(1:lv) == 'acccon') then
   ierr=RAMS_getvar('ACONPR',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='accum convective pcp;', units='mm;')

   ! Vertically-integrated atmospheric moisture

elseif(cvar(1:lv) == 'vertint_rt' .or. cvar(1:lv) == 'vertint_cond') then
   ierr=RAMS_getvar('TOPT',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,c,b,d,e,ngrd)
   if (cvar(1:lv) == 'vertint_rt') then
      ierr=RAMS_getvar('RV',ngrd,a,b,flnm)
      call set_var_info(class=2, name='vertint total water;', units='mm;')
   else
      call RAMS_comp_zero(n1,n2,n3,a)
      call set_var_info(class=2, name='vertint condensate;', units='mm;')
   endif
   ierr=RAMS_getvar('RCP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RRP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RPP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RSP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RAP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RGP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('RHP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   call RAMS_comp_mult(n1,n2,n3,a,d)
   call RAMS_comp_vertint(n1,n2,n3,a,e,ngrd)


!-------------------------------------------------------------------------------
! LEAF variables

elseif(cvar(1:lv) == 'patch_area') then
   ierr=RAMS_getvar('PATCH_AREA',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   call set_var_info(class=6, name='patch fractional area;', units=';')

elseif(cvar(1:lv) == 'canopy_mixrat_p' .or. cvar(1:lv) == 'canopy_mixrat_ps') then
   ierr=RAMS_getvar('CAN_RVAP',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'canopy_mixrat_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='canopy mixing ratio;', units='g/kg;')
      call RAMS_comp_mults(n1,n2,npatch,a,1.e3)
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='canopy mixing ratio_ps;', units='g/kg;')
      call RAMS_comp_mults(n1,n2,1,a,1.e3)
   endif
   

elseif(cvar(1:lv) == 'canopy_temp_p' .or. cvar(1:lv) == 'canopy_temp_ps') then
   ierr=RAMS_getvar('CAN_TEMP',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'canopy_temp_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='canopy temperature;', units='C;')
      call RAMS_comp_tempC(n1,n2,npatch,a)
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='canopy temperature_ps;', units='C;')
      call RAMS_comp_tempC(n1,n2,1,a)
   endif
   

elseif(cvar(1:lv) == 'veg_temp_p' .or. cvar(1:lv) == 'veg_temp_ps') then
   ierr=RAMS_getvar('VEG_TEMP',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'veg_temp_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='vegetation temperature;', units='C;')
      call RAMS_comp_tempC(n1,n2,npatch,a)
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='vegetation temperature_ps;', units='C;')
      call RAMS_comp_tempC(n1,n2,1,a)
   endif

elseif(cvar(1:lv) == 'veg_z0_p' .or. cvar(1:lv) == 'veg_z0_ps') then
   ierr=RAMS_getvar('VEG_ROUGH',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'veg_z0_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='veg roughness;', units='m;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='veg roughness_ps;', units='m;')
   endif

elseif(cvar(1:lv) == 'soil_z0_p' .or. cvar(1:lv) == 'soil_z0_ps') then
   ierr=RAMS_getvar('SOIL_ROUGH',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'soil_z0_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='soil roughness;', units='m;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='soil roughness_ps;', units='m;')
   endif

elseif(cvar(1:lv) == 'veg_class_p' .or. cvar(1:lv) == 'veg_class_bp') then
   ierr=RAMS_getvar('LEAF_CLASS',ngrd,d,b,flnm)
   if(ierr==1) ierr=RAMS_getvar('VEG_CLASS',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_vegclass(n1*n2*npatch,1,1,d)

   if (cvar(1:lv) == 'veg_class_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='vegetation class;', units='#;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_bigpatch(n1,n2,1,npatch ,d,e,a)
      call set_var_info(class=2, name='vegetation class;', units='#;')
   endif

elseif(cvar(1:lv) == 'veg_ndvi_p' .or. cvar(1:lv) == 'veg_ndvi_ps') then
   ierr=RAMS_getvar('VEG_NDVIC',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'veg ndvi_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='veg ndvi;', units=';')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='veg ndvi_ps;', units=';')
   endif

elseif(cvar(1:lv) == 'ustar_p' .or. cvar(1:lv) == 'ustar_ps') then
   ierr=RAMS_getvar('USTAR',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'ustar_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='ustar;', units='m/s;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='ustar_ps;', units='m/s;')
   endif

elseif(cvar(1:lv) == 'tstar_p' .or. cvar(1:lv) == 'tstar_ps') then
   ierr=RAMS_getvar('TSTAR',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'tstar_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='tstar;', units='K;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='tstar_ps;', units='K;')
   endif

elseif(cvar(1:lv) == 'rstar_p' .or. cvar(1:lv) == 'rstar_ps') then
   ierr=RAMS_getvar('RSTAR',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100

   if(cvar(1:lv) == 'rstar_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='rstar;', units='kg/kg;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch,d,e,a)
      call set_var_info(class=2, name='rstar_ps;', units='kg/kg;')
   endif

elseif(cvar(1:lv) == 'sens_heat_flux_p' .or.  &
       cvar(1:lv) == 'sens_heat_flux_ps') then
   ierr=RAMS_getvar('USTAR',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('TSTAR',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mult(n1,n2,npatch,d,c)

   ierr=RAMS_getvar('TOPT',ngrd,a,ff,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,e,a,ngrd)
   call RAMS_comp_multap(n1,n2,1,npatch,d,e)
   call RAMS_comp_mults(n1,n2,npatch,d,-1004.)

   if(cvar(1:lv) == 'sens_heat_flux_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='sfc sens heat flux;', units='W/m2;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch ,d,e,a)
      call set_var_info(class=2, name='sfc sens heat flux_ps;', units='W/m2;')
   endif

elseif(cvar(1:lv) == 'lat_heat_flux_p' .or.  &
       cvar(1:lv) == 'lat_heat_flux_ps') then
   ierr=RAMS_getvar('USTAR',ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('RSTAR',ngrd,c,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_mult(n1,n2,npatch,d,c)

   ierr=RAMS_getvar('TOPT',ngrd,a,ff,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_dn0(n1,n2,n3,b,c,e,a,ngrd)
   call RAMS_comp_multap(n1,n2,1,npatch,d,e)
   call RAMS_comp_mults(n1,n2,npatch,d,-2.5e6)

   if(cvar(1:lv) == 'sens_heat_flux_p') then
      call atob(n1*n2*npatch,d,a)
      call set_var_info(class=6, name='sfc latent heat flux;', units='W/m2;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,1,npatch ,d,e,a)
      call set_var_info(class=2, name='sfc latent heat flux_ps;', units='W/m2;')
   endif

elseif(cvar(1:lv) == 'soil_temp_p' .or. cvar(1:lv) == 'soil_temp_ps') then
   ierr=RAMS_getvar('SOIL_ENERGY',ngrd,a,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('SOIL_WATER' ,ngrd,d,b,flnm) ; if(ierr /= 0) goto 100
   ierr=RAMS_getvar('SOIL_TEXT'  ,ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_copysst(n1,n2,nzg,a)
   call RAMS_comp_qwtc(n1,n2,nzg,npatch,a,d,e)

   if (cvar(1:lv) == 'soil_temp_p') then
      call set_var_info(class=8, name='soil/sea temp;', units='C;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum(n1,n2,nzg,npatch,a,e,d)
      call atob(n1*n2*nzg,d,a)
      call set_var_info(class=5, name='soil/sea temp-ps;', units='C;')
   endif

elseif(cvar(1:lv) == 'soil_moist_p' .or. cvar(1:lv) == 'soil_moist_ps') then
   ierr=RAMS_getvar('SOIL_WATER',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   if (cvar(1:lv) == 'soil_moist_p') then
      call set_var_info(class=8, name='soil moisture;', units='m3/m3;')
   else
      ierr=RAMS_getvar('PATCH_AREA',ngrd,e,b,flnm) ; if(ierr /= 0) goto 100
      call RAMS_comp_patchsum_l (n1,n2,nzg,npatch ,a,e,d)
      call atob(n1*n2*nzg,d,a)
      call set_var_info(class=5, name='soil moisture-ps;', units='m3/m3;')
   endif


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!   CAMx averaged chemical species
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

elseif(cvar(1:lv) == 'ch-no' ) then
   ierr=RAMS_getvar('CH-NO',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='no;', units='ppm;')

elseif(cvar(1:lv) == 'ch-no-ug' ) then
   ierr=RAMS_getvar('CH-NO',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call RAMS_comp_mults(n1,n2,n3,a,1339.)
   call set_var_info(class=3, name='no;', units='ug/m3;')

elseif(cvar(1:lv) == 'ch-no2' ) then
   ierr=RAMS_getvar('CH-NO2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='no2;', units='ppm;')

elseif(cvar(1:lv) == 'ch-no2-ug' ) then
   ierr=RAMS_getvar('CH-NO2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call RAMS_comp_mults(n1,n2,n3,a,2054.)
   call set_var_info(class=3, name='no2;', units='ug/m3;')

elseif(cvar(1:lv) == 'ch-co' ) then
   ierr=RAMS_getvar('CH-NO2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='carbon monoxide;', units='ppm;')

elseif(cvar(1:lv) == 'ch-co-mg' ) then
   ierr=RAMS_getvar('CH-NO2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call RAMS_comp_mults(n1,n2,n3,a,1.250)
   call set_var_info(class=3, name='carbon monoxide;', units='mg/m3;')

elseif(cvar(1:lv) == 'ch-o3' ) then
   ierr=RAMS_getvar('CH-O3',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='ozone;', units='ppm;')

elseif(cvar(1:lv) == 'ch-o3-ug' ) then
   ierr=RAMS_getvar('CH-O3',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call RAMS_comp_mults(n1,n2,n3,a,2143.)
   call set_var_info(class=3, name='ozone;', units='ug/m3;')

elseif(cvar(1:lv) == 'ch-so2' ) then
   ierr=RAMS_getvar('CH-SO2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='sulphur dioxide;', units='ppm;')

elseif(cvar(1:lv) == 'ch-so2-ug' ) then
   ierr=RAMS_getvar('CH-SO2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call RAMS_comp_mults(n1,n2,n3,a,2857.)
   call set_var_info(class=3, name='sulphur dioxide;', units='ug/m3;')

elseif(cvar(1:lv) == 'ch-par' ) then
   ierr=RAMS_getvar('CH-PAR',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='par;', units='ppm;')

elseif(cvar(1:lv) == 'ch-tol' ) then
   ierr=RAMS_getvar('CH-TOL',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='tol;', units='ppm;')

elseif(cvar(1:lv) == 'ch-eth' ) then
   ierr=RAMS_getvar('CH-ETH',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='eth;', units='ppm;')

elseif(cvar(1:lv) == 'ch-ole' ) then
   ierr=RAMS_getvar('CH-OLE',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='ole;', units='ppm;')

elseif(cvar(1:lv) == 'ch-pan' ) then
   ierr=RAMS_getvar('CH-PAN',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='pan;', units='ppm;')

elseif(cvar(1:lv) == 'ch-isop' ) then
   ierr=RAMS_getvar('CH-ISOP',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='isoprene;', units='ppm;')

elseif(cvar(1:lv) == 'ch-xyl' ) then
   ierr=RAMS_getvar('CH-XYL',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='xyl;', units='ppm;')

elseif(cvar(1:lv) == 'ch-form' ) then
   ierr=RAMS_getvar('CH-FORM',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='form;', units='ppm;')

elseif(cvar(1:lv) == 'ch-ald2' ) then
   ierr=RAMS_getvar('CH-ALD2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='ald2;', units='ppm;')

elseif(cvar(1:lv) == 'ch-hno3' ) then
   ierr=RAMS_getvar('CH-HNO3',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='hno3;', units='ppm;')

elseif(cvar(1:lv) == 'ch-nxoy' ) then
   ierr=RAMS_getvar('CH-NXOY',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='nxoy;', units='ppm;')

elseif(cvar(1:lv) == 'ch-ntr' ) then
   ierr=RAMS_getvar('CH-NTR',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,n3,a)
   call set_var_info(class=3, name='ntr;', units='ppm;')

elseif(cvar(1:lv) == 'ch-voc'.or.cvar(1:lv) == 'ch-voc-ug') then
   call RAMS_comp_zero(n1,n2,n3,a)
   ierr=RAMS_getvar('CH-ETH',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-OLE',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-PAR',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-TOL',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-XYL',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-FORM',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-ALD2',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-ISOP',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   call RAMS_comp_noneg(n1,n2,n3,a)
   if(cvar(1:lv)=='ch-voc-ug') then
      call RAMS_comp_mults(n1,n2,n3,a,6696.)
      call set_var_info(class=3, name='VOC;', units='ug/m3;')
   else
      call set_var_info(class=3, name='VOC;', units='ppm;')
   endif

elseif(cvar(1:lv) == 'ch-pm10'.or.cvar(1:lv) == 'ch-pm10-ug') then
   call RAMS_comp_zero(n1,n2,n3,a)
   ierr=RAMS_getvar('CH-PNO3',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-PSO4',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-PNH4',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-POA',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-SOA1',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-SOA2',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-SOA3',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-SOA4',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-PEC',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-FPRM',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-FCRS',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-CPRM',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-CCRS',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-NA',ngrd,c,b,flnm)
   if(ierr == 0) call RAMS_comp_accum(n1,n2,n3,a,c)
   ierr=RAMS_getvar('CH-PCL',ngrd,c,b,flnm)
   call RAMS_comp_noneg(n1,n2,n3,a)
   call setvar_info(class=3, name='ch-pm10;', units='ug/m3;')

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!   CAMx area emission species
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

elseif(cvar(1:lv) == 'em-no' ) then
   ierr=RAMS_getvar('EM-NO',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-no;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-no2' ) then
   ierr=RAMS_getvar('EM-NO2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-no2;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-par' ) then
   ierr=RAMS_getvar('EM-PAR',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-par;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-tol' ) then
   ierr=RAMS_getvar('EM-TOL',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-tol;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-eth' ) then
   ierr=RAMS_getvar('EM-ETH',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-eth;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-ole' ) then
   ierr=RAMS_getvar('EM-OLE',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-ole;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-isop' ) then
   ierr=RAMS_getvar('EM-ISOP',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-isoprene;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-xyl' ) then
   ierr=RAMS_getvar('EM-XYL',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-xyl;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-form' ) then
   ierr=RAMS_getvar('EM-FORM',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-form;', units='moles/hr;')

elseif(cvar(1:lv) == 'em-ald2' ) then
   ierr=RAMS_getvar('EM-ALD2',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='emiss-ald2;', units='moles/hr;')

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!   CAMx landuse classes
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

elseif(cvar(1:lv) == 'lu-01' ) then
   ierr=RAMS_getvar('LU-01',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-01;', units='fraction;')
elseif(cvar(1:lv) == 'lu-02' ) then
   ierr=RAMS_getvar('LU-02',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-02;', units='fraction;')
elseif(cvar(1:lv) == 'lu-03' ) then
   ierr=RAMS_getvar('LU-03',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-03;', units='fraction;')
elseif(cvar(1:lv) == 'lu-04' ) then
   ierr=RAMS_getvar('LU-04',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-04;', units='fraction;')
elseif(cvar(1:lv) == 'lu-05' ) then
   ierr=RAMS_getvar('LU-05',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-05;', units='fraction;')
elseif(cvar(1:lv) == 'lu-06' ) then
   ierr=RAMS_getvar('LU-06',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-06;', units='fraction;')
elseif(cvar(1:lv) == 'lu-07' ) then
   ierr=RAMS_getvar('LU-07',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-07;', units='fraction;')
elseif(cvar(1:lv) == 'lu-08' ) then
   ierr=RAMS_getvar('LU-08',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-08;', units='fraction;')
elseif(cvar(1:lv) == 'lu-09' ) then
   ierr=RAMS_getvar('LU-09',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-09;', units='fraction;')
elseif(cvar(1:lv) == 'lu-10' ) then
   ierr=RAMS_getvar('LU-10',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-10;', units='fraction;')
elseif(cvar(1:lv) == 'lu-11' ) then
   ierr=RAMS_getvar('LU-11',ngrd ,a,b,flnm) ; if(ierr /= 0) goto 100
   call RAMS_comp_noneg(n1,n2,1,a)
   call set_var_info(class=2, name='camx-landuse-11;', units='fraction;')


else

   print*,'Variable name not found in hvlib.f90 - ',cvar(1:lv)
   call set_var_info ( class=0, name=cvar(1:lv), units=' ' )

endif

100 continue

print*,'hvhvhvhvhvhvhvhvhvhv:',ierr
if(ierr == 1 ) call set_var_info ( class=0 )
if(ierr == 2 ) call set_var_info ( class=-1 )

return
end


!***************************************************************************

subroutine read_SPEC(ispec,isrc,flnm,cdname,cdunits)

! Routine opens the SPEC file for HYPACT runs to get the variable name and
! units

character*(*) flnm,cdname,cdunits
character sflnm*80,line*256,tokens(20)*32

cdname='none;'
cdunits='none;'

lp=index(flnm(lastslash(flnm):),'-')
sflnm=flnm(1:lp+lastslash(flnm)-1)//'spec.txt'

open(8,file=sflnm,status='old')
read(8,'(a)') line
call parse(line,tokens,ntok)
read(tokens(1),*) iver
read(tokens(2),*) nsources
do nsrc=1,nsources
   read(8,'(a)') line
   call parse(line,tokens,ntok)
   read(tokens(1),*) isrcf
   read(tokens(8),*) ispecf
   if(isrc == isrcf.or.isrc == -1.or.isrc == 0) then
      if(isrc == 0) then
         cdunits='all sources;'
      elseif(isrc == -1) then
         cdunits=tokens(10)(1:len_trim(tokens(10)))//'/m:S:3:N:;'
      else
         cdunits=tokens(3)(1:len_trim(tokens(3)))//';'
      endif
      if(ispec == ispecf.or.ispec == 0) then
         if(ispec == 0) then
            cdname='all species;'
         else
            cdname=tokens(9)(2:len_trim(tokens(9))-1)//';'
         endif
         goto 2
      endif
   endif
enddo
2 continue
close(8)

!print*,cdname
!print*,cdunits

return
end

