!############################# Change Log ##################################
! 3.0.0
!

subroutine plot_frame (paction)

use pl_params
use define_colors
use ra_file_info

implicit none

character(len=*) :: paction

logical, allocatable, save :: fexist(:,:)
integer, save :: ncall=0,nfiles,ngrids_pl

integer :: nv,nf,ng,itime,nvgr

print*,'start plot_frame: ',cvar(1)(1:4),' ',cwinds(1:1), ' ',cvar(2)(1:4)

! Default color table and alias
call default_colors(ibgnd)


if (ncall == 0) then
   ncall = 1

   ! Color settings - this had to be done after gks is opened
   !  Not sure its needed any more
   call default_colindex (iwkstation)
   !call draw_colours(1,40,'first')
   !call frame
   !return
   
   ! ra_init is called to inventory which files are here
   call ra_init(nfiles,anpref)
   call ra_set_file(1,1)
   call ra_get_idata(1,1,ngrids_pl,nv)
   allocate (fexist(nfiles,ngrids_pl))
   do nf=1,nfiles
      call ra_set_file(1,nf)
      do ng=1,ngrids_pl
         call ra_get_ldata(0,ng,fexist(nf,ng),nv)
      enddo
   enddo
   
endif
 
    
! skip this frame if nothing to plot. May want only a grid picture... 
!if(cvar(1)(1:4) =='none' .and. cwinds(1:1)   =='n'.and.  &
!   cvar(2)(1:4) =='none') return

      
! print action summary
print*
if(cvar(1)(1:4) /= 'none') print*,  &
    'Plotting prim var - ',trim(cvar(1)),' / ',conttyp(1),' / ',ctime
    
! Find if the requested grid is available at this time...

read(ctime,*) itime
read(cgrid,*) nvgr

if (.not.fexist(itime,nvgr)) then
   print*,'Header file number:',itime
   print*,'Requested grid does not exist:',nvgr,' - skipping...'
   return
endif
   
   
if(cwinds == 'b') print*,'Plotting winds    - barbs'
if(cwinds == 'v') print*,'Plotting winds    - vectors'
if(cwinds == 's') print*,'Plotting winds    - streamlines'
if(cwinds == 't') print*,'Plotting winds    - vectors and turbulence'
if(cwinds == 'r') print*,'Plotting winds    - vectors and vorticity'

if(cvar(2)(1:4) /= 'none') print*,  &
    'Plotting sec var  - ',trim(cvar(2)),' / ',conttyp(2)

if(slab_type == 'XZ') then
   horiz='X' ; vert='Z'
   islab=1
   niboff=ixbeg ; njboff=iybeg ; nnboff=0
   nieoff=ixend ; njeoff=iyend ; nneoff=0
   niinc=1      ; njinc=1      ; nninc=1
   icoor=islab_coor
elseif(slab_type == 'YZ') then
   horiz='Y' ; vert='Z'
   islab=2
   niboff=ixbeg ; njboff=iybeg ; nnboff=0
   nieoff=ixend ; njeoff=iyend ; nneoff=0
   niinc=1      ; njinc=1      ; nninc=1
   icoor=islab_coor
elseif(slab_type == 'XY') then
   horiz='X' ; vert='Y'
   islab=3
   niboff=ixbeg ; njboff=iybeg ; nnboff=0
   nieoff=ixend ; njeoff=iyend ; nneoff=0
   niinc=1      ; njinc=1      ; nninc=1
   icoor=islab_coor
else
   print*,'slab_type: ',slab_type,' : not allowed'
   stop 'bad slab'
endif

print*,'islab,icoor',islab,icoor
print*,'niboff,nieoff,nninc',niboff,nieoff,nninc
print*,'njboff,njeoff,njinc',njboff,njeoff,njinc
print*,'nnboff,nneoff,niinc',nnboff,nneoff,niinc


call pl_opspec()

print*,'------------------------call pl_driver'
call pl_driver ('revu')

call frame


return
end

!***************************************************************************

subroutine pl_opspec ()

use pl_params

implicit none

integer :: ivar,nclevels


      if(abs(mfill).gt.3) then
         print*,'MFILL must be between -3 and 3',MFILL
         stop 'plotspc'
      endif
      if(abs(ibgnd).gt.3) then
         print*,'IBACKGND must be between -3 and 3',IBGND
         stop 'plotspc'
      endif
      if(ipanl.lt.0.or.ipanl.gt.4) then
         print*,'IPANEL must be between 0 and 4',IPANL
         stop 'plotspc'
      endif
      
      if(iztran==0) then
         print*,'IZTRAN not specified'
         stop 'plotspc'
      endif
      if(iplevel==0.and.iztran==3) then
         print*,'IPLEVEL not specified'
         stop 'plotspc'
      endif
      
      if(islab.ne.3.and.iztran.ne.1) then
         print*,'iztran',iztran
         print*,'islab',islab
         print*,'Cannot plot vertical cartesian or pressure surfaces'
         stop 'plotspc'
      endif

!      if(ilmarkers < 0.or.ilmarkers > 1) then
!         print*,'LANDMARK marker on/off parameter '  &
!               ,'(M - integer) must be between 0 '  &
!               ,'and 1',ilmarkers
!         print*,landmark
!         stop 'landmkset'
!      endif
      if(bufflandmk < 0..or.bufflandmk > .1) then
         print*,'LANDMARK marker buffer parameter '  &
               ,'(b - real) must be between 0.0 '  &
               ,'and 0.1',bufflandmk
         print*,landmark
         stop 'landmkset'
      endif
      if(itypelandmk < 1.or.itypelandmk > 5) then
         print*,'LANDMARK marker type parameter '  &
               ,'(t - integer) must be between '  &
               ,'1 and 5',itypelandmk
         print*,landmark
         stop 'landmkset'
      endif
      if(sizelandmk < 0.1.or.sizelandmk > 10.) then
         print*,'LANDMARK marker size parameter '  &
               ,'(s - real) must be between 0.1 '  &
               ,'and 10.0',sizelandmk
         print*,landmark
         stop 'landmkset'
      endif
      if(ilandlab < 0.or.ilandlab > 1) then
         print*,'LANDMARK label on/off parameter '  &
               ,'(L - integer) must be between 0 '  &
               ,'and 1',ilandlab
         print*,landmark
         stop 'landmkset'
      endif
      if(sizelandlab < .002.or.sizelandlab > .05) then
         print*,'LANDMARK label size parameter '  &
               ,'(s - real) must be between 0.002 '  &
               ,'and 0.05',sizelandlab
         print*,landmark
         stop 'landmkset'
      endif

do ivar = 1,2
   if(conttyp(ivar)(1:1) /= 'c ' .and. conttyp(ivar)(1:1) /= 'f ' .and. &
      conttyp(ivar)(1:1) /= 't ' .and. &
      conttyp(ivar)(1:1) /= 'v'.and. ivar == 2) then
      print*,'Variable -',ivar,' plotting method (conttyp) '  &
            ,'must be one of c (contour), cb '  &
            ,'(contour, show color bar), f (fill), '  &
            ,'fb (fill, show color bar), t (tile) '  &
            ,'or tb (tile, show color bar) ',conttyp(ivar)(1:1)
      stop 'pl_opspec'
   endif

   if(conrinc(ivar) /= 0.) then
      nclevels=nint((conrhi(ivar)-conrlo(ivar))/conrinc(ivar))+2
      if(nclevels > 100) then
         print*,'Contour var:',ivar,': too many contour levels requested'
         print*,'Must be <= 100: hi, low, inc, levels'
         print*,conrhi(ivar),conrlo(ivar),conrinc(ivar),nclevels
         stop 'pl_opspec'
      endif
   endif
   
   
         if(icmeth(ivar) < -7.or.icmeth(ivar) > 7) then
            print*,'Contour var:',ivar,' graduated color method '  &
                  ,'parameter (m - integer) must be '  &
                  ,'between -7 and -7',icmeth(ivar)
            stop 'pl_opspec'
         endif
         if(cbias(ivar) < 0.3.or.cbias(ivar) > 3) then
            print*,'Contour var:',ivar,' graduated color bias'  &
                  ,'parameter (b - real) must be '  &
                  ,'between 0.3 and 3.0',cbias(ivar)
            stop 'pl_opspec'
         endif
         if(icint(ivar) < 1.or.icint(ivar) > 1000) then
            print*,'Contour var:',ivar,' major contour line interval '  &
                  ,'parameter (i - integer) must be '  &
                  ,'between 1 and 30',icint(ivar)
            stop 'pl_opspec'
         endif
         if(icdash(ivar) < 0.or.icdash(ivar) > 2) then
            print*,'Contour var:',ivar,' line solid/dash control '  &
                  ,'parameter (d - integer) must be '  &
                  ,'between 0 and 2',icdash(ivar)
            stop 'pl_opspec'
         endif
         if(abs(cgrad(ivar)) > 50.) then
            print*,'Contour var:',ivar,' graduated contour line color '  &
                  ,'parameter (g - real) must be '  &
                  ,'between -50.0 and 50.0',cgrad(ivar)
            stop 'pl_opspec'
         endif
         if(cthick(ivar) < .5.or.cthick(ivar) > 5.) then
            print*,'Contour var:',ivar,' line thickness '  &
                  ,'parameter (t - real) must be '  &
                  ,'between 0.5 and 5.0',cthick(ivar)
            stop 'pl_opspec'
         endif
         if(icover(ivar) < 0.or.icover(ivar) > 1) then
            print*,'Contour var:',ivar,' line over draw '  &
                  ,'parameter (o - integer) must be '  &
                  ,'between 0 and 1',icover(ivar)
            stop 'pl_opspec'
         endif
         if(icline(ivar) < -1.or.icline(ivar) > 3) then
            print*,'Contour var:',ivar,' line labels '  &
                  ,'parameter (l - integer) must be '  &
                  ,'between -1 and 3',icline(ivar)
            stop 'pl_opspec'
         endif
         if(ichigh(ivar) < -1.or.ichigh(ivar) > 3) then
            print*,'Contour var:',ivar,' high/low labels '  &
                  ,'parameter (h - integer) must be '  &
                  ,'between -1 and 3',ichigh(ivar)
            stop 'pl_opspec'
         endif
         if(csize(ivar) < 0.002.or.csize(ivar) > 0.1) then
            print*,'Contour var:',ivar,' size of contour and '  &
                  ,'high/low labels parameter '  &
                  ,'(s - real) must be between 0.002 '  &
                  ,'and 0.1',csize(ivar)
            stop 'pl_opspec'
         endif

enddo

         ! prevent cartesian and pressure plots in the vert
         if(islab /= 3.and.iztran /= 1) then
            print*,'iztran',iztran
            print*,'islab',islab
            print*,'Cannot plot vertical cartesian or pressure surfaces'
            stop 'plotspc'
         endif

return
end

