!############################# Change Log ##################################
! 2.3.1.4
!
!
!###########################################################################
!  Copyright (C)  1990, 1995, 1999, 2000 - All Rights Reserved
!  Regional Atmospheric Modeling System - RAMS
!  Mission Research Corporation / *ASTeR Division
!###########################################################################

subroutine framset (chhor,chver,xmplot,xtplot,ymplot,ytplot  &
                   ,xmn,ymn,zmn,xtn,ytn,ztn,slz  &
                   ,topt,n2,n3,ztop,nic,njc  &
                   ,icoorf,ivtype,pctlnd,topta,if_adap)

use pl_params
use define_colors

implicit none

integer :: nic,njc,ivtype,n2,n3,icoorf,if_adap
real :: ztop,vioff,vjoff
real :: xmplot(*),xtplot(*),ymplot(*),ytplot(*),slz(*),topt(*),pctlnd(*)  &
       ,xmn(*),ymn(*),zmn(*),xtn(*),ytn(*),ztn(*),topta(*)  &
       ,voltsl(nic,njc)
character(len=*)  :: chhor,chver

integer, parameter :: nztr=1000
integer :: ic,icw,icl,i,j,k,ih,iixbeg,iiybeg,nn,iii  &
          ,nseg,ns
real :: valugp,ztopz,factor,pp1,pp2,pq1,pq2,xxx1,xxx2,yyy1,yyy2  &
       ,pclwc,zst,xseg
real :: pcoor(nztr),pclw(nztr),zx(2),zy(2)
character(len=80) :: title
character(len=6)  :: axlabx,axlaby
character(len=1)  :: cpoint,h,v
character(len=16) :: number,cformat,titl,xlabfmt,ylabfmt

real :: topta_slab(1000),xfill(4),yfill(4),dstfill(8)
integer :: indfill(12)

common/landwat/pclw

save

h=chhor(1:1)
v=chver(1:1)

! Set up defaults and plotting array for horizontal X axis.
! This involves finding the minimum and maximum values and
! setting defaults for the axis label and numeric format.

print*,'start frameset',h,v,ivtype

if(h.eq.'X') then
   do i=nib,nie
      xmplot(i-nib+2)=xmn(i)
      xtplot(i-nib+1)=xtn(i)
   enddo
   if(nib.ge.2) then
      xmplot(1)=xmn(nib-1)
   else
      xmplot(1)=2.*xmn(nib)-xmn(nib+1)
   endif

   axlabx='x'
   xlabfmt='-3pf6.0'

elseif(h.eq.'Y') then
   do i=nib,nie
      xmplot(i-nib+2)=ymn(i)
      xtplot(i-nib+1)=ytn(i)
   enddo
   if(nib.ge.2) then
      xmplot(1)=ymn(nib-1)
   else
      xmplot(1)=2.*ymn(nib)-ymn(nib+1)
   endif

   axlabx='y'
   xlabfmt='-3pf6.0'

elseif(h.eq.'Z') then
   do i=nib,nie
      xmplot(i-nib+2)=zmn(i)
      xtplot(i-nib+1)=ztn(i)
   enddo
   if(nib.ge.2) then
      xmplot(1)=zmn(nib-1)
   else
      xmplot(1)=2.*zmn(nib)-zmn(nib+1)
   endif

   axlabx='z'
   xlabfmt='0pf6.0'

!elseif(h.eq.'T') then
!   do i=nib,nie
!      xtplot(i-nib+1)=times
!   enddo
!   axlabx=' t (s)'
!   xlabfmt='f6.0'
endif

xmin=1.e20
xmax=-1.e20
! plots with tiles only are set to the full area
! others are limited by the t-grid
! would like to have things plotted on the actual stagger
if((cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
    cvar(2)(1:4).eq.'none').or.  &
   (cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
    cvar(2)(1:4).ne.'none'.and.conttyp(2)(1:1).eq.'t')) then
   do i=1,nic+1
      xmin=min(xmin,xmplot(i))
      xmax=max(xmax,xmplot(i))
   enddo
else
   do i=1,nic
      xmin=min(xmin,xtplot(i))
      xmax=max(xmax,xtplot(i))
   enddo
endif

if(xmax-xmin < 5000.) then
   axlabx=axlabx(1:1)//' (m)'
   xlabfmt='0pf6.0'
else
   axlabx=axlabx(1:1)//' (km)'
   xlabfmt='-3pf6.0'
endif


! Set up the y array for plotting.

ivtran=0
izstran=0

if(v.eq.'X') then
   do j=njb,nje
      ymplot(j-njb+2)=xmn(j)
      ytplot(j-njb+1)=xtn(j)
   enddo
   if(njb.ge.2) then
      ymplot(1)=xmn(njb-1)
   else
      ymplot(1)=2.*xmn(njb)-xmn(njb+1)
   endif

   axlaby='x (km)'
   ylabfmt='-3pf6.0'

elseif(v.eq.'Y') then
   do j=njb,nje
      ymplot(j-njb+2)=ymn(j)
      ytplot(j-njb+1)=ytn(j)
   enddo
   if(njb.ge.2) then
      ymplot(1)=ymn(njb-1)
   else
      ymplot(1)=2.*ymn(njb)-ymn(njb+1)
   endif

   axlaby = 'y (km)'
   ylabfmt = '-3pf6.0'

elseif(v.eq.'Z') then

   ! normal section for atmosphere plots

   if (ivtype.le.3) then

      do j=njb,nje
         ymplot(j-njb+2)=zmn(j)
         ytplot(j-njb+1)=ztn(j)
      enddo
      if(njb.ge.2) then
         ymplot(1)=zmn(njb-1)
      else
         ymplot(1)=2.*zmn(njb)-zmn(njb+1)
         ytplot(1)=ymplot(2)
      endif

   elseif(ivtype==8.or.ivtype==5) then

      ! next section modified for vertical soil (only) plots.  modify
      ! further for vertical leaf plots that combine soil, snow, veg,
      ! canopy, atm.

      do k=njb,nje
         ymplot(k-njb+2)=slz(k+1)
         ytplot(k-njb+1)=0.5*(slz(k)+slz(k+1))
      enddo
      ymplot(1)=slz(njb)

   endif

   ! Set up array with topography as necessary.

   ivtran=1
   izstran=1
   if(ivtype.le.3) then

      ! normal section for atmosphere plots

      if(h.eq.'X') then

         do ih=nib,nie
            zs(ih-nib+1)=valugp(1,n2,n3,1,ih,icoorf,topt)
            topta_slab(ih-nib+1)=valugp(1,n2,n3,1,ih,icoorf,topta)
            pclw(ih-nib+1)=valugp(1,n2,n3,1,ih,icoorf,pctlnd)
           ! print*,'topta:',ih,ih-nib+1,topta_slab(ih-nib+1)
         enddo
         do ih=nib,nie-1
            zuv(ih-nib+2)=0.5*(zs(ih-nib+1)+zs(ih-nib+2))
         enddo
         zuv(1)=zs(1)
         zuv(nie+1)=zs(nie)
         if(nib.gt.1) zuv(1)=.5*(zs(1)+valugp(1,n2,n3,1,nib-1,icoorf,topt))
         if(nie.lt.n2) zuv(nie-nib+2)=.5*(zs(nie-nib+1)  &
                                     +valugp(1,n2,n3,1,nie+1,icoorf,topt))

      elseif(h.eq.'Y') then
         do ih=nib,nie
            zs(ih-nib+1)=valugp(1,n2,n3,1,icoorf,ih,topt)
            pclw(ih-nib+1)=valugp(1,n2,n3,1,icoorf,ih,pctlnd)
            topta_slab(ih-nib+1)=valugp(1,n2,n3,1,ih,icoorf,topta)
         enddo
         do ih=nib,nie-1
            zuv(ih-nib+2)=0.5*(zs(ih-nib+1)+zs(ih-nib+2))
         enddo
         zuv(1)=zs(1)
         zuv(nie+1)=zs(nie)
         if (nib.gt.1) zuv(1)=.5*(zs(1)+valugp(1,n2,n3,1,icoorf,nib-1,topt))
         if (nie.lt.n3) zuv(nie-nib+2)=.5*(zs(nie-nib+1)  &
                                      +valugp(1,n2,n3,1,icoorf,nie+1,topt))

      elseif(h.eq.'T') then
         zst=valugp(1,n2,n3,1,iixbeg,iiybeg,topt)
         pclwc=valugp(1,n2,n3,1,iixbeg,iiybeg,pctlnd)
         do k=nib,nie
            zs(k-nib+1)=zst
            pclw(k-nib+1)=pclwc
            zuv(k-nib+1)=zst
         enddo
         zuv(nie-nib+2)=zst
      endif

      do k=nib,nie
         zmax=max(zmax,zs(k-nib+1))
      enddo
      zmax=max(zmax,zuv(1))
      zmax=max(zmax,zuv(nie-nib+2))

   elseif(ivtype==8.or.ivtype==5) then

      ! new section for soil (only) plot

      do ih=nib,nie+1
         zuv(ih-nib+1)=0.
      enddo
      zmax=0.

   endif

   if(ivtype.le.3) then
      axlaby='z (m)'
      ylabfmt='0pf6.0'
   else
      axlaby='z (m)'
      ylabfmt='0pf6.2'
   endif

   do nn=1,nztr
      ztr(nn)=ytplot(nn)
   enddo
   zmodtop=ztop

endif

ymin=1.e20
ymax=-1.e20
! plots with tiles only are set to the full area
! others are limited by the t-grid
! would like to have things plotted on the actual stagger
if((cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
    cvar(2)(1:4).eq.'none').or.  &
   (cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
    cvar(2)(1:4).ne.'none'.and.conttyp(2)(1:1).eq.'t')) then
   do j=1,njc+1
      ymin=min(ymin,ymplot(j))
      ymax=max(ymax,ymplot(j))
   enddo
else
   do j=1,njc
      ymin=min(ymin,ytplot(j))
      ymax=max(ymax,ytplot(j))
   enddo
endif 
if(v=='Z'.and.njb.le.2.and.ivtype.ne.8.and.ivtype.ne.5) ymin=0.
if(v=='Z') ymax=ymax*(1.-zmax/ztop)+zmax

if(ymax-ymin < 5000. .or. v == 'Z') then
   axlaby=axlaby(1:1)//' (m)'
   ylabfmt='0pf6.0'
else
   axlaby=axlaby(1:1)//' (km)'
   ylabfmt='-3pf6.0'
endif


return

!--------------------------------------------

! Plot ticks marks and axis labels

entry framdrw (chhor,chver,xmplot,xtplot,ymplot,ytplot,topt,n2,n3  &
              ,nic,njc,icoorf,ztop  &
              ,ivtype,vioff,vjoff,voltsl,if_adap)
ic=10
call coloralias_set (iwkstation,'axis',ic)
call gsplci(ic)
call gstxci(ic)

print*,'+++++++++++++++:',ylabfmt

if(ipinfo /= 3)  &
   call axislab (nic,njc  &
                ,xtplot,ytplot  &
                ,axlabx,axlaby,xlabfmt,ylabfmt  &
                ,ztop,ivtype,vioff,vjoff)

! Plot perimeter

call set (px1,px2,py1,py2,0.,1.,0.,1.,1)
call perim (1,1,1,1)

if((h == 'X'.or.h == 'Y'.or.h == 'T').and.ivtype == 3 .and. v == 'Z') then

   ! Draw the topography (not for leaf)
   
   call gslwsc(3.)  ! line width
   ic=10
   call coloralias_set (iwkstation,'axis',ic)
   call gsplci(ic)

   do i=1,nic+1
      pcoor(i)=0.
   enddo

   if((cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
       cvar(2)(1:4).eq.'none').or.  &
      (cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
       cvar(2)(1:4).ne.'none'.and.conttyp(2)(1:1).eq.'t')) then

      call set (px1,px2,py1,py2,xmplot(1),xmplot(nic+1),ymin,ymax,1)
      call getset (pp1,pp2,pq1,pq2,xxx1,xxx2,yyy1,yyy2,iii)
      zx(1)=xmplot(1)
      zy(1)=zs(1)
      zx(2)=xtplot(1)
      zy(2)=zs(1)
      call gpl (2,zx,zy)
      call gpl(nic,xtplot,zs)
      zx(1)=xtplot(nic)
      zy(1)=zs(nic)
      zx(2)=xmplot(nic+1)
      zy(2)=zs(nic)
      call gpl (2,zx,zy)
      
   else

      call set (px1,px2,py1,py2,xtplot(1),xtplot(nic),ymin,ymax,1)
      call getset (pp1,pp2,pq1,pq2,xxx1,xxx2,yyy1,yyy2,iii)
      call gpl (nic,xtplot,zs)
      if(if_adap == 1) call gpl (nic,xtplot,topta_slab)
      

   endif

   ! plot land/water bar under frame
   
   if(ipanl.eq.1) then  ! line width
   
      call gslwsc(5.)  ! line width
      
      icl=9 ; icw=10
      call coloralias_set (iwkstation,'land',icl)
      call coloralias_set (iwkstation,'water',icw)

      if((cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
          cvar(2)(1:4).eq.'none').or.  &
         (cvar(1)(1:4).ne.'none'.and.conttyp(1)(1:1).eq.'t'.and.  &
          cvar(2)(1:4).ne.'none'.and.conttyp(2)(1:1).eq.'t')) then

         call set (px1,px2,py1-.005,py2,xmplot(1),xmplot(nic+1),0.,1.,1)
 
         call gsplci(icw)
         zy(1)=0.
         zy(2)=0.
         do i=1,nic
            zx(1)=xmplot(i)
            zx(2)=xmplot(i+1)
            if(pclw(i).lt..5) then
               call gsplci(icw)
               call gpl (2,zx,zy)
            else
               call gsplci(icl)
               call gpl (2,zx,zy)
            endif
         enddo

      else
 
         call set (px1,px2,py1-.005,py2,xtplot(1),xtplot(nic),0.,1.,1)

         call gsplci(icl)
         call gpl (nic,xtplot(1),pcoor(1))
         call gsplci(icw)
         do i=1,nic
            if(pclw(i) < .5) call gpl (2,xtplot(i),pcoor(i))
         enddo

      endif
   
   endif

endif
!============================================================================   

!   if(if_adap == 1 .and. v =='Z') then
   if(if_adap == 1 ) then
   print*,'@@@@@@@@@@@@@@@start buildgs:',v,if_adap,nic,njc,ymin,ymax
   !  Draw buildings with softfill
      call set (px1,px2,py1,py2,xtplot(1),xtplot(nic),ymin,ymax,1)
      ic=10
      call coloralias_set (iwkstation,'axis',ic)
      call gsplci(ic)
      nseg=5

      call gsfais (1)
      call sfseti ('TYPE OF FILL',0)
      
      do i=1,nic-1
         do k=1,njc-1
            if( voltsl(i,k) < 1.) then
               !print '(3i4,10g12.5)'  &
               !      ,i,k,ic,voltsl(i,k),ymplot(k+1),ymplot(k),xmplot(i)
               xfill(1) = xmplot(i)   ; yfill(1) = ymplot(k)
               xfill(2) = xmplot(i+1) ; yfill(2) = ymplot(k)
               xfill(3) = xmplot(i+1) ; yfill(3) = ymplot(k+1)
               xfill(4) = xmplot(i)   ; yfill(4) = ymplot(k+1)
               call sfsgfa (xfill,yfill,4,dstfill,8,indfill,12,ic)
            endif
         enddo
      enddo
      call sflush()         
  endif
!=============================================================================

call gslwsc(1.)  ! reset line width

! No map will be drawn - set flag correctly
itrans=0

! Set the vertical exaggeration factor used in plotting vectors in
! the FV subroutine
zfactor=(px2-px1)*(ymax-ymin)/((py2-py1)*(xmax-xmin))

call set (0.,1.,0.,1.,0.,1.,0.,1.,1)

ic=10
call coloralias_set (iwkstation,'title1',ic)
call gsplci(ic)
call gstxci(ic)

return
end

!***************************************************************************

subroutine axislab (nic,njc  &
                   ,xtplot,ytplot  &
                   ,axlabx,axlaby,xlabfmt,ylabfmt  &
                   ,ztop,ivtype,vioff,vjoff)
use pl_params
use define_colors

implicit none

integer :: nic,njc,ivtype
real :: ztop,vioff,vjoff
real :: xtplot(*),ytplot(*)
character(len=*) :: axlabx,axlaby,xlabfmt,ylabfmt


integer :: i,j,ic,nlably,nlablx
real :: yleft,yright,ylabn,zleft,zright,ymin1,ymax1,xmin1,xmax1,ycoord  &
       ,xcoord,xlabn,xlabnp,yinc,ylabst,xinc,xlabst,tickin,tickout
character(len=16) :: cformat,number
print*,'+++++++++++++++:',ylabfmt

ic=10
call coloralias_set (iwkstation,'axis',ic)
call gsplci(ic)
call gstxci(ic)

! inward and outward tickmark sizes
if(ipanl.eq.1) then
   tickin=.008
   tickout=.01
else
   tickin=.005
endif

! Put inward pointing ticks on the Y-axis
! account for vector box in panel plots

ymin1=ymin-(ymax-ymin)/(py2-py1)*py1
ymax1=ymax+(ymax-ymin)/(py2-py1)*(1.-py2)
call set (0.,1.,0.,1.,0.,1.,ymin1,ymax1,1)
if(vert.eq.'Z'.and.ivtype.le.3) then
   if (conttyp(1)(1:1).eq.'t'.or.conttyp(2)(1:1).eq.'t') then
      zleft=zuv(1)
      zright=zuv(nie+1)
   else
      zleft=zs(1)
      zright=zs(nie)
   endif
else
   zleft=0.
   zright=0.
endif

do j=1,njc
   yleft=zleft+ytplot(j)*(1.-zleft/ztop)
   call frstpt(px1,yleft)
   call vector(px1+tickin,yleft)
   yright=zright+ytplot(j)*(1.-zright/ztop)
   if(vert.eq.'Z') then
      if((ytplot(j).lt.ytplot(njc)-vjoff/(px2-px1)*(ytplot(njc)-ytplot(1))  &
        .and.ipanl.ne.1).or.ipanl.eq.1) then
         call frstpt(px2,yright)
         call vector(px2-tickin,yright)
      endif
   else
      if((ytplot(j).gt.ytplot(1)+vjoff/(px2-px1)*(ytplot(njc)-ytplot(1))  &
        .and.ipanl.ne.1).or.ipanl.eq.1) then
         call frstpt(px2,yright)
         call vector(px2-tickin,yright)
      endif
   endif
enddo

! Draw outward pointing ticks on the Y-axis and label them
      
if(ipanl.eq.1.and.ipinfo.ne.2) then
   write(cformat,'(''('',a8,'')'')') ylabfmt
   nlably=9
   call niceinc_mrc (ymin,ymax,nlably,yinc,ylabst)
   ycoord=ymax-.05*(ymax-ymin)
   do j=1,nlably
      ylabn=ylabst+(j-1)*yinc
      print*,'ppppppppp:',cformat,ylabn,':::',ylabfmt
      write(number,cformat) ylabn
      if(ylabn.lt.ycoord) call plchlq (px1-.01,ylabn,number(1:6),-.7,0.,1.)
      call frstpt(px1,ylabn)
      call vector(px1-tickout,ylabn)
   enddo
   ycoord=.99*ymax+.01*ymin
   call plchlq (px1-.01,ycoord,axlaby,-0.7,0.,1.)
endif

! Put inward pointing ticks at every grid point on the x-axis
! account for vector box in panel plots
   
xmin1=xmin-(xmax-xmin)/(px2-px1)*px1
xmax1=xmax+(xmax-xmin)/(px2-px1)*(1.-px2)
call set(0.,1.,0.,1.,xmin1,xmax1,0.,1.,1)
do i=1,nic
   if((xtplot(i).lt.xtplot(nic)-vioff/(px2-px1)*(xtplot(nic)-xtplot(1))  &
     .and.ipanl.ne.1).or.ipanl.eq.1) then
      if(vert.eq.'Z') then
         call frstpt(xtplot(i),py2)
         call vector(xtplot(i),py2-tickin)
      else
         call frstpt(xtplot(i),py1)
         call vector(xtplot(i),py1+tickin)
      endif
   endif
   if(vert.eq.'Z') then
      call frstpt(xtplot(i),py1)
      call vector(xtplot(i),py1+tickin)
   else
      call frstpt(xtplot(i),py2)
      call vector(xtplot(i),py2-tickin)
   endif
enddo

! Draw outward pointing ticks on the X-axis and label them

if(ipanl.eq.1.and.ipinfo.ne.2) then
   write(cformat,'(''('',a8,'')'')') xlabfmt
   nlablx=9
   call niceinc_mrc (xmin,xmax,nlablx,xinc,xlabst)
   xcoord=.90*xmax+.10*xmin
   do i=1,nlablx
      xlabn=xlabst+(i-1)*xinc
      write(number,cformat) xlabn
      xlabnp=xlabn-.02*(xmax1-xmin1)
      if(xlabn.lt.xcoord) call plchlq (xlabnp,py1-.03,number(1:6),-.7,0.,0.)
      call frstpt (xlabn,py1)
      call vector (xlabn,py1-tickout)
   enddo
   call plchlq (.9*xmax+.1*xmax1,py1-.03,axlabx,-0.7,0.,1.)
endif

return
end

!***************************************************************************

subroutine setframe ()

implicit none

call set (0.,1.,0.,1.,0.,1.,0.,1.,1)
call gsplci(0)
call frstpt(.0,.0)
call vector(.0,.0)
call sflush
 
return
end

!***************************************************************************

subroutine backlab (axis1,axis2,ngrid  &
                   ,xtn,ytn,ztn,slz,itime,idate,ihtran  &
                   ,iplev,boxtop,boxhite,ivtype,iovtype,nf)

use pl_params
use define_colors
use ra_file_info

implicit none

integer :: ngrid,itime,idate,ihtran,iplev,ivtype,iovtype,nf
real    :: xtn,ytn,ztn,slz,boxtop,boxhite
character(len=*)  :: axis1,axis2

integer :: ic,imon,imonth,iday,iyear,iyr,isec,nch,julday1970,npt,ittt  &
          ,nnfiles
real :: hpos,box5,fcsthr,fcstsec,startutc,xx1,xx2,yy1,yy2,fcstsec1  &
       ,fcstsec2,dfcstsec,fcstday
character(len=60) :: title
character(len=3)  :: dayofwk(0:6),vday,month(12),cfhr,cfday
character(len=2)  :: cmon,cday,chr
character(len=4)  :: cyear
character(len=6)  :: ctim
character(len=8)  :: cyrmoda
character(len=7)  :: ctn,ctn2

data month/'Jan','Feb','Mar','Apr','May','Jun'  &
          ,'Jul','Aug','Sep','Oct','Nov','Dec'/
data dayofwk/'Thu','Fri','Sat','Sun','Mon','Tue','Wed'/    

! Draw box and label for the run title

call set (0.,1.,0.,1.,0.,1.,0.,1.,1)
if(ipinfo.eq.1) then

   ! Draw boxes for the background labels
   
   ic=10
   call coloralias_set (iwkstation,'title0',ic)
print*,'=============ic1:',ic
   call plotif(0.,0.,2)
   call gsplci(ic)
   call plotif(0.,0.,2)
   call gstxci(ic)
   call plotif(0.,0.,2)
 
   call frstpt(.01,boxtop)
   call vector(.01,boxtop-boxhite)
   call vector(.99,boxtop-boxhite)
   call vector(.99,boxtop)
   call vector(.01,boxtop)
 
   call frstpt(.55,boxtop)
   call vector(.55,boxtop-boxhite)
 
   box5=boxtop-.5*boxhite
   call sflush
   
   ic=10   
   call coloralias_set (iwkstation,'title1',ic)
print*,'=============ic2:',ic
   call plotif(0.,0.,2)
   call gsplci(ic)
   call plotif(0.,0.,2)
   call gstxci(ic)
   call plotif(0.,0.,2)
 
   write(title,'(''grid '',i1)') ngrid
   call plchhq (.60,box5,title,-0.7,0.,-1.)
   write (title,'(a)') head1(1:60)
   call plchhq (.03,box5,title,-0.7,0.,-1.)
 
   ! Draw boxes and labels for the grid number, time, and slab position
 
   ic=10   
   call coloralias_set (iwkstation,'title0',ic)
print*,'=============ic3:',ic
   call plotif(0.,0.,2)
   call gsplci(ic)
   call plotif(0.,0.,2)
   call gstxci(ic)
   call plotif(0.,0.,2)
 
   boxtop=boxtop-boxhite
 
   call frstpt(.01,boxtop)
   call vector(.01,boxtop-boxhite)
   call vector(.99,boxtop-boxhite)
   call vector(.99,boxtop)
 
   call frstpt(.20,boxtop)
   call vector(.20,boxtop-boxhite)
 
   call frstpt(.55,boxtop)
   call vector(.55,boxtop-boxhite)
 
   call frstpt(.675,boxtop)
   call vector(.675,boxtop-boxhite)
 
   call frstpt(.79,boxtop)
   call vector(.79,boxtop-boxhite)

   call frstpt(.915,boxtop)
   call vector(.915,boxtop-boxhite)
 
   box5=boxtop-.5*boxhite
   call sflush
 
   ic=10
   call coloralias_set (iwkstation,'title2',ic)
print*,'=============ic4:',ic
   call plotif(0.,0.,2)
   call gsplci(ic)
   call plotif(0.,0.,2)
   call gstxci(ic)
   call plotif(0.,0.,2)
 
   if(axis1.ne.'T'.and.axis2.ne.'T') then
      iyr=idate/10000
      imon=mod(idate,10000)/100
      iday=mod(idate,100)
      isec=mod(itime,100)
      write (title,'(i4.4,a1,i2.2,a1,i2.2,a1,i4.4,a1,i2.2,a4)')  &
        iyr,'-',imon,'-',iday,'-',itime/100,'.',isec,' UTC'
      call plchhq (.21,box5, title(1:index(title,'C')), -.7,0.,-1.)
   endif
 
   hpos=.03
   if(axis1.ne.'X'.and.axis2.ne.'X') then
      write (title,'(a,-3PF7.0,a)') 'x =', xtn,' km'
        call plchhq (hpos, box5, title, -.7,0., -1.)
        hpos=hpos+.19
   endif
 
   IF(axis1.ne.'Y'.and.axis2.ne.'Y') then
      write (title,'(a,-3PF7.0,a)') 'y =', ytn,' km'
        call plchhq (hpos, box5, title, -.7,0., -1.)
        hpos=hpos+.19
   endif
 
   if(axis1.ne.'Z'.and.axis2.ne.'Z') then
      if(itrans.ne.3) then
         if((ivtype.eq.3.and.cvar(1)(1:4).ne.'none').or.  &
           (iovtype.eq.3.and.cvar(2)(1:4).ne.'none').or.  &
             cwinds(1:1).ne.'n') then
            write (title,'(a,F7.1,a)') 'z =', ztn,' m'
         elseif(((ivtype==8.or.ivtype==5).and.cvar(1)(1:4).ne.'none').or.  &
               ((iovtype==8.or.iovtype==5).and.cvar(2)(1:4).ne.'none')) then
            write (title,'(a,F7.2,a)') 'z =', slz,' m'
         else
            write (title,'(a,F7.1,a)') ' '
         endif
         call plchhq (hpos,box5,title,-0.7,0.,-1.)
         hpos=hpos+.19
      else
         write (title,'(a,i5,a)') 'p =', iplev,' mb'
         call plchhq (hpos,box5,title,-0.7,0.,-1.)
         hpos=hpos+.19
      endif
   endif
 
   call plchhq (.58,box5,' min ',-0.6,0.,-1.)
   call plchhq (.705,box5,' max ',-0.6,0.,-1.)
   call plchhq (.82,box5,' inc ',-0.6,0.,-1.)
   call plchhq (.925,box5,' lab* ',-0.6,0.,-1.)

endif

if(ipanl.ne.1.or.ipinfo==2) then
   
   ic=10   
   call coloralias_set (iwkstation,'title1',ic)
   call gsplci(ic)
   call gstxci(ic)

   ! construct and write the top title
   
   call ra_get_idata (3,ngrid,itime,npt)
   call ra_get_idata (2,ngrid,idate,npt)
   call ra_get_fdata (1,ngrid,fcstsec,npt)
   call ra_get_fdata (2,ngrid,startutc,npt)
   write(cyrmoda,'(i8)') idate
   cyear=cyrmoda(1:4)
   read(cyear,'(i4)') iyear
   cmon=cyrmoda(5:6)
   read(cmon,'(i2)') imonth      
   cday=cyrmoda(7:8)
   read(cday,'(i2)') iday
   write(ctim,'(i6.6)') itime
   vday=dayofwk(mod(julday1970(imonth,iday,iyear)-1,7))
   fcsthr=fcstsec/3600.
   write(cfhr,'(i3.3)') nint(fcsthr)
   fcstday=fcstsec/86400.
   write(cfday,'(i3)') nint(fcstday)
   
   ! files spaced in days or hours?
   call ra_get_idata (4,ngrid,nnfiles,npt)
   call ra_get_fdata (1,ngrid,fcstsec1,npt)
   fcstsec2=0.
   if(nnfiles.gt.1) call ra_get_fdata (2,ngrid,fcstsec2,npt)
   dfcstsec=fcstsec2-fcstsec1
   if(dfcstsec.lt.86400.) then
      title=cfhr//' hr RAMS Valid '//ctim(1:4)  &
            //' UTC '//vday//' '//cday//' '//month(imonth)//' '//cyear
   else
      title='day '//cday(1:len_trim(cday))//' RAMS Valid '//ctim(1:4)  &
            //' UTC '//vday//' '//cday//' '//month(imonth)//' '//cyear
   endif
   
   if(ipanl==1) then
      call plchlq (px1,py2+.015,trim(title),-.8,0.,-1.)
   else
      call plchlq (px1,py2+.01,trim(title),-.65,0.,-1.)
   endif
   
   ! bottom title
   
   title=''
   if(axis1.ne.'X'.and.axis2.ne.'X') then
      write(ctn,'(-3pf7.0)') xtn
      call deblank (ctn,ctn2,nch)
      title='y='//ctn2(1:len_trim(ctn2))//'km'
   endif
   if(axis1.ne.'Y'.and.axis2.ne.'Y') then
      write(ctn,'(-3pf7.0)') ytn
      call deblank (ctn,ctn2,nch)
      title='y='//ctn2(1:len_trim(ctn2))//'km'
   endif
   if(axis1.ne.'Z'.and.axis2.ne.'Z') then
      if(itrans.ne.3) then
         if((ivtype.eq.3.and.cvar(1)(1:4).ne.'none').or.  &
           (iovtype.eq.3.and.cvar(2)(1:4).ne.'none').or.  &
            (cwinds(1:1).ne.'n')) then
            write(ctn,'(f7.1)') ztn
            call deblank(ctn,ctn2,nch)
            title='z='//ctn2(1:len_trim(ctn2))//'m'
         elseif(((ivtype==8.or.ivtype==5).and.cvar(1)(1:4).ne.'none').or.  &
               ((iovtype==8.or.iovtype==5).and.cvar(2)(1:4).ne.'none')) then
            write(ctn,'(f7.2)') slz
            call deblank (ctn,ctn2,nch)
            title='z='//ctn2(1:len_trim(ctn2))//'m'
         endif
      else
         write(ctn,'(i5)') iplev
         call deblank (ctn,ctn2,nch)
         title='z='//ctn2(1:len_trim(ctn2))//'mb'
      endif
   endif
   
   if(ipanl==1) then
      call plchlq(px2,py2+.015,trim(title),-.8,.8,1.)
   else
      call plchlq(px2,py1-.01,trim(title),-.55,0.,1.)
   endif

endif

return
end

