!-----------------------------------------------------------------------

subroutine exec_action(tokens)

use define_colors

! This routine is application-dependent and is customized for each action.

implicit none

character(len=*) :: tokens(*)

integer :: ln,ierr
real, external :: ch2real
integer, external :: ch2int

character(len=20) :: command

command=tokens(2)   ! tokens(1) is 'exec'

if(trim(command) == 'plot') then
   call plot_frame('plot')

elseif( trim(command) == 'open_meta') then
   ! token(3) needs to be metafile name. Do quick check...
   call check_arg(tokens(3),1,'open_meta','c',ierr)
   call open_metafile(trim(tokens(3)))

elseif( trim(command) == 'close_meta') then
   call close_metafile()

elseif( trim(command) == 'color_define') then
   ! token(3) needs to be color name.
   ! token(4) needs to be 'hls' or 'rgb'
   ! token(5-7) need to be floating point values
   !    Do quick check...
   call check_arg(tokens(3),2,'color_define','c',ierr)
   call check_arg(tokens(5),3,'color_define','f',ierr)
   
   call colortab_add(trim(tokens(3)),trim(tokens(4))  &
            ,ch2real(tokens(5)),ch2real(tokens(6)),ch2real(tokens(7)))

elseif( trim(command) == 'color_alias') then
   ! token(3) needs to be alias name.
   ! token(4) needs to be already defined color name
   call check_arg(tokens(3),2,'color_alias','c',ierr)
   
   call coloralias_add(trim(tokens(3)),trim(tokens(4)))

else
   print*,'Unknown action in execute:',trim(command)
   stop 'execute'

endif


return
end


subroutine check_arg(arg,narg,command,atype,ierr)

implicit none

integer :: narg,ierr
character(len=*) :: arg(narg),command,atype

integer :: n,check_int,check_real

ierr=0
do n = 1, narg
   print*,arg(n),len_trim(arg(n))
   ! Check first and see if they have non-zero length
   if (len_trim(arg(n)) <= 0) then
      print*,'Incorrect or missing argument to "exec ',trim(command)//'"'
      print*,'Argument number:',n
      ierr=1
   endif
   
   ! If they are flagged to be a float or integer, check
   if(atype(1:1) == 'i') then
      ierr=ierr+check_int(arg(n),0)
   elseif(atype(1:1) == 'f') then
      ierr=ierr+check_real(arg(n),0)
   endif     
enddo

if(ierr /= 0) stop 'execute'

return
end
