subroutine serror_mess(msg)
character(len=*) msg

print*,msg

return
end

!***************************************************************************

subroutine lead_deblank(str1,str2)
character(len=*) :: str1,str2

! strips blanks from beginning of a string

str2=' '
ln=len(str1)
do n=1,ln
   if(str1(n:n) /= ' ') then
      str2(1:)=str1(n:)
      return
   endif
enddo

return
end

!***************************************************************************

subroutine de_multi_blank(str1,str2)
character(len=*) :: str1,str2

! strips multiple blanks from a string

str2=' '
ic2=1
ln=len(str1)
do n=1,ln
   if(str1(n:n) /= ' ' .or.(n > 1 .and. str2(ic2-1:ic2-1) /= ' ') ) then
      str2(ic2:ic2)=str1(n:n)
      ic2=ic2+1
   endif
enddo

return
end


!***************************************************************************

subroutine stokenize(str1,tokens,ntok,toksep)
character(len=*) :: str1,tokens(*),str*256
character(len=1) :: toksep

! this routine "parses" character string str into different pieces
! or tokens by looking for  possible token separators (toks
! str contains nch characters.  the number of tokens identified is ntok
! the character string tokens are stored in tokens.

call de_multi_blank(str1,str)
!str=str1
nch=len_trim(str)
!print*,'tok:',nch,trim(str) 

ist=1
if(str(1:1) == toksep) ist=2
npt=ist
ntok=0
do nc=ist,nch
   if(str(nc:nc) == toksep .or. nc == nch) then
   !print*,'+++:',nc,npt,nch
      if(nc-npt >= 0) then
         ntok=ntok+1
         tokens(ntok)=str(npt:nc-1)
    !           print*,'npt,nc-1:',npt,nc-1,trim(tokens(ntok))
         if(nc == nch) then
            tokens(ntok)=str(npt:nc)
     !          print*,'npt,nc:',npt,nc,tokens(ntok)
            goto 10
         endif
         npt=nc+1
      endif
   endif
enddo
10 continue

return
end
!***************************************************************************

integer function ch2int (str)
implicit none
character(len=*) :: str

! Read integer value INT from character string STR

read(str,*) ch2int
  
return
end

!***************************************************************************

real function ch2real (str)
implicit none
character(len=*) :: str

! Read real value FNUM from character string STR

read(str,*) ch2real
  
return
end

!***************************************************************************

integer function check_real (str,fatal)
implicit none
character(len=*) :: str
integer :: fatal

integer :: ln,n,npdot,ne,lnn
character(len=32) :: str2

! Integer number check - test to see if str is a valid integer
!   by seeing if all characters are values and only 1 +/- sign in first column

check_real=0
call deblank(str,str2,lnn)

! See if in e notation
ne = max(index(str2(1:lnn),'e'),index(str2(1:lnn),'E'))

! Check first part to ne-1 (or end if no e)
ln=lnn
if(ne /= 0) ln=ne-1

npdot=0
do n=1,ln
   if(str(n:n) == '+'.or.str(n:n) =='-' ) then
      if(n > 1) check_real=1
   elseif(str(n:n) == '.') then
      npdot=npdot+1
   elseif(str(n:n) < '0' .or. str(n:n) > '9') then
      check_real=1
   endif
enddo
if(npdot > 1) check_real=1

! Now check e part if any
if (ne /= 0) then
   do n=ne+1,lnn
      if(str(n:n) == '+'.or.str(n:n) =='-' ) then
         if(n > ne+1) check_real=1
      elseif(str(n:n) < '0' .or. str(n:n) > '9') then
         check_real=1
      endif
   enddo
endif


! Print message and optionally stop
if (check_real /= 0) then
   print*,'Invalid real number found:',trim(str)
   if(fatal == 1) stop 'check_real'
endif

return
end

!***************************************************************************

integer function check_int (str,fatal)
implicit none
character(len=*) :: str
integer :: fatal

integer :: ln,n
character(len=32) :: str2

! Integer number check - test to see if str is a valid integer
!   by seeing if all characters are values and only 1 +/- sign in first column

check_int=0
call deblank(str,str2,ln)

do n=1,ln
   if(str(n:n) == '+'.or.str(n:n) =='-') then
      if( n > 1) check_int=1
   elseif(str(n:n) < '0' .or. str(n:n) > '9') then
      check_int=1
   endif
enddo

! Print message and optionally stop
if (check_int /= 0) then
   print*,'Invalid integer number found:',trim(str)
   if(fatal == 1) stop 'check_int'
endif

return
end


