!-----------------------------------------------------------------------

subroutine set_appvar_value(name,value)

! This routine is application-dependent and is customized for each variable.

use pl_params

implicit none

character(len=*) :: name,value
integer :: ln,in1

ln=len_trim(name)

!print*,'set_appvar: ',trim(name),' ',trim(value)

! Primary contour field settings

if( name(1:ln)      == 'cont_var_1') then
   call svarset_c(cvar(1),value)
elseif ( name(1:ln) == 'cont_type_1') then
   call svarset_c(conttyp(1),value) 
elseif ( name(1:ln) == 'cont_cbar_1') then
   call svarset_c(colorbar(1),value)
elseif ( name(1:ln) == 'cont_low_1') then
   call svarset_f(conrlo(1),value)
elseif ( name(1:ln) == 'cont_high_1') then
   call svarset_f(conrhi(1),value)
elseif ( name(1:ln) == 'cont_inc_1') then
   call svarset_f(conrinc(1),value)
elseif ( name(1:ln) == 'cont_meth_1') then
   call svarset_i(icmeth(1),value)
elseif ( name(1:ln) == 'cont_meth_bias_1') then
   call svarset_f(cbias(1),value)
elseif ( name(1:ln) == 'cont_meth_cent_1') then
   call svarset_f(ccent(1),value)
elseif ( name(1:ln) == 'cont_line_major_int_1') then
   call svarset_i(icint(1),value)
elseif ( name(1:ln) == 'cont_line_dash_1') then
   call svarset_i(icdash(1),value)
elseif ( name(1:ln) == 'cont_line_grad_1') then
   call svarset_f(cgrad(1),value)
elseif ( name(1:ln) == 'cont_line_thick_1') then
   call svarset_f(cthick(1),value)
elseif ( name(1:ln) == 'cont_line_overlay_1') then
   call svarset_i(icover(1),value)
elseif ( name(1:ln) == 'cont_lab_highlow_1') then
   call svarset_i(ichigh(1),value)
elseif ( name(1:ln) == 'cont_lab_line_1') then
   call svarset_i(icline(1),value)
elseif ( name(1:ln) == 'cont_lab_size_1') then
   call svarset_f(csize(1),value)
elseif ( name(1:ln) == 'cont_lab_color_1') then
   call svarset_c(labcol(1),value)
elseif ( name(1:ln) == 'cont_color_low_1') then
   call svarset_c(fillcols(1,1),value) 
elseif ( name(1:ln) == 'cont_color_mid_1') then
   call svarset_c(fillcols(2,1),value) 
elseif ( name(1:ln) == 'cont_color_high_1') then
   call svarset_c(fillcols(3,1),value)

! Secondary field settings

elseif( name(1:ln)  == 'cont_var_2') then
   call svarset_c(cvar(2),value)
elseif ( name(1:ln) == 'cont_type_2') then
   call svarset_c(conttyp(2),value) 
elseif ( name(1:ln) == 'cont_cbar_2') then
   call svarset_c(colorbar(2),value)
elseif ( name(1:ln) == 'cont_low_2') then
   call svarset_f(conrlo(2),value)
elseif ( name(1:ln) == 'cont_high_2') then
   call svarset_f(conrhi(2),value)
elseif ( name(1:ln) == 'cont_inc_2') then
   call svarset_f(conrinc(2),value)
elseif ( name(1:ln) == 'cont_meth_2') then
   call svarset_i(icmeth(2),value)
elseif ( name(1:ln) == 'cont_meth_bias_2') then
   call svarset_f(cbias(2),value)
elseif ( name(1:ln) == 'cont_meth_cent_2') then
   call svarset_f(ccent(2),value)
elseif ( name(1:ln) == 'cont_line_major_int_2') then
   call svarset_i(icint(2),value)
elseif ( name(1:ln) == 'cont_line_dash_2') then
   call svarset_i(icdash(2),value)
elseif ( name(1:ln) == 'cont_line_grad_2') then
   call svarset_f(cgrad(2),value)
elseif ( name(1:ln) == 'cont_line_thick_2') then
   call svarset_f(cthick(2),value)
elseif ( name(1:ln) == 'cont_line_overlay_2') then
   call svarset_i(icover(2),value)
elseif ( name(1:ln) == 'cont_lab_highlow_2') then
   call svarset_i(ichigh(2),value)
elseif ( name(1:ln) == 'cont_lab_line_2') then
   call svarset_i(icline(2),value)
elseif ( name(1:ln) == 'cont_lab_size_2') then
   call svarset_f(csize(2),value)
elseif ( name(1:ln) == 'cont_lab_color_2') then
   call svarset_c(labcol(2),value)
elseif ( name(1:ln) == 'cont_color_low_2') then
   call svarset_c(fillcols(1,2),value) 
elseif ( name(1:ln) == 'cont_color_mid_2') then
   call svarset_c(fillcols(2,2),value) 
elseif ( name(1:ln) == 'cont_color_high_2') then
   call svarset_c(fillcols(3,2),value)
   
! Wind field settings   
elseif ( name(1:ln) == 'winds') then
   call svarset_c(cwinds,value)
elseif ( name(1:ln) == 'winds_interval_i') then
   call svarset_i(intwindi,value)
elseif ( name(1:ln) == 'winds_interval_j') then
   call svarset_i(intwindj,value)
elseif ( name(1:ln) == 'winds_barb_scale') then
   call svarset_i(ibscale,value)
elseif ( name(1:ln) == 'winds_color') then
   call svarset_c(windcol,value)
elseif ( name(1:ln) == 'winds_stemlength') then
   call svarset_f(stemleng,value)
elseif ( name(1:ln) == 'winds_velmax') then
   call svarset_f(velomax,value)
elseif ( name(1:ln) == 'winds_headlength0') then
   call svarset_f(headleng0,value)
elseif ( name(1:ln) == 'winds_headlength') then
   call svarset_f(headleng,value)

! Landmark settings

elseif ( name(1:ln) == 'landmark') then
   call svarset_c(landmark,value)
elseif ( name(1:ln) == 'landmarkers') then
   call svarset_c(lmarkers,value)
elseif ( name(1:ln) == 'landmarks_type') then
   call svarset_i(itypelandmk,value)
elseif ( name(1:ln) == 'landmarks_sep') then
   call svarset_f(stemleng,value)
elseif ( name(1:ln) == 'landmarks_color') then
   call svarset_c(collandmk,value)
elseif ( name(1:ln) == 'landmarks_size') then
   call svarset_f(sizelandmk,value)
elseif ( name(1:ln) == 'landmarks_lab') then
   call svarset_i(ilandlab,value)
elseif ( name(1:ln) == 'landmarks_lab_color') then
   call svarset_c(collandlab,value)
elseif ( name(1:ln) == 'landmarks_lab_size') then
   call svarset_f(sizelandlab,value)
   
! Slab definition settings

elseif ( name(1:ln) == 'slab_type') then
   call svarset_c(slab_type,value)
elseif ( name(1:ln) == 'slab_left_offset') then
   call svarset_i(ixbeg,value)
elseif ( name(1:ln) == 'slab_right_offset') then
   call svarset_i(ixend,value)
elseif ( name(1:ln) == 'slab_top_offset') then
   call svarset_i(iybeg,value)
elseif ( name(1:ln) == 'slab_bottom_offset') then
   call svarset_i(iyend,value)
elseif ( name(1:ln) == 'slab_transform') then
   call svarset_i(itrans,value)
elseif ( name(1:ln) == 'slab_p_level') then
   call svarset_i(iplevel,value)
elseif ( name(1:ln) == 'slab_mapfill') then
   call svarset_i(mfill,value)
elseif ( name(1:ln) == 'slab_background') then
   call svarset_i(ibgnd,value)
elseif ( name(1:ln) == 'slab_plotinfo') then
   call svarset_i(ipinfo,value)
elseif ( name(1:ln) == 'slab_panels') then
   call svarset_i(ipanl,value)
elseif ( name(1:ln) == 'slab_coor') then
   call svarset_i(islab_coor,value)
elseif ( name(1:ln) == 'slab_time') then
   call svarset_c(ctime,value)
elseif ( name(1:ln) == 'slab_grid') then
   call svarset_c(cgrid,value)
elseif ( name(1:ln) == 'slab_drawgrids') then
   call svarset_c(drawgrids,value) 
elseif ( name(1:ln) == 'slab_label') then
   call svarset_c(head1,value)
   
! Files
   
elseif ( name(1:ln) == 'file_input') then
   call svarset_c(anpref,value)
   print*,'sssssssss:',len(value),trim(value)
   print*,'sssssssss:',len(anpref),trim(anpref)
elseif ( name(1:ln) == 'file_output') then
   call svarset_c(revpref,value)
   
else
   call serror_mess('app variable not found: '//trim(name))
endif


return
end


subroutine svarset_c(var,value)
implicit none
character(len=*) :: var,value

   var=value

return
end

subroutine svarset_f(var,value)
implicit none
character(len=*) :: value
real :: var

   read(value,'(f20.0)') var

return
end

subroutine svarset_i(var,value)
implicit none
character(len=*) :: value
integer :: var

   read(value,'(i20)') var

return
end
