!***************************************************************************

subroutine windplot (u,v,nic,njc  &
                   ,slab,cdname,cdunits  &
                   ,boxtop,boxhite,xtplot,ytplot  &
                   ,ztop,uu,vv,nngd,iolayer,vioff,vjoff)
use pl_params
use define_colors

implicit none

integer :: nic,njc,nngd,iolayer
real :: boxtop,boxhite,ztop  &
       ,vioff,vjoff
real :: u(0:nic,0:njc),v(0:nic,0:njc),slab(*),xtplot(*),ytplot(*)  &
       ,uu(0:nic,0:njc),vv(0:nic,0:njc)
character(len=*)  :: cdname,cdunits

integer :: i,j,ier,lcdname,lcdunits,ic,memwork,icp,ict
real :: dir,spd,box5,scle,vexag
real :: rif(6),rjf(6),dst(6),ind(8)
real, allocatable :: un(:),vn(:),work(:)

character(len=80) :: title

integer :: inita,initb,iterp,iterc,igflg,imsg,icyc,incxv,incyv
real :: arowl,uvmsg,displ,dispc,cstop,bbbbb,tilelo,tilehi
common /str03/ inita,initb,arowl,iterp,iterc,igflg  &
              ,imsg,uvmsg,icyc,displ,dispc,cstop
common /vec2/ bbbbb,incxv,incyv

incxv=intwindi
incyv=intwindj
inita=intwindi
initb=2

iwcolor=10
call coloralias_set(1,windcol,iwcolor)

! Plot the vector field.

! the following line has been modified to give the user the option
! of plotting out vorticity vectors

if(cwinds(1:1) == 'v'.or.cwinds(1:1) == 'r'.or.cwinds(1:1) == 't')  &
   call ramsvect (nic,njc,u,v,slab,cdname,cdunits  &
                 ,boxtop,boxhite,xtplot,ytplot  &
                 ,ztop  &
                 ,uu,vv,nngd,iolayer,vioff,vjoff)

! Plot the stream lines

if(cwinds(1:1) == 's'.or.cwinds(1:1) == 'b') then
   if(vert(1:1) == 'Z') then
      if(conttyp(1)(1:1) == 't') then
         call set(px1,px2,py1,py2,0.5,float(nii)+.5,ymin,ymax,1)
      else
         call set(px1,px2,py1,py2,1.0,float(nii),ymin,ymax,1)
      endif
   else
      if(conttyp(1)(1:1)  ==  't') then
         call set(px1,px2,py1,py2,.5,float(nii)+.5,.5,float(njj)+.5,1)
      else
         call set(px1,px2,py1,py2,1.,float(nii),1.,float(njj),1)
      endif
   endif
endif

if(cwinds(1:1) == 's') then
   ! getting a nii by njj array from the oversized u and v arrays
   vexag=1.
   if(vert(1:1) == 'Z')  &
           vexag=(py2-py1)/(px2-px1) * (xmax-xmin)/(ymax-ymin)
   allocate(un(nii*njj))
   allocate(vn(nii*njj))
   
   if(allocated(work)) deallocate(work)
   allocate(work(2*max(nii,njj)**2))
   call gsplci(iwcolor)
   call gstxci(iwcolor)
   
   call strmln_mrc2 (u,v,un,vn,work,nii,nii,njj,1,ier,vexag)   
   deallocate(un,vn)
   print *,'Drawn streamlines'
endif

! Plot the wind barbs

if(cwinds(1:1) == 'b') then
   call set (px1,px2,py1,py2,1.,float(nii),1.,float(njj),1)
   call gsplci(iwcolor)
   call gstxci(iwcolor)
   if(stemleng <= 0.) then
      scle=.85*float(intwindi)
   else
      scle=.85*float(intwindi)*stemleng
   endif
   tilelo=1.e15
   tilehi=-1.e15
   do j=1,njj,intwindj
      do i=1,nii,intwindi
         call winddf (dir,spd,u(i,j),v(i,j))
         call windbarb (float(i),float(j),1,dir,spd,scle,0.)
         tilelo=min(tilelo,spd)
         tilehi=max(tilehi,spd)
      enddo
   enddo
   !print*,tilelo,tilehi
   print*,'Drawn barbs'
      
   if(ipinfo == 1) then

      ! Plot label information for barbs

      if(ibscale <= 1) then
         cdname='barb 10 m/s flag 50 m/s'
      elseif(ibscale == 2) then
         cdname='barb 4 m/s  flag 20 m/s'
      elseif(ibscale == 3) then
         cdname='barb 2 m/s  flag 10 m/s'
      elseif(ibscale >= 4) then
         cdname='barb 1 m/s  flag 5 m/s'
      endif
   
      call info_labels(1,'barbs',cdname,';',tilelo,tilehi &
         ,-1.e20,-1e20  &
         ,boxtop,boxhite,'title0',windcol)

   endif
   
   if(ipanl.ne.1) then

      ! Construct the title for multi-panel plots

      call set (0.,1.,0.,1.,0.,1.,0.,1.,1)
 
      ! fill box in lower right corner
 
      rif(1)=px2
      rif(3)=rif(1)-vioff
      rif(2)=rif(1)
      rif(4)=rif(3)
      rif(5)=rif(1)
 
      if(vert == 'Z') then
         rjf(1)=py2
         rjf(2)=rjf(1)-vjoff
         rjf(3)=rjf(2)
         rjf(4)=rjf(1)
         rjf(5)=rjf(1)
      else
         rjf(1)=py1
         rjf(2)=rjf(1)+vjoff
         rjf(3)=rjf(2)
         rjf(4)=rjf(1)
         rjf(5)=rjf(1)
      endif
 
      call sfsgfa (rif,rjf,4,dst,6,ind,8,0)
 
      ! put boarder around box
      !call colortab_ind ('axis',ic)
      !call gsplci(ic)
      !call gstxci(ic)
 
      !call frstpt(rif(1),rjf(1))
      !call vector(rif(2),rjf(2))
      !call vector(rif(3),rjf(3))
      !call vector(rif(4),rjf(4))
      !call vector(rif(5),rjf(5))
      !call sflush

      ! Plot the barb values

      call gsplci(iwcolor)
      call gstxci(iwcolor)

      if(ibscale.le.1) then
         title='staff 10m/s'
      elseif(ibscale == 2) then
         title='staff 4m/s'
      elseif(ibscale == 3) then
         title='staff 2m/s'
      elseif(ibscale.ge.4) then
         title='staff 1m/s'
      endif
      if(vert(1:1) == 'Z') then
         call plchlq (px2-.002,py2-.022,title(1:(len_trim(title))),-.5,0.,1.)
      else
         call plchlq (px2-.002,py1+.009,title(1:(len_trim(title))),-.5,0.,1.)
      endif
 
      if(ibscale.le.1) then
         title='flag 50m/s'
      elseif(ibscale == 2) then
         title='flag 20m/s'
      elseif(ibscale == 3) then
         title='flag 10m/s'
      elseif(ibscale.ge.4) then
         title='flag 5m/s'
      endif
      if(vert(1:1) == 'Z') then
         call plchlq (px2-.002,py2-.009,title(1:(len_trim(title))),-.5,0.,1.)
      else
         call plchlq (px2-.002,py1+.022,title(1:(len_trim(title))),-.5,0.,1.)
      endif
   
   endif
endif

return
end
!***************************************************************************

SUBROUTINE STRMLN_mrc2(Ux,Vx,U,V,WORK,IMAX,IPTSX,JPTSY,NSET,IER,vexag)
DIMENSION       Ux(IMAX+1,JPTSY+1)    ,Vx(IMAX+1,JPTSY+1)      ,  &
                U(IMAX,JPTSY)         ,V(IMAX,JPTSY)           ,  &
                WORK(1)
DIMENSION       WIND(4)               ,VIEW(4)
!
COMMON /STR01/  IS         ,IEND      ,JS        ,JEND  &
             ,  IEND1      ,JEND1     ,I         ,J  &
             ,  X          ,Y         ,DELX      ,DELY  &
             ,  ICYC1      ,IMSG1     ,IGFL1
COMMON /STR02/  EXT , SIDE , XLT , YBT
COMMON /STR03/  INITA , INITB , AROWL , ITERP , ITERC , IGFLG  &
             ,  IMSG , UVMSG , ICYC , DISPL , DISPC , CSTOP

SAVE

! fix to give a nii by njj array going into nii by njj (not nii+1 by njj+1)
do i=1,IMAX
  do j=1,JPTSY
      U(i,j)=Ux(i,j)
      V(i,j)=Vx(i,j)*vexag
   enddo
enddo

EXT       = 0.25
SIDE      = 0.90
XLT       = 0.05
YBT       = 0.05

!INITA     = 2
!INITB     = 2
AROWL     = 0.33
ITERP     = 35
ITERC     = -99
IGFLG     = 0
ICYC      = 0
IMSG      = 0
UVMSG     = 1.E+36
DISPL     = 0.33
DISPC     = 0.67
CSTOP     = 0.50


IER = 0

! LOAD THE COMMUNICATION COMMON BLOCK WITH PARAMETERS

IS = 1
IEND = IPTSX
JS = 1
JEND = JPTSY
IEND1 = IEND-1
JEND1 = JEND-1
IEND2 = IEND-2
JEND2 = JEND-2
XNX = FLOAT(IEND-IS+1)
XNY = FLOAT(JEND-JS+1)
ICYC1 = ICYC
IGFL1 = IGFLG
IMSG1 = 0

! IF ICYC .NE. 0 THEN CHECK TO MAKE SURE THE CYCLIC CONDITION EXISTS.

IF (ICYC1.NE.0) CALL CHKCYC  (U,V,IMAX,JPTSY,IER)

! Save original SET call.

CALL GETSET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),  &
             WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)

IF (NSET.lt.0) GOTO 10
IF (NSET.eq.0) GOTO 20
IF (NSET.gt.0) GOTO 60

10 X1 = VIEW(1)
X2 = VIEW(2)
Y1 = VIEW(3)
Y2 = VIEW(4)
X3 = IS
X4 = IEND
Y3 = JS
Y4 = JEND
GOTO  55

20 ITYPE = 1
X1 = XLT
X2 = (XLT+SIDE)
Y1 = YBT
Y2 = (YBT+SIDE)
X3 = IS
X4 = IEND
Y3 = JS
Y4 = JEND
IF (AMIN1(XNX,XNY)/AMAX1(XNX,XNY).LT.EXT) GO TO  50
IF (XNX.lt.XNY) GOTO 30
IF (XNX.eq.XNY) GOTO 50
IF (XNX.gt.XNY) GOTO 40
30 X2 = (SIDE*(XNX/XNY) + XLT)
GOTO  50
40 Y2 = (SIDE*(XNY/XNX) + YBT)
50 CONTINUE

! CENTER THE PLOT

DX = 0.25*( 1. - (X2-X1) )
DY = 0.25*( 1. - (Y2-Y1) )
X1 = (XLT+DX)
X2 = (X2+DX )
Y1 = (YBT+DY)
Y2 = (Y2+DY )

55 CONTINUE

! DEFINE AND SELECT NORMALIZATION TRANS, SET LOG SCALING

CALL SET(X1,X2,Y1,Y2,X3,X4,Y3,Y4,ITYPE)

IF (NSET.EQ.0) CALL PERIM (1,0,1,0)

60 CONTINUE

! DRAW THE STREAMLINES
! .   BREAK THE WORK ARRAY INTO TWO PARTS.  SEE DRWSTR FOR FURTHER
! .   COMMENTS ON THIS.


CALL DRWSTR (U,V,WORK(1),WORK(IMAX*JPTSY+1),IMAX,JPTSY)

! Restore SET call.

CALL SET (VIEW(1),VIEW(2),VIEW(3),VIEW(4),  &
          WIND(1),WIND(2),WIND(3),WIND(4),IOLLS)

RETURN
END
