subroutine wvector (xtplot,ytplot,uplt,vplt,dx  &
                   ,px1,px2,py1,py2,xmin,xmax,ymin,ymax  &
                   ,stemleng,headleng0,headleng,headang,velomax)

implicit none

real :: px1,px2,py1,py2,xmin,xmax,ymin,ymax,zmax
real :: xtplot,ytplot,dx,uplt,vplt 
real :: stemleng,headleng0,headleng,headang,velomax

integer :: ic,icmj,ib,ncn,ln
real :: varmax,varmin,adiff,stemfac,hsize1,hsize2,hsize,angstem  &
       ,dxh1,dyh1,dxh2,dyh2,x1,x2,x3,x4,y1,y2,y3,y4,box5,angh,velmax  &
       ,xa,xz,ya,z,val,vexag  &
       ,oplt,vt,vvt,ut,uut,aplt,scalefach,vel  &
       ,yz,xstart,ystart,yinc,dir,spd,sz,step,sszz,voff


!print*,'start wvector',stemleng,headleng0,headleng,headang,velomax,dx
!print*,'start wvector',px1,px2,py1,py2,xmin,xmax,ymin,ymax
!print*,'start wvector',xtplot,ytplot,uplt,vplt,dx


call set (px1,px2,py1,py2,px1,px2,py1,py2,1)


! Compute head angle in radians.  Find maximum velocity in field.
angh=headang*3.14159/180.
velmax=velomax

! ut and vt are velocity components averaged to T points.  vel is velocity
! magnitude at T points.  hsize is the vector head length.  angstem is
! the plot angle of the vector stem.
   
vt=vplt
ut=uplt
vel=sqrt(ut**2+vt**2)

oplt=py1+(py2-py1)*(ytplot-ymin)/(ymax - ymin)
aplt=px1+(px2-px1)*(xtplot-xmin)/(xmax - xmin)


! Compute size factor for vector stem, and min and max vector head lengths

adiff=(px2-px1)*dx/(xmax-xmin)
stemfac=stemleng*adiff/velmax
hsize1=headleng0*adiff
hsize2=headleng*adiff
hsize=hsize1+(hsize2-hsize1)*vel/velmax
angstem=atan2(vt,ut)

! Compute the x and y displacements of the vector head line segments

dxh1=hsize*cos(angstem+angh)
dyh1=hsize*sin(angstem+angh)
dxh2=hsize*cos(angstem-angh)
dyh2=hsize*sin(angstem-angh)

! Find plot coordinates of the 4 endpoints of the vector parts

! Head at specified location
!x1=aplt
!x2=aplt-ut*stemfac
!x3=aplt-dxh1
!x4=aplt-dxh2
!y1=oplt
!y2=oplt-vt*stemfac
!y3=oplt-dyh1
!y4=oplt-dyh2

! Tail at specified location
x1=aplt
x2=aplt+ut*stemfac
x3=x2-dxh1
x4=x2-dxh2
y1=oplt
y2=oplt+vt*stemfac
y3=y2-dyh1
y4=y2-dyh2

!  If any part of the vector head is out of bounds, skip drawing the
!  vector..., or tail
! MAY WANT TO BRING BACK FORMER CLIPPING CODE BECAUSE SET CALL ABOVE
! IS NOT CLIPPING

xa=min(x1,x3,x4,x2)
xz=max(x1,x3,x4,x2)
ya=min(y1,y3,y4,y2)
yz=max(y1,y3,y4,y2)

if(xa.lt.px1.or.xz.gt.px2.or.ya.lt.py1.or.yz.gt.py2) return


! Draw the vector

! Head at specified location
!call frstpt(x1,y1)
!call vector(x2,y2)
!call frstpt(x3,y3)
!call vector(x1,y1)
!call vector(x4,y4)

! Tail at specified location
call frstpt(x1,y1)
call vector(x2,y2)
call frstpt(x3,y3)
call vector(x2,y2)
call vector(x4,y4)


return
end
